
	**************************************************
	*						 *
	*	       2.11 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.11.1


NEW FEATURES

    o	R CMD INSTALL checks if dependent packages are available early on
	in the installation of source packages, thereby giving clearer
	error messages.

    o	R CMD INSTALL --build now names the file in the format used
	for Mac OS X binary files on that platform.

    o	BIC() in package stats4 now also works with multiple fitted models,
	analogously to AIC().


DEPRECATED & DEFUNCT

    o	Use of file extension .C for C++ code in packages is now
	deprecated: it has caused problems for some 'make's on
	case-insensitive file systems (although it currently works
	with the recommended toolkits).


INSTALLATION

    o	Command 'gnutar' is preferred to 'tar' when configure sets
	TAR.  This is needed on Mac OS 10.6, where the default tar,
	bsdtar 2.6.2, has been reported to produce archives with
	illegal extensions to tar (according to the POSIX standard).


BUG FIXES

    o	The C function mkCharLenCE now no longer reads past 'len' bytes
	(unlikely to be a problem except in user code). (PR#14246)

    o	On systems without any default LD_LIBRARY_PATH (not even
	/usr/local/lib), [DY]LIB_LIBRARY_PATH is now set without a
	trailing colon.	 (PR#13637)

    o	More efficient utf8ToInt() on long multi-byte strings with
	many multi-byte characters.  (PR#14262)

    o	aggregate.ts() gave platform-depedent results due to rounding
	error for ndeltat != 1.

    o 	package.skeleton() sometimes failed to fix filenames for .R or
    	.Rd files to start with an alphanumeric.  (PR#14253)
	It also failed when only an S4 class without any methods was
	defined.  (PR#14280)

    o	splinefun(*, method = "monoH.FC")  was not quite monotone in rare
	cases.	(PR#14215)

    o	Rhttpd no longer crashes due to SIGPIPE when the client closes
	the connection prematurely.  (PR#14266)

    o	format.POSIXlt() could cause a stack overflow and crash when used on
    	very long vectors.  (PR#14267)

    o	Rd2latex() incorrectly escaped special characters in \usage sections.

    o	mcnemar.test() could alter the levels (dropping unused levels)
	if passed 'x' and 'y' as factors (reported by Greg Snow).

    o	Rd2pdf sometimes needed a further pdflatex pass to get
	hyperlinked pages correct.

    o	interaction() produced malformed results when levels were
    	duplicated, causing segfaults in split().

    o	cut(d, breaks = <n>)  now also works for "Date" or "POSIXt"
        argument d.  (PR#14288)

    o	memDecompress() could decompress incompletely rare xz-compressed
	input due to incorrect documentation of xz utils.  (Report
	and patch from Olaf Mersmann.)

    o	The S4 initialize() methods for "matrix", "array", and "ts" have
 	been fixed to call validObject(). (PR#14284)

    o	R CMD INSTALL now behaves the same way with or without
	--no-multiarch on platforms with only one installed
	architecture.  (It used to clean the src directory without
	--no-multiarch.)

    o	[<-.data.frame was not quite careful enough in assigning (and
        potentially deleting) columns right-to-left. (PR#14263)

    o	rbeta(n, a,b) no longer occasionally returns NaN for a >> 1 > b.
	(PR#14291)

    o	pnorm(x, log.p = TRUE) could return NaN not -Inf for x near
	(minus for lower.tail=TRUE) the largest representable number.

    o	Compressed data files *.(txt|tab|csv).(gz|bz2|xz) were not
	recognized for the list of data topics and hence for packages
	using LazyData.  (PR#14273)

    o	textConnection() did an unnecessary translation on strings in
	a foreign encoding (e.g. UTF-8 strings on Windows) and so was
	slower than it could have been on very long input strings.
	(PR#14286)
	
    o	tools::Rd2txt() did not render poorly written Rd files
	consistently with other renderers.

    o	na.action() did not extract the 'na.action' component as
	documented.




		CHANGES IN R VERSION 2.11.0


SIGNIFICANT USER-VISIBLE CHANGES

    o	Packages must have been installed under R >= 2.10.0, as the
	current help system is the only one now supported.

    o	A port to 64-bit Windows is now available as well as binary
	package repositiories: see the 'R Administration and
	Installation Manual'.

    o	Argument matching for primitive functions is now done in the
	same way as for interpreted functions except for the deliberate
	exceptions

	    call switch .C .Fortran .Call .External

	all of which use positional matching for their first argument,
	and also some internal-use-only primitives.

    o	The default device for command-line R at the console on Mac OS X
	is now quartz() and not X11().


NEW FEATURES

    o	The 'open' modes for connections are now interpreted more
	consistently.  open = "r" is now equivalent to open = "rt" for
	all connections.  The default open = "" now means "rt" for all
	connections except the compressed file connections gzfile(),
	bzfile() and xzfile() for which it means "rb".

    o	R CMD INSTALL now uses the internal untar() in package utils:
	this ensures that all platforms can install bzip2- and
	xz-compressed tarballs.	 In case this causes problems (as it
	has on some Windows file systems when run from Cygwin tools)
	it can be overridden by the environment variable
	R_INSTALL_TAR: setting this to a modern external tar program
	will speed up unpacking of large (tens of Mb or more)
	tarballs.

    o	help(try.all.packages = TRUE) is much faster (although the
	time taken by the OS to find all the packages the first time
	it is used can dominate the time).

    o	R CMD check has a new option '--timings' to record
	per-example timings in file <pkg>.Rcheck/<pkg>-Ex.timings.

    o	The TRE library has been updated to version 0.8.0 (minor bugfixes).

    o	grep[l], [g]sub and [g]regexpr now work in bytes in an 8-bit
	locales if there is no marked UTF-8 input string: this will be
	somewhat faster, and for [g]sub() give the result in the
	native encoding rather than in UTF-8 (which returns to the
	behaviour prior to R 2.10.0).

    o	A new argument 'skipCalls' has been added to browser() so that
	it can report the original context when called by other
	debugging functions.

    o	More validity checking of UTF-8 and MBCS strings is done by
	agrep() and the regular-expression matching functions.

    o	The undocumented restriction on gregexpr() to length(text) > 0
	has been removed.

    o	Package tcltk now sends strings to Tcl in UTF-8: this means
	that strings with a marked UTF-8 encoding are supported in
	non-UTF-8 locales.

    o	The graphics engine now supports rendering of raster (bitmap)
	images, though not all graphics devices can provide (full)
	support.  Packages providing graphics devices (e.g., Cairo,
	RSvgDevice, cairoDevice) will need to be reinstalled.

	There is also support in the graphics engine for capturing
	raster images from graphics devices (again not supported
	on all graphics devices).

    o	R CMD check now also checks if the package and namespace can
	be unloaded: this provides a check of the .Last.lib() and
	.onUnload() hook functions (unless --install=fake).

    o	prop.table(x) now accepts a one-dimensional table for x.

    o	A new function vapply() has been added, based on a suggestion
	from Bill Dunlap.  It requires that a template for the
	function value be specified, and uses it to determine the
	output type and to check for consistency in the function
	values.

    o	The main HTML help page now links to a reformatted copy of
	this NEWS file. (Suggested by Henrik Bengtsson.)  Package
	index files link to the package DESCRIPTION and NEWS files and
	a list of demos when using dynamic help.

    o	The [ method for class "AsIs" allows the next method to change
	the underlying class.  (Wish of Jens Oehlschlägel.)

    o	write.csv[2] no longer allow 'append' to be changed: as ever,
	direct calls to write.table() give more flexibility as well as
	more room for error.

    o	The index page for HTML help for a package now collapses
	multiple signatures for S4 methods into a single entry.

    o	The use of '.required' by require() and detach() has been
	replaced by '.Depends' which is set from the 'Depends' field
	of a package (even in packages with name spaces).  By default
	detach() prevents such dependencies from being detached: this
	can be overridden by the argument 'force'.

    o	bquote() has been extended to work on function definitions
	(wish of PR#14031).

    o	detach() when applied to an object other than a package
	returns the environment that has been detached, to parallel
	attach().

    o	readline() in non-interactive use returns "" and does not
	attempt to read from the 'terminal'.

    o	New function file_ext() in package 'tools'.

    o	xtfrm() is now primitive and internally generic, as this allows
	S4 methods to be set on it without name-space scoping issues.

	There are now "AsIs" and "difftime" methods, and the default
	method uses unclass(x) if is.numeric(x) is true (which will be
	faster but relies on is.numeric() having been set correctly
	for the class).

    o	is.numeric(x) is now false for a "difftime" object
	(multiplication and division make no sense for such objects).

    o	The default method of weighted.mean(x, w) coerces 'w' to be
	numeric (aka double); previously only integer weights were
	coerced.  Zero weights are handled specially so an infinite
	value with zero weight does not force an NaN result.

	There is now a "difftime" method.

    o	bug.report() now has 'package' and 'lib.loc' arguments to
	generate bug reports about packages.  When this is used, it
	looks for a BugReports field in the package DESCRIPTION file,
	which will be assumed to be a URL at which to submit the
	report, and otherwise generates an email to the package
	maintainer.  (Suggested by Barry Rowlingson.)

    o	quantile() now has a method for the date-time class "POSIXt",
	and types 1 and 3 (which never interpolate) work for Dates and
	ordered factors.

    o	length(<POSIXlt>)  now returns the length of the corresponding
	abstract timedate-vector rather than always 9 (the length of the
	underlying list structure).  (Wish of PR#14073 and PR#10507.)

    o	The readline completion backend no longer sorts possible
	completions alphabetically (e.g., function argument names) if
	R was built with readline >= 6.

    o	select.list() gains a 'graphics' argument to allow Windows/Mac
	users to choose the text interface.  This changes the
	behaviour of new.packages(ask=TRUE) to be like
	update.packages(ask=TRUE) on those platforms in using a text
	menu: use ask="graphics" for a graphical menu.

    o	New function chooseBioCmirror() to set the "BioC_mirror" option.

    o	The R grammar prevents using the argument 'name' in signatures
	of S4 methods for '$' and '$<-', since they will always be
	called with a character string value for 'name'.  The implicit
	S4 generic functions have been changed to reflect this:
	packages which included 'name' in the signature of their
	methods need to be updated and re-installed.

    o	The handling of the 'method' argument of glm() has been
	refined following suggestions by Ioannis Kosmidis and Heather
	Turner.

    o	str() gains a new argument 'list.len' with default 99, limiting the
	number of list() items (per level), thanks to suggestions from
	David Winsenius.

    o	Having formal arguments of an S4 method in a different order
	from the generic is now an error (the warning having been
	ignored by some package maintainers for a long time).

    o	New functions enc2native() and enc2utf8() convert character
	vectors with possibly marked encodings to the current locale and
	UTF-8 respectively.

    o	Unrecognized escapes and embedded nuls in character strings are
	now an error, not just a warning.  Thus option "warnEscapes"
	is no longer needed.  rawToChar() now removes trailing nuls
	silently, but other embedded nuls become errors.

    o	Informational messages about masked objects displayed when a
	package is attached are now more compact, using strwrap()
	instead of one object per line.

    o	print.rle() gains argument 'prefix'.

    o	download.file() gains a "curl" method, mainly for use on
	platforms which have 'curl' but not 'wget', but also for some
	hard-to-access URLs.

    o	In Rd, \eqn and \deqn will render in HTML (and convert to text)
	upper- and lower-case Greek letters (entered as \alpha ...),
	\ldots, \dots, \ge and \le.

    o	utf8ToInt() and intToUtf8() now map NA inputs to NA outputs.

    o	file() has a new argument 'raw' which may help if it is used
	with something other than a regular file, e.g. a character device.

    o	New function strtoi(), a wrapper for the C function strtol.

    o	as.octmode() and as.hexmode() now allow inputs of length other
	than one.

	The format() and print() methods for "octmode" now preserve
	names and dimensions (as those for "hexmode" did).

	The format() methods for classes "octmode" and "hexmode" gain
	a 'width' argument.

    o	seq.int() returns an integer result in some further cases
	where seq() does, e.g. seq.int(1L, 9L, by = 2L).

    o	Added \subsection{}{} macro to Rd syntax, for subsections
	within sections.

    o	n-dimensional arrays with dimension names can now be indexed
	by an n-column character matrix. The indices are matched
	against the dimension names.  NA indices are propagated to the
	result.	 Unmatched values and "" are not allowed and result in
	an error.

    o	interaction(drop=TRUE) uses less memory (related to PR#14121).

    o	summary() methods have been added to the "srcref" and
	"srcfile" classes, and various encoding issues have been
	cleaned up.

    o	If option "checkPackageLicense" is set to TRUE (not currently
	the default), users will be asked to agree to
	non-known-to-be-FOSS package licences at first use.

    o	Checking setAs(a,b) methods only gives a message instead of a
	warning, when one of a or b is unknown.

    o	New function norm() to compute a matrix norm.
	norm() and also backsolve() and sample() have implicit S4 generics.

    o	Renviron.site and Rprofile.site can have architecture-specific
	versions on systems with sub-architectures.

    o	R CMD check now (by default) also checks Rd files for
	auto-generated content in need of editing, and missing argument
	descriptions.

    o	aggregate() gains a formula method thanks to a contribution by
	Arni Magnusson.	 The data frame method now allows summary
	functions to return arbitrarily many values.

    o	path.expand() now propagates NA values rather than converting them
	to "NA".

    o	file.show() now disallows NA values for file names, headers, and
	pager.

    o	The 'fuzz' used by seq() and seq.int() has been reduced from
	1e-7 to 1e-10, which should be ample for the double-precision
	calculations used in R.	 It ensures that the fuzz never comes
	into play with sequences of integers (wish of PR#14169).

    o	The default value of RSiteSearch(restrict=) has been changed
	to include vignettes but to exclude R-help.  The R-help
	archives available have been split, with a new option of
	"Rhelp10" for those from 2010.

    o	New function rasterImage() in the 'graphics' package for drawing
	raster images.

    o	stats:::extractAIC.coxph() now omits aliased terms when computing
	the degrees of freedom (suggestion of Terry Therneau).

    o	cor() and cov() now test for misuse with non-numeric
	arguments, such as the non-bug report PR#14207.

    o	pchisq(ncp =, log.p = TRUE) is more accurate for probabilities
	near one.  E.g. pchisq(80, 4, ncp=1, log.p=TRUE).  (Maybe what
	was meant in PR#14216.)

    o	maintainer() has been added, to give convenient access to the
	name of the maintainer of a package (contributed by David
	Scott).

    o	sample() and sample.int() allow zero items to be sampled from
	a zero-length input.  sample.int() gains a default value
	'size=n' to be more similar to sample().

    o	switch() returned NULL on error (not previously documented on
	the help page): it now does so invisibly, analogously to
	if-without-else.

	It is now primitive: this means that EXPR is always matched to
	the first argument and there is no danger of partial matching
	to later named arguments.

    o	Primitive functions UseMethod(), attr(), attr<-(), on.exit(),
	retracemem() and substitute() now use standard argument
	matching (rather than positional matching).  This means that
	all multi-argument primitives which are not internal now use
	standard argument matching except where positional matching is
	desirable (as for switch(), call(), .C() ...).

    o	All the one-argument primitives now check that any name
	supplied for their first argument is a partial match to the
	argument name as documented on the help page: this also
	applies to replacement functions of two arguments.

    o	base::which() uses a new .Internal function when arr.ind is
	FALSE resulting in a 10x speedup.  Thanks to Patrick Aboyoun
	for implementation suggestions.

    o	Help conversion to text now uses the first part of \enc{}{}
	markup if it is representable in the current output encoding.
	On the other hand, conversion to LaTeX with the default
	outputEncoding = "ASCII" uses the second part.

    o	A new class "listOfMethods" has been introduced to represent
	the methods in a methods table, to replace the deprecated
	class "MethodsList".

    o	any() and all() return early if possible.  This may speed up
	operations on long vectors.

    o	strptime() now accepts "%z" (for the offset from UTC in the
	RFC822 format of +/-hhmm).

    o	The PCRE library has been updated to version 8.02, a bug-fix
	release which also updates tables to Unicode 5.02.

    o	Functions which may use a graphical select.list() (including
	menu() and install.packages()) now check on a Unix-alike that
	Tk can be started (and not just
	capabilities("tcltk") && capabilities("X11")).

    o	The parser no longer marks strings containing octal or hex
	escapes as being in UTF-8 when entered in a UTF-8 locale.

    o	On platforms with cairo but not Pango (notably Mac OS X) the
	initial default X11() type is set to "Xlib": this avoids
	several problems with font selection when done by cairo rather
	than Pango (at least on Mac OS X).

    o	New arrayInd() such that which(x, arr.ind = TRUE) for an array
	'x' is now equivalent to arrayInd(which(x), dim(x), dimnames(x)).


DEPRECATED & DEFUNCT

    o	Bundles of packages are defunct.

    o	stats::clearNames() is defunct: use unname().

    o	Basic regular expressions are defunct, and strsplit(), grep(),
	grepl(), sub(), gsub(), regexpr() and gregexpr() no longer
	have an 'extended' argument.

    o	methods::trySilent() is defunct.

    o	index.search() (which was deprecated in 2.10.0) is no longer
	exported and has a different argument list.

    o	Use of multiple arguments to return() is now defunct.

    o	The use of UseMethod() with more than two arguments is now defunct.

    o	In the 'methods' package, the MethodsList metadata objects which
	had been superseded by hash tables (environments) since R
	2.8.0 are being phased out.  Objects of this class are no
	longer assigned or used as metadata by the package.

	getMethods() is now deprecated, with its internal use replaced
	by findMethods() and other changes.  Creating objects from the
	MethodsList class is also deprecated.

    o	Parsing strings containing both octal/hex and Unicode escapes
	now gives a warning and will become an error in R 2.12.0.


INSTALLATION

    o	UTF-8 is now used for the reference manual and package
	manuals.  This requires LaTeX '2005/12/01' or later.

    o	configure looks for a POSIX compliant tr, Solaris's
	/usr/ucb/tr having been found to cause Rdiff to malfunction.

    o	configure is now generated with autoconf-2.65, which works
	better on recent systems and on Mac OS X.


PACKAGE INSTALLATION

    o	Characters in R source which are not translatable to the
	current locale are now handled more tolerantly:	 these will be
	converted to hex codes with a warning.	Such characters are
	only really portable if they appear in comments.

    o	R CMD INSTALL now tests that the installed package can be loaded
	(and backs out the installation if it cannot): this can be
	suppressed by --no-test-load.  This avoids installing/updating
	a package that cannot be used: common causes of failures to
	load are missing/incompatible external software and
	missing/broken dependent packages.

    o	Package installation on Windows for a package with a src
	directory now checks if a DLL is created unless there is a
	src/Makefile.win file: this helps catch broken installations
	where the toolchain has not reported problems in building the DLL.
	(Note: this can be any DLL, not just one named <pkg-name>.dll.)


BUG FIXES

    o	Using with(), eval() etc with a list with some unnamed
	elements now works. (PR#14035)

    o	The "quick" dispatch of S4 methods for primitive functions was
	not happening, forcing a search each time.  (Dispatch for
	closures was not affected.)  A side effect is that default
	values for arguments in a method that do not have defaults in
	the generic will now be ignored.

    o	Trying to dispatch S4 methods for primitives during the search
	for inherited methods slows that search down and potentially
	could cause an infinite recursion.  An internal switch was
	added to turn off all such methods from
	findInheritedMethods().

    o	R framework installation (on Mac OS X) would not work properly
	if a rogue Resources directory was present at the top level.
	Such a non-symlink will now be renamed to Resources.old (and
	anything previously named Resources.old removed) as part of
	the framework installation process.

    o	The checks for conforming S4 method arguments could fail when
	the signature of the generic function omitted some of the
	formal arguments (in addition to ...).	Arguments omitted from
	the method definition but conforming (per the documentation)
	should now be ignored (treated as "ANY") in dispatching.

    o	The computations for S4 method evaluation when '...' was in the
	signature could fail, treating '...' as an ordinary symbol.
	This has been fixed, for the known cases.

    o	Various ar() fitting methods have more protection for singular
	fits.

    o	callNextMethod now works again with the drop= argument in `[`

    o	parse() and parse_Rd() miscounted columns when multibyte UTF-8
	characters were present.

    o	Formatting of help pages has had minor improvements: extra
	blank lines have been removed from the text format, and empty
	package labels removed from HTML.

    o	cor(A, B) where A has n x 1 and B a 1-dimensional array
	segfaulted or gave an internal error.
	(The case cor(B, A) was PR#7116.)

    o	cut.POSIXt() applied to a start value after the DST transition
	on a DST-change day could give the wrong time for 'breaks' in units
	of days or longer.  (PR#14208)

    o	do_par() UNPROTECTed too early (PR#14214)

    o	subassignment x[[....]] <- y didn't check for a zero-length
	right hand side, and inserted rubbish value. (PR#14217)

    o	fisher.test() no longer gives a P-value *very* slightly > 1,
	in some borderline cases.

    o	Internal function matchArgs no longer modifies the general
	purpose bits of the SEXPs that make up the formals list of R
	functions.  This fixes an invalid error message that would
	occur when a garbage collection triggered a second call to
	matchArgs for the same function via a finalizer.

    o	gsub() in 2.10.x could fail from stack overflow for extremely
	long strings due to temporary data being allocated on the
	stack.	Also, gsub() with fixed=TRUE is in some circumstances
	considerably faster.

    o	Several primitives, including attributes(), attr<-()
	interactive(), nargs() and proc.time(), did not check that
	they were called with the correct number of arguments.

    o	A potential race condition in list.files() when other processes
	are operating on the directory has been fixed; the code now
	dynamically allocates memory for file listings in a single
	pass instead of making an initial count pass.

    o	mean(x, trim=, na.rm = FALSE) failed to return NA if 'x'
	contained missing values.  (Reported by Bill Dunlap.)

    o	Extreme tail behavior of, pbeta() {and hence pf()}, e.g.,
	pbeta(x, 3, 2200, lower.tail=FALSE, log.p=TRUE) now returns
	finite values instead of jumping to -Inf too early (PR#14230).

    o	parse(text=x) misbehaved for objects 'x' that were not coerced
	internally to character, notably symbols.  (Reported to
	R-devel by Bill Dunlap.)

    o	The internal C function 'coerceSymbol' now handles coercion to
	character, and warns if coercion fails (rather than silently
	returning NULL).  This allows a name to be given where a
	character vector is required in functions which coerce
	internally.

    o	The interpretation by strptime() of %c was non-standard (not
	that it is ever advisable to use locale- and system-specific
	input formats).

    o	capabilities("X11") now works the same way on Mac OS X as on
	other platforms (and as documented: it was always true for R
	built with --with-aqua, as the CRAN builds are).

    o	The X11() device with cairo but not Pango (notably Mac OS X)
	now checks validity of text strings in UTF-8 locales (since
	Pango does but cairo it seems does not).

    o	read.fwf() misread multi-line records when n was specified.
	(PR#14241)

    o	all.equal(*, tolerance = e) passes the numeric tolerance also to
	the comparison of the attributes.

    o	pgamma(0,0), a boundary case, now returns 0, its limit from the
	left, rather than the limit from the right.

    o	Issuing POST requests to the internal web server could stall
	the request under certain circumstances.

    o	gzcon( <textConnection> ), an error, no longer damages the
	connection (in a way to have it seg.fault). (PR#14237)

    o	All the results from hist() now use the nominal 'breaks' not
	those adjusted by the numeric 'fuzz": in recent versions the
	nominal 'breaks' were reported but the 'density' referred to
	the intervals used in the calculation -- which mattered very
	slightly for one of the extreme bins.  (Based on a report by
	Martin Becker.)

    o	If xy[z].coords (used internally by many graphics functions) are
	given a list as 'x', they now check that the list has suitable
	names and give a more informative error message.  (PR#13936)




	**************************************************
	*						 *
	*	       2.10 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.10.1 patched


NEW FEATURES

    o	The handling of line textures in the postscript() and pdf()
	devices was set up for round end caps (the only type which
	existed at the time): it has now been adjusted for butt endcaps.

    o	lchoose(a,k) is now defined as	log(abs(choose(a,k))), analogously
	to lfactorial().

    o	Although \eqn{} in Rd files is defined as a 'verbatim' macro,
	many packages expected \dots and \ldots to be interpreted
	there (as was the case in R < 2.10.0), so this is now done
	(using an ellipsis in HTML rendering).

    o	Escaping of braces in quoted strings in R-code sections of Rd
	files is allowed again.	 This had been changed for the new Rd
	format in R 2.10.0 but was only documented on the developer
	site and was handled inconsistently by the converters: text
	and example conversion removed the escapes but HTML conversion
	did not.

    o	The PCRE library has been updated to version 8.01, a bug-fix
	release.

    o	tools::readNEWS() now accepts a digit as the first character
	of a news section.


BUG FIXES

    o	Using read.table(header=TRUE) on a header with an embedded new
	line would copy part of the header into the data.  (PR#14103)

    o	qpois(p = 1, lambda = 0) now gives 0 as for all other p.  (PR#14135)

    o	Functions related to string comparison (e.g. unique(), match())
	could cause crashes when used with strings not in the native
	encoding, e.g. UTF-8 strings on Windows.
	(PR#14114 and PR#14125)

    o	x[ , drop=TRUE] dropped an NA level even if it was in use.

    o	The dynamic HTML help system reported the wrong MIME type for the
	style sheet.

    o	tools::codoc() (used by R CMD check) was missing cases where the
	function had no arguments but was documented to have some.

    o	Help links containing special characters (e.g. "?") were not
	generated correctly when rendered in HTML. (PR#14155)

    o	lchoose(a,k) no longer wrongly gives NaN for negative a.

    o	ks.test() could give a p-value that was off by one observation
	due to rounding error.	(PR#14145)

    o	readBin()/readChar() when reading millions of character strings
	in a single call used excessive amounts of memory (which also
	slowed them down).

    o	R CMD SHLIB could fail if used with paths that were not
	alphanumeric, e.g. contained '+'.  (PR#14168)

    o	sprintf() was not re-entrant, which potentially caused problems
	if an as.character() method called it.

    o	The quartz() device did not restore the clipping region when
	filling the background for a new page.	This could be observed
	in multi-page bitmap output as stale outer regions of the
	plot.

    o	p.adjust(*, method, n) now works correctly for the rare case
	n > length(p), also when method differs from "bonferroni" or
	"none", thanks to a patch from Gordon Smyth.

    o	tools::showNonASCII() failed to detect non-ASCII characters
	if iconv() (incorrectly) converted them to different ASCII
	characters.  (Seen on Windows only.)

    o	tcrossprod() wrongly failed in some cases when one of the
	arguments was a vector and the other a matrix.

    o	[cr]bind(..., deparse.level=2) was not always giving names
	when documented to do so.  (Discovered whilst investigating
	PR#14189.)

    o	match(incomparables=<non-NULL>) could in rare cases infinite-
	loop.

    o	poisson.test() needed to pass 'conf.level' to binom.test()
	(PR#14195)

    o	The "nls" method for df.residual() gave incorrect results for
	models fitted with na.action = na.exclude.  (PR#14194)

    o	A change to options(scipen=) was only implemented when printing
	next occurred, even though it should have affected intervening
	calls to axis(), contour() and filledcontour().

    o	prettyNum(drop0trailing=TRUE) did not handle signs of imaginary
	parts of complex numbers correctly (and this was used by str():
	PR#14201).

    o	system.time() had sys.child component wrong (copied user.child
	instead) on systems with HAVE_GETRUSAGE (PR#14210)

    o	Changing both line texture and line cap (end) resulted in the
	latter to be ommitted form the PDF code.  In addition, line cap
	(end) and join are now set explicitly in PDF output to ensure
	correct defaults.

    o	The suppression of auto-rotation in bitmap() and dev2bitmap()
	with the 'pdfwrite' device was not working correctly.

    o	plot(ecdf(), log="x") no longer gives an incorrect warning.

    o	read.fwf() works again when 'file' is a connection.

    o	Startup files will now be found if their paths exceed 255 bytes.
	(PR#14228)

    o	contrasts<- (in the 'stats' package) no longer has an
	undeclared dependence on 'methods' (introduced in 2.10.0).



		CHANGES IN R VERSION 2.10.1


NEW FEATURES

    o	The PCRE library has been updated to version 8.00.

    o	R CMD INSTALL has new options --no-R, --no-libs, --no-data,
	--no-help, --no-demo, --no-exec, and --no-inst to suppress
	installation of the specified part of the package.  These are
	intended for special purposes (e.g. building a database
	of help pages without fully installing all packages).

    o	The documented line-length limit of 4095 bytes when reading
	from the console now also applies also to parse(file="")
	(which previously had a limit of around 1024 bytes).

    o	A Bioconductor mirror can be set for use by setRepositories()
	via the option "BioC_mirror", e.g. the European mirror can be
	selected by
	options(BioC_mirror="http://bioconductor.statistik.tu-dortmund.de")

    o	Double-clicking in a tk_select.list() list box now selects the
	item and closes the list box (as happens on the Windows
	select.list() widget).


INSTALLATION

    o	configure will be able to find a usable libtiff in some rare
	circumstances where it did not previously (where libtiff
	needed to be linked explicitly against -ljpeg).

    o	Making refman.pdf works around a problem with the indexing
	with hyperref 6.79d and later.


DEPRECATED & DEFUNCT

    o	The 'extended' argument is deprecated in strsplit(), grep(),
	grepl(), sub(), gsub(), regexpr() and gregexpr() (not just the
	value extended = FALSE) and will be removed in R 2.11.0.


BUG FIXES

    o	trigamma(x) and other psigamma(x, n) calls are now accurate for
	very large abs(x). (PR#14020)

    o	[g]sub(perl=FALSE, fixed=FALSE) could use excessive stack space
	when used with a very long vector containing some non-ASCII
	strings.

    o	The default method of weighted.mean(na.rm = TRUE) did not omit
	weights for NA observations in 2.10.0.	(PR#14032)

    o	[g]regexpr(pattern, fixed = TRUE) returned match positions in
	bytes (not characters) in an MBCS locale if 'pattern' was a
	single byte.

	[g]sub(fixed = TRUE) with a single-byte pattern could
	conceivably have matched part of a multibyte character in a
	non-UTF-8 MBCS.

    o	findLineNum() and setBreakpoint() would sometimes fail if the
	specified file was not in the current directory.

    o	Package tcltk's demo(tkdensity) was broken in 2.9.0 when demo()
	was changed to set par(ask = TRUE).

    o	gsub() with backrefs could fail on extremely long strings
	(hundreds of thousands of characters) due to integer overflow
	in a length calculation.

    o	abline(*, untf=TRUE) now uses a better x-grid in log-scale, e.g.,
	for plot(c(1,300), c(1,300), log="xy") ; abline(4,1, untf=TRUE).

    o	detach/unloadNamespace() arrange to flush the package's
	lazyload cache of R objects once the package/namespace is no
	longer needed.

    o	There have been small fixes to the rendering of help,
	e.g. \command is now rendered verbatim (so e.g. -- is not
	interpreted, PR#14045).

	Also, there are many small changes to help files where the new
	converters were not rendering them in the same way as before.

    o	available.packages() would fail when run on a repository
	with no packages meeting the filtering conditions. (PR#14042)

    o	rep(x, times, each = 2) gave invalid results when the 'times'
	argument is a vector longer than 'x'.  Reported by Bill Dunlap.

    o	An error when unloadNamespace() attempted to run the .onUnload()
	function gave an error in the reporting function and so was
	not reported properly.

    o	Text help rendering did not handle very long input lines
	properly.

    o	promptMethods() generated signature documentation improperly.

    o	pgamma(x, a, lower.tail=FALSE) and qgamma(..) are now
	considerably more accurate in some regions for very small 'a'.
	qgamma() now correctly returns 0 instead of NaN in similar
	extreme cases, and qgamma() no longer warns in the case of
	small 'a', see (PR#12324).

    o	unname() now also removes names from a zero length vector.

    o	Printing results from ls.str() no longer evaluates unevaluated
	calls.

    o	complete.cases() failed on a 0-column data frame argument.
	(Underlies PR#14066.)

	It could return nonsensical results if no input determined the
	number of cases (seen in the no-segfault tests).

    o	An error in nls() with a long formula could cause a segfault.
	(PR#14059)

    o	qchisq(p, df, ncp, lower.tail = FALSE) with ncp >= 80 was
	inaccurate for small p (as the help page said): it is now
	less inaccurate. (In part, PR#13999.)

	For ncp less than but close to 80, pchisq() and qchisq() are
	more accurate for probablilities very close to 1 (a series
	expansion was truncated slightly too early).

	pchisq(x, df, ncp) can no longer return values just larger
	than one for large values of ncp.

    o	intToUtf8() could fail when asked to produce 10Mb or more
	strings, something it was never intended to do: unfortunately
	Windows crashed R (other OSes reported a lack of resources).
	(PR#14068)

    o	chisq.test() could fail when given argument 'x' or 'y' which
	deparsed to more than one line.	 (Reported by Laurent Gauthier.)

    o	S4 methods are uncached whenever the name space containing
	them is unloaded (by unloadNamespace() as well as by
	detach(unload = TRUE)).

    o	The internal record-keeping by dyn.load/dyn.unload was
	incomplete, which could crash R if a DLL that registered
	.External routines had earlier been unloaded.

    o	bessel[JY](x, nu) with nu a negative integer (a singular case)
	is now correct, analogously to besselI(), see PR#13556, below.

    o	tools::file_path_as_absolute() doubled the file separator when
	applied to a file such as "/vmunix" or (on Windows) "d:/afile"
	in a directory for which getwd() would return a path with a
	trailing separator (largely cosmetic, as reasonable file
	systems handle such a path correctly).	(Perhaps what was
	meant by PR#14078.)

    o	unsplit(drop = TRUE) applied to a data frame failed to pass
	'drop' to the computation of row names. (PR#14084)

    o	The "difftime" method of mean() ignored its 'na.rm' argument.

    o	tcltk::tk_select.list() is now more likely to remove the
	widget immediately after selection is complete.

    o	Adding/subtracting a "difftime" object to/from a "POSIXt" or
	"Date" object works again (it was broken by the addition of
	Ops.difftime).

    o	Conversion to latex of an Rd file with no aliases failed.

    o	wilcox.test(*, conf.int=TRUE) has achieved.level corrected and, for
	exact=FALSE, now gives an 'estimate' which does not depend on the
	alternative used.

    o	help.search() failed when the package argument was specified.
	(PR#14113)

    o	switch(EXPR = "A")  now returns NULL, as switch(1) {which used to
	signal an error}.



		CHANGES IN R VERSION 2.10.0


SIGNIFICANT USER-VISIBLE CHANGES

    o	Package help is now converted from Rd by the R-based converters
	that were first introduced in 2.9.0.  This means

	- Packages that were installed by R-devel after 2009-08-09
	  should not be used with earlier versions of R, and most
	  aspects of package help (including the runnable examples)
	  will be missing if they are so used.

	- Text, HTML and latex help and examples for packages
	  installed under the new system are converted on-demand from
	  stored parsed Rd files.  (Conversions stored in packages
	  installed under R < 2.10.0 are used if no parsed Rd files
	  are found.  It is recommended that such packages be
	  re-installed.)


    o	HTML help is now generated dynamically using an HTTP server
	running in the R process and listening on the loopback
	interface.

	- Those worried about security implications of such a server
	  can disable it by setting the environment variable
	  R_DISABLE_HTTPD to a non-empty value.	 This disables
	  help.start() and HTML help (so text help is shown instead).

	- The Java/Javascript search engine has been replaced by an
	  HTML interface to help.search().  help.start() no longer has
	  an argument 'searchEngine' as it is no longer needed.

	- The HTML help can now locate cross-references of the form
	  \link[pkg]{foo} and \link[pkg:foo]{bar} where 'foo' is an
	  alias in the package, rather than the documented (basename
	  of a) filename (since the documentation has been much
	  ignored).


NEW FEATURES

    o	polygon(), pdf() and postscript() now have a parameter
	'fillOddEven' (default FALSE), which controls the mode used for
	polygon fills of self-intersecting shapes.

    o	New debugonce() function; further,
	getOption("deparse.max.lines") is now observed when debugging,
	from a code suggestion by John Brzustowski.  (PR#13647/8)

    o	plot() methods for "stepfun" and hence "ecdf" no longer plot
	points by default for n >= 1000.

    o	[g]sub(*, perl=TRUE) now also supports '\E' in order to *end*
	\U and \L case changes, thanks to a patch from Bill Dunlap.

    o	factor(), `levels<-`(), etc, now ensure that the resulting factor
	levels are unique (as was always the implied intention).  Factors
	with duplicated levels are still constructible by low-level means,
	but are now declared illegal.

    o	New print() (S3) method for class "function", also used for
	auto-printing.	Further, .Primitive functions now print and
	auto-print identically.	 The new method is based on code
	suggestions by Romain François.

    o	The print() and toLatex() methods for class "sessionInfo" now
	show the locale in a nicer format and have arguments to
	suppress locale information.

    o	In addition to previously only round(), there are other 'Math'
	group (S3) methods for 'difftime', such as floor(), signif(),
	abs(), etc.

    o	For completeness, old.packages() and available.packages() allow
	'type' to be specified (you could always specify 'available'
	or 'contriburl').

    o	available.packages() by default only returns information on
	the latest versions of packages whose version requirements are
	satisified by the currently running R.

    o	tools::write_PACKAGES() has a new argument 'latestOnly', which
	defaults to TRUE when only the latest versions in the
	repository will be listed in the index.

    o	getOption() has a new argument 'default' that is returned if
	the specified option is not set. This simplifies querying a
	value and checking whether it is NULL or not.

    o	parse() now warns if the requested encoding is not supported.

    o	The "table" method of as.data.frame() gains a 'stringsAsFactors'
	argument to allow the classifying factors to be returned as
	character vectors rather than the default factor type.

    o	If model.frame.default() encounters a character variable where
	'xlev' indicates a factor, it now converts the variable to a
	factor (with a warning).

    o	curve() now returns a list containing the points that were drawn.

    o	spineplot() now accepts axes = FALSE, for consistency with
	other functions called by plot.factor().

    o	The Kendall and Spearman methods of cor.test() can optionally
	use continuity correction when not computing exact p-values.
	(The Kendall case is the wish of PR#13691.)

    o	R now keeps track of line numbers during execution for
	code sourced with options(keep.source = TRUE).	The source
	reference is displayed by debugging functions such as traceback(),
	browser(), recover(), and dump.frames(), and is stored as an
	attribute on each element returned by sys.calls(). [Experimental]

    o	More functions now have an implicit (S4) generic definition.

    o	quantile.default() now disallows factors (wish of PR#13631)
	and its help documents what numeric-like properties its input
	need to have to work correctly.

    o	weighted.mean() is now generic and has "Date", "POSIXct" and
	"POSIXlt" methods.

    o	Naming subscripts (e.g. x[i=1, j=2]) in data.frame methods for
	[ and [[ now gives a warning.  (Names are ignored in the
	default method, but could have odd semantics for other
	methods, and do for the data.frame ones.)

    o	as.data.frame() has an "aovproj" method.  (Wish of PR#13505)

    o	as.character(x) for numeric x no longer produces strings such as
	"0.30", i.e., with trailing zeros.  This change also renders
	levels construction in factor() more consistent.

    o	codocClasses(), which checks consistency of the documentation of
	S4 class slots, now does so in considerably more cases.	 The
	documentation of inherited slots (from superclasses) is now
	optional.  This affects 'R CMD check <pkg>' when the package
	defines S4 classes.

    o	codoc() now also checks S4 methods for code/documentation
	mismatches.

    o	for(), while(), and repeat() loops  now always return NULL as
	their (invisible) value.  This change was needed to address a
	reference counting bug without creating performance penalties
	for some common use cases.

    o	The print() method for ls.str() results now obeys an optional
	'digits' argument.

    o	The 'method' argument of glm() now allows user-contributed methods.

    o	More general reorder.default() replaces functionality of
	reorder.factor() and reorder.character().

    o	The function aspell() has been added to provide an interface to
	the Aspell spell-checker.

    o	Filters RdTextFilter() and SweaveTeXFilter() have been added
	to the tools package to provide support for aspell() or other
	spell checkers.

    o	xtabs() with the new option 'sparse = TRUE' now returns a sparse
	Matrix, using package 'Matrix'.

    o	contr.sum() etc gain an argument 'sparse' which allows sparse
	matrices to be returned.

	contrasts() also gains a 'sparse' argument which it passes to the
	actual contrast function if that has a formal argument 'sparse'.

	'contrasts(f, .) <- val' now also works when 'val' is a sparse
	Matrix.	 It is planned that model.matrix() will work with such
	factors 'f' in the future.

    o	readNEWS() will recognize a UTF-8 byte-order mark (BOM) in the
	NEWS file. However, it is safer to use only ASCII code there
	because not all editors recognize BOMs.

    o	New utility function inheritedSlotNames() for S4 class programming.

    o	tabulate() now allows NAs to pass through (and be ignored).

    o	If debug() is called on an S3 generic function then all methods
	are debugged as well.

    o	Outlier symbols drawn by boxplot() now obey the 'outlwd'
	argument.  Reported by Jurgen Kluge.

    o	svd(x) and eigen(x) now behave analogously to qr(x) in
	accepting logical matrices x.

    o	File NEWS is now in UTF-8, and has a BOM (often invisible) on
	the first line, and Emacs local variables set for UTF-8 at the
	end.  RShowDoc("NEWS") should display this correctly, given
	suitable fonts.

    o	terms.formula(simplify = TRUE) now does not deparse the LHS and
	so preserves non-standard responses such as `a: b` (requested
	by Sundar Dorai-Raj).

    o	New function news() for building and querying R or package news
	information.

    o	z^n for integer n and complex z is more accurate now if
	|n| <= 65536.

    o	factor(NULL) now returns the same as factor(character(0))
	instead of an error, and table(NULL) consequently does
	analogously.

    o	as.data.frame.vector() (and its copies) is slightly faster
	by avoiding a copy if there are no names (following a
	suggestion of Tim Hesterberg).

    o	writeLines(), writeBin() and writeChar() have a new argument
	'useBytes'.  If false, character strings with marked encodings
	are translated to the current locale (as before) but if true
	they are written byte-by-byte.

    o	iconv() has a new argument 'mark' which can be used (by
	experts) to suppress the declaration of encodings.

    o	DESCRIPTION 'LinkingTo' specs are now recognized as installation
	dependencies, and included in package management computations.

    o	Standardized DESCRIPTION 'License' specs are now available for
	package management computations.

    o	"\uxxxx" and "\Uxxxxxxxx" escapes can now be parsed to a UTF-8
	encoded string even in non-UTF-8 locales (this has been
	implemented on Windows since R 2.7.0).	The semantics have
	been changed slightly: a string containing such escapes is
	always stored in UTF-8 (and hence is suitable for portably
	including Unicode text in packages).

    o	New as.raw() method for "tclObj" objects (wish of PR#13758).

    o	Rd.sty now makes a better job of setting email addresses,
	including using a monospaced font.

    o	textConnection() gains an 'encoding' argument to determine how
	input strings with marked encodings will be handled.

    o	R CMD Rd2pdf is available as a shortcut for R CMD Rd2dvi --pdf.

    o	R CMD check now checks links where a package is specified
	(\link[pkg]{file} or \link[pkg:file]{topic}), if the package
	is available.  It notes if the package is not available, as in
	many cases this is an error in the link.

    o	identical() gains three logical arguments, which allow for even
	more differentiation, notably '-0' and '0'.

    o	legend() now can specify the 'border' color of filled boxes,
	thanks to a patch from Frederic Schutz.

    o	Indexing with a vector index to [[]] has now been extended to
	all recursive types.

    o	Pairlists may now be assigned as elements of lists.  (Lists
	could always be created with pairlist elements, but [[<-
	didn't support assigning them.)

    o	The parser now supports C-preprocessor-like #line directives,
	so error messages and source references may refer to the original
	file rather than an intermediate one.

    o	New functions findLineNum() and setBreakpoint() work with the
	source references to find the location of source lines and set
	breakpoints (using trace()) at those lines.

    o	Namespace importing is more careful about warning on masked
	generics, thanks to a patch by Yohan Chalabi.

    o	detach() now has an argument 'character.only' with the same
	meaning as for library() or require().

    o	available.packages() gains a 'filters' argument for specifying
	the filtering operations performed on the packages found in the
	repositories.  A new built-in 'license/FOSS' filter only
	retains packages for which installation can proceed solely based
	on packages which can be verified as Free or Open Source
	Software (FOSS) employing the available license specifications.

    o	In registering an S3 class by a call to setOldClass(), the data
	part (e.g., the object type) required for the class can be
	included as one of the superclasses in the Classes argument.

    o	The argument 'f' to showMethods() can be an expression evaluating
	to a generic function, allowing methods to be shown for
	non-exported generics and other nonstandard cases.

    o	sprintf() now supports '%o' for octal conversions.

    o	New function Sys.readlink() for information about symbolic
	links, including if a file is a symbolic link.

    o	Package 'tools' has new functions checkRdaFiles() and
	resaveRdaFiles() to report on the format of .rda/.RData data
	files, and to re-save them in a different compressed format,
	including choosing the most compact format available.

	A new INSTALL option, --resave-data, makes use of this.

    o	File ~/.R/config is used in preference to ~/.Rconfig, and
	these are now documented in 'R Installation and Administration'.

    o	Logic operations with complex numbers now work, as they were always
	documented to, and as in S.

    o	arrows() and segments() allow one of x1 or y1 to be omitted to
	simplify the specification of vertical or horizontal lines
	(suggestion of Tim Hesterberg).

    o	approxfun() is faster by avoiding repeated NA checks (diagnosis
	and patch by Karline Soetaert & Thomas Petzoldt).

    o	There are the beginnings of a Nynorsk translation by Karl Ove
	Hufthammer.

    o	stripchart() allows par 'bg' to be passed in for the
	background colour for pch = 21 (wish of PR#13984).

    o	New generic function .DollarNames() to enable class authors
	to customize completion after the $ extractor.

    o	load(), save(), dput() and dump() now open a not-yet-open
	connection in the appropriate mode (as other functions using
	connections directly already did).


REGULAR EXPRESSIONS

    o	A different regular expression engine is used for basic and
	extended regexps and is also for approximate matching.	This is
	based on the TRE library of Ville Laurikari, a modifed copy of
	which is included in the R sources.

	This is often faster, especially in a MBCS locale.

	Some known differences are that it is less tolerant of invalid
	inputs in MBCS locales, and in its interpretation of undefined
	(extended) regexps such as "^*".  Also, the interpretation of
	ranges such as [W-z] in caseless matching is no longer to map
	the range to lower case.

	This engine may in future be used in 'literal' mode for fixed
	= TRUE, and there is a compile-time option in src/main/grep.c
	to do so.

    o	The use of repeated boundary regexps in gsub() and gregexpr() as
	warned about in the help page does not work in this engine (it
	did in the previous one since 2005).

    o	Extended (and basic) regexps now support same set of options as
	for fixed = TRUE and perl = TRUE, including 'useBytes' and
	support for UTF-8-encoded strings in non-UTF-8 locales.

    o	agrep() now has full support for MBCS locales with a modest
	speed penalty.	This enables help.search() to use approximate
	matching character-wise rather than byte-wise.

    o	[g]sub use a single-pass algorithm instead of matching twice
	and so is usually faster.

    o	The perl = TRUE versions now work correctly in a non-UTF-8 MBCS
	locale, by translating the inputs to UTF-8.

    o	useBytes = TRUE now inhibits the translation of inputs with
	marked encodings.

    o	strsplit() gains a 'useBytes' argument.

    o	The algorithm used by strsplit() has been reordered to batch by
	elements of 'split': this can be much faster for fixed = FALSE
	(as multiple compilation of regexps is avoided).

    o	The help pages, including ?regexp, have been updated and
	should be consulted for details of the new implementations.


HELP & Rd FILE CHANGES

    o	A new dynamic HTML help system is used by default, and may be
	controlled using tools::startDynamicHelp().  With this enabled,
	HTML help pages will be generated on request, resolving links
	by searching through the current .libPaths().  The user
	may set options("help.ports") to control which IP port is used
	by the server.

    o	help.start() no longer sets options(htmlhelp = TRUE) (it used
	to on Unix but not on Windows).	 Nor does it on Unix reset the
	"browser" option if given an argument of that name.

	Arguments 'update' and 'remote' are now available on all
	platforms: the default is update = FALSE since the http server
	will update the package index at first use.

    o	help() has a new argument 'help_type' (with default set by the
	option of that name) to supersede 'offline', 'htmlhelp' and
	'chmhelp' (although for now they still work if 'help_type' is
	unset).	 There is a new type, "PDF" to allow offline PDF
	(rather than PostScript).

	A function offline_help_helper() will be used if this exists
	in the workspace or further down the search path, otherwise
	the function of that name in the 'utils' name space is used.

    o	Plain text help is now used as the fallback for HTML help (as
	it always was for Compiled HTML help on Windows).

    o	It is possible to ask for static HTML pages to be prebuilt via
	the configure option --enable-prebuilt-html.  This may be
	useful for those who wish to make HTML help available outside
	R, e.g. on a local web site.

    o	An experimental tag \Sexpr has been added to Rd files, to
	evaluate expressions at build, install, or render time.
	Currently install time and render time evaluation are
	supported.

    o	Tags \if, \ifelse and \out have been added to allow
	format-specific (or more general, using \Sexpr) conditional
	text in man pages.

    o	The parse_Rd() parser has been made more tolerant of coding
	errors in Rd files:  now all syntax errors are reported as
	warnings, and an attempt is made to continue parsing.

    o	parse_Rd() now has an argument 'fragment' (default FALSE) to
	accept small fragments of Rd files (so that \Sexpr can output
	Rd code which is then parsed).

    o	parse_Rd() now always converts its input to UTF-8.  The Rd2*
	rendering functions have a new parameter, 'outputEncoding',
	which controls how their output is encoded.

    o	parse_Rd() no longer includes the newline as part of a
	"%"-style comment.

    o	There have been various bug fixes and code reorganization in
	the Rd renderers Rd2HTML, Rd2latex, Rd2txt, and Rd2ex.

	All example files are now created with either ASCII or UTF-8
	encoding, and the encoding is only marked in the file if there
	is any non-UTF-8 code (previously it was marked if the help
	file had non-ASCII contents, possibly in other sections).

    o	print.Rd() now adds necessary escape characters so that
	printing and re-parsing an Rd object should produce an
	equivalent object.

    o	parse_Rd() was incorrectly handling multiple backslashes in
	R code strings, converting 4n+3 backslashes to 2n+1 instead
	of 2n+2.

    o	parse_Rd() now recognizes the \var tag within a quoted string
	in R-like text.

    o	parse_Rd() now treats the argument of \command as LaTeX-like,
	rather than verbatim.


COMPRESSION

    o	New function untar() to list or unpack tar archives, possibly
	compressed.  This uses either an external 'tar' command or an
	internal implementation.

    o	New function tar() to create (possibly compressed) tar archives.

    o	New functions memCompress() and memDecompress() for in-memory
	compression and decompression.

    o	bzfile() has a 'compress' argument to select the amount of
	effort put into compression when writing.

    o	New function xzfile() for use with xz-compressed files.	 (This
	can also read files compressed by some versions of 'lzma'.)

    o	gzfile() looks at the file header and so can now also read
	bzip2-ed files and xz-compressed files.

    o	There are the new options of save(compress = "bzip2") and "xz"
	to use bzip2 or xz compression (which will be slower, but can
	give substantially smaller files).  Argument compression_level
	gives finer control over the space/time tradeoffs.

	load() can read such saves (but only as from this version of R).

    o	R CMD INSTALL/check and tools::writePACKAGES accept a wider
	range of compressed tar archives.  Precisely how wide depends
	on the capabilities of the host system's 'tar' command: they
	almost always include .tar.bz2 archives, and with modern
	versions of 'tar' other forms of compression such as lzma and
	xz, and arbitrary extensions.

    o	R CMD INSTALL has a new option --data-compress to control the
	compression used when lazy-loading data.  New possibilities are
	--data-compress=bzip2 which will give ca 15% better
	compression at the expense of slower installation times, and
	--data-compress=xz, often giving even better compression on
	large datasets at the expense of much longer installation
	times.	(The latter is used for the recommended packages: it is
	particularly effective for 'survival'.)

    o	file() for open = "", "r" or "rt" will automagically detect
	compressed files (from gzip, bzip2 or xz).  This means that
	compressed files can be specified by file name (rather than
	via a gzfile() connection) to read.table(), readlines(),
	scan() and so on.

    o	data() can handle compressed text files with extensions
	.{txt,tab,csv}.{gz,bz2,xz} .


DEPRECATED & DEFUNCT

    o	png(type="cairo1") is defunct: the value is no longer recognized.

    o	tools::Rd_parse() is defunct (as this version of R uses only
	Rd version 2).

    o	Use of ~/.Rconf (which was deprecated in favour of ~/.Rconfig
	in 2004) has finally been removed.

    o	Bundles of packages are deprecated.  See 'Writing R
	Extensions' for the steps needed to unbundle a bundle.

    o	help() arguments 'offline', 'htmlhelp' and 'chmhelp' are
	deprecated in favour of 'help_type'.

    o	clearNames() ('stats') is deprecated for unname().

    o	Basic regular expressions (extended = FALSE) are deprecated in
	strsplit, grep and friends.  There is a precise POSIX standard
	for them, but it is not what recent RE engines implement, and
	it seems that in almost all cases package authors intended
	fixed = TRUE when using extended = FALSE.

    o	methods::trySilent() is deprecated for	try(*, silent=TRUE) or
	- more efficiently and flexibly - something like
	tryCatch(*, error = function(e) e).

    o	index.search() is deprecated: there are no longer directories of
	types other than 'help'.


INSTALLATION

    o	cairo >= 1.2 is now required (1.2.0 was released in July 2006)
	for cairo-based graphics devices (which remain optional).

    o	A suitable iconv() is now required: support for configure option
	--without-iconv has been withdrawn (it was deprecated in R 2.5.0).

    o	Perl is no longer 'essential'.	R can be built without it, but
	scripts R CMD build, check, Rprof and Sd2d require it.

    o	A system 'glob' function is now essential (a working
	Sys.glob() has been assumed since R 2.9.0 at least).

    o	C99 support for MBCS is now required, and configure option
	--disable-mbcs has been withdrawn.

    o	Having a version of 'tar' capable of automagically detecting
	compressed archives is useful for utils::untar(), and so 'gtar'
	(a common name for GNU tar) is preferred to 'tar': set
	environment variable TAR to specify a particular 'tar' command.


INTERNATIONALIZATION

    o	There is some makefile support for adding/updating translations
	in packages: see po/README and 'Writing R Extensions'.

	There is support for the use of 'dngettext' for C-level
	translations in packages: see 'Writing R Extensions'.


BUG FIXES

    o	Assigning an extra 0-length column to a data frame by
	DF[, "foo"] <- value now works in most cases (by filling with
	NAs) or fails.	(It used to give a corrupt data frame.)

    o	validObject() avoids an error during evaluation in the case
	of various incorrect slot definitions.

    o	n:m now returns a result of type "integer" in a few more
	boundary cases.

    o	The 'zap.ind' argument to printCoefmat() did not usually work as
	other code attempted to ensure that non-zero values had a
	non-zero representation.

    o	printCoefmat() formatted groups of columns together, not just
	the cs.ind group but also the zap.ind group and a residual
	group.	It now formats all columns except the cs.ind group
	separately (and zaps the zap.ind group column-by-column).  The
	main effect will be see in the output from print.anova, as
	this grouped SS-like columns in the zap.ind group.

    o	R_ReplDLLinit() initializes the top-level jump so that some
	embedded applications on Windows no longer crash on error.

    o	identical() failed to take the encoding of character strings
	into account, so identical byte patterns are not necessarily
	identical strings, and similarly Latin-1 and UTF-8 versions of
	the same string differ in byte pattern.

    o	methods(f) used to warn unnecessarily for an S4 generic 'f' which
	had been created based on an existing S3 generic.

    o	The check for consistent ordering of superclasses was not
	ignoring all conditional relations (the symptom was usually
	spurious warnings for classes extending "array").

    o	Trying to assign into a raw vector with an index vector
	containing NAs could cause a segfault.	Reported by Hervé Pagès.

    o	Rscript could segfault if (by user error) its filename argument
	was missing.  Reported by Martin Morgan.

    o	getAnywhere() (and functions that use it, including argument
	completion in the console) did not handle special built-in
	functions.  Reported by Romain Francois.

    o	order() was missing a PROTECT() call and so could segfault when
	called on character data under certain (rare) circumstances
	involving marked non-native encodings.

    o	prettyNum(z, drop0trailing=TRUE) did not work correctly when z
	was a complex vector.  Consequently, str(z, ...)  also did
	not.  (PR#13985)

    o	'make distclean' removed too many files in etc/ if
	builddir = srcdir.

    o	R CMD replaced TEXINPUTS rather than appending to it (as
	documented and intended).

    o	help.start() no longer fails on unix when "browser" is a
	function.

    o	pbeta(x, *, log.p = TRUE) is sometimes more accurate, e.g., for
	very small x.

    o	Unserializing a pre-2.8 workspace containing pure ASCII character
	objects with a LATIN1 or UTF-8 encoding would corrupt the CHARSXP
	cache.



	**************************************************
	*						 *
	*	       2.9 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.9.2 patched


NEW FEATURES

    o	On systems using ICU for collation (including Mac OS X), using
	Sys.setlocale() to change the LC_COLLATE setting is more
	likely to change the collation provided by ICU.


BUG FIXES

    o	On systems using zipped data and help (Windows) the names of
	datasets could clash with temporary filenames used when
	running examples, causing errors.

    o	as.complex() sometimes warned about NAs on coercions and
	sometimes not (when the C function asComplex was used, e.g. on
	list elements).	 (PR#13942)

    o	cat() on an unopened connection could close it twice, and
	with file() connections segfaulted on some systems.

    o	Printing a list could segfault if the elements are nested too
	deeply.



		CHANGES IN R VERSION 2.9.2


NEW FEATURES

    o	install.packages(NULL) now lists packages only once even if they
	occur in more than one repository (as the latest compatible
	version of those available will always be downloaded).

    o	approxfun() and approx() now accept a 'rule' of length two, for
	easy specification of different interpolation rules on left and
	right.

	They no longer segfault for invalid zero-length specification
	of 'yleft, 'yright', or 'f'.

    o	seq_along(x) is now equivalent to seq_len(length(x)) even where
	length() has an S3/S4 method; previously it (intentionally)
	always used the default method for length().

    o	PCRE has been updated to version 7.9 (for bug fixes).

    o	agrep() uses 64-bit ints where available on 32-bit platforms
	and so may do a better job with complex matches.
	(E.g. PR#13789, which failed only on 32-bit systems.)


DEPRECATED & DEFUNCT

    o	R CMD Rd2txt is deprecated.  (It is just a wrapper for
	R CMD Rdconv -t txt.)

    o	tools::Rd_parse() is deprecated and will be removed in 2.10.0
	(which will use only Rd version 2).


BUG FIXES

    o	parse_Rd() still did not handle source reference encodings
	properly.

    o	The C utility function PrintValue no longer attempts to print
	attributes for CHARSXPs as those attributes are used
	internally for the CHARSXP cache.  This fixes a segfault when
	calling it on a CHARSXP from C code.

    o	PDF graphics output was producing two instances of anything
	drawn with the symbol font face. (Report from Baptiste Auguie.)

    o	length(x) <- newval and grep() could cause memory corruption.
	(PR#13837)

    o	If model.matrix() was given too large a model, it could crash
	R. (PR#13838, fix found by Olaf Mersmann.)

    o	gzcon() (used by load()) would re-open an open connection,
	leaking a file descriptor each time. (PR#13841)

    o	The checks for inconsistent inheritance reported by setClass()
	now detect inconsistent superclasses and give better warning
	messages.

    o	print.anova() failed to recognize the column labelled
	P(>|Chi|) from a Poisson/binomial GLM anova as a p-value
	column in order to format it appropriately (and as a
	consequence it gave no significance stars).

    o	A missing PROTECT caused rare segfaults during calls to
	load().	 (PR#13880, fix found by Bill Dunlap.)

    o	gsub() in a non-UTF-8 locale with a marked UTF-8 input
	could in rare circumstances overrun a buffer and so segfault.

    o	R CMD Rdconv --version was not working correctly.

    o	Missing PROTECTs in nlm() caused "random" errors. (PR#13381 by
	Adam D.I. Kramer, analysis and suggested fix by Bill Dunlap.)

    o	Some extreme cases of pbeta(log.p = TRUE) are more accurate
	(finite values < -700 rather than -Inf).  (PR#13786)

	pbeta() now reports on more cases where the asymptotic
	expansions lose accuracy (the underlying TOMS708 C code was
	ignoring some of these, including the PR#13786 example).

    o	new.env(hash = TRUE, size = NA)	now works the way it has been
	documented to for a long time.

    o	tcltk::tk_choose.files(multi = TRUE) produces better-formatted
	output with filenames containing spaces.  (PR#13875)

    o	R CMD check --use-valgrind did not run valgrind on the package tests.

    o	The tclvalue() and the print() and as.xxx methods for class
	"tclObj" crashed R with an invalid object -- seen with an
	object saved from an earlier session.

    o	R CMD BATCH garbled options -d <debugger> (useful for
	valgrind, although --debugger=valgrind always worked)

    o	INSTALL with LazyData and Encoding declared in DESCRIPTION
	might have left options("encoding") set for the rest of the
	package installation.



		CHANGES IN R VERSION 2.9.1


NEW FEATURES

    o	New function anyDuplicated(x) returns 0 (= FALSE) or the index
	of the first duplicated entry of x.

    o	matplot(), matlines() and matpoints() now also obey a 'lend'
	argument, determining line end styles. (Wish of PR#13619).

    o	bw.SJ(), bw.bcv() and bw.ucv() now gain an optional 'tol'
	argument allowing more accurate estimates.

    o	new.packages() no longer regards packages with the same name
	as a member of an installed bundle as 'new' (this is now
	consistent with the dependency checks in install.packages()).

	It no longer reports on partially installed bundles (since
	members can be updated individually if a bundle is unbundled).

    o	old.packages() and hence updates.packages() will look for
	updates to members of package bundles before updates to the
	whole bundle: this allow bundles to be split and installations
	updated.

    o	nlminb() gives better non-convergence messages in some cases.

    o	S3 method dispatch will support S4 class inheritance for S3
	methods, for primitives and via UseMethod(), if the argument
	S3methods=TRUE is given to setClass().	S4 method dispatch
	will use S3 per-object inheritance if S3Class() is set on the
	object.	 See ?Methods and the paper referenced there.

    o	R CMD INSTALL is more tolerant of (malformed) packages with a
	'man' directory but no validly named .Rd files.

    o	R CMD check now reports where options are used that cause some
	of the checks to be skipped.

    o	RSiteSearch has been updated to be consistent with the new
	layout of the search site itself, which now includes separate
	options for vignettes, views, and r-sig-mixed-models, as well
	as changed names for r-help. (Contributed by Jonathan Baron.)

    o	That R CMD check makes use of a
	<pkg>/tests/Examples/<pkg>-Ex.Rout.save file as a reference
	result is now documented in 'Writing R Extensions'.


DEPRECATED & DEFUNCT

    o	print.atomic() (defunct since 1.9.0) has been removed since it
	caused confusion for an S4 class union "atomic".

    o	png(type="cairo1") is deprecated -- it was only needed for
	platforms with 1.0 <= cairo < 1.2.


BUG FIXES

    o	The ... argument was not handled properly when ... was found
	in the enclosure of the current function, rather than in the
	function header itself.	 (This caused integrate() to fail in
	certain cases.)

    o	col2rgb("#00000080", TRUE) would return the background colour.
	(Reported by Hadley Wickham.)

    o	interaction() now ensures that the levels of the result are unique.

    o	packageDescription() and hence sessionInfo() now report the correct
	package version also for a non-attached loaded namespace of
	a version different from the default lib.loc.

    o	smoothScatter() now also works when e.g. xlim[2] < xlim[1].

    o	Invalid use of sprintf() such as sprintf("%S%") now give an error
	instead of a segmentation fault, as do very unusual cases such as
	sprintf("%s", tryCatch(stop(), error=identity)).  (It was
	always documented that misuse could crash R in
	platform-dependent ways.)

    o	parse_Rd() would mishandle braces when they occurred at
	the start of a line within an R string in an Rd file (reported
	by Alex Couture-Beil) or when they occurred in an R comment
	(reported by Mark Bravington).

    o	readNEWS() missed version numbers with more than one digit.

    o	building R --without-x no longer fails (PR#13665)

    o	printCoefmat(cbind(0,1)) now works too (PR#13677)

    o	bw.SJ(c(1:99, 1e6)) now works too.

    o	Rd2txt() could not handle empty descriptions of items in an Rd
	file (reported by Mark Bravington), and did not wrap long lists
	of arguments if they were given in a single item.

    o	stars() would do a partial plot when called with plot = FALSE;
	it now consistently returns the locations of the stars.

    o	Rd2latex() could not handle empty sections.

    o	old.packages() and hence update.packages() would fail on a
	repository which contained only one package but with multiple
	versions of that package.

    o	as.character.Rd() added extra braces when displaying two-argument
	macros.	 (Report and fix by Manuel Eugster.)

    o	unsplit() was misbehaving in the case of single-column data
	frames. (Reported by Will Gray.)

    o	as(I(1), "vector") and similar coercions from objects of
	"unregistered" S3 classes now work.

    o	srcref records produced by parse() and parse_Rd() did not record
	the encoding of the source file.  (Reported by Romain Francois.)

    o	The X11 version of View() was misbehaving in MBCS locales, and
	PgUp/PgDn now behave better, thanks to a patch from Ei-ji Nakama.

    o	R CMD check looked at the environment variable PDFLATEX, but
	as from R 2.8.1 R CMD Rd2dvi used R_PDFLATEXCMD in
	preference, and that was set by R CMD (and not PDFLATEX).  Now
	R CMD check looks at R_PDFLATEXCMD.

    o	sprintf() now signals an error when the result of single format
	specification would be longer than the limit (8192 bytes); it would
	return "somewhat random" results or segfault previously. (PR#13667)
	Further, arguments of type "language" or "symbol" are no longer
	allowed, as these, e.g., sprintf("%s", quote(list())), typically
	lead to unexpected results or hard to understand error messages.

    o	The new (in 2.9.0) 'stringsAsFactors' argument to expand.grid()
	was not working: it now does work but has default TRUE for
	backwards compatibility.

    o	tcrossprod(<1d-array>, <matrix>) now does work when the arguments
	are of compatible dimensions.

    o	qbinom() now is accurate also in (large size, small prob)
	cases.	(PR#13711)

    o	The calculation of the Spearman p-value in cor.test() is
	slightly more accurate in some cases.  (PR#13574)

    o	The digamma(), trigamma() and psigamma() functions could be
	inaccurate for values of x around 1e-15 due to cancellation.
	(PR#13714).

    o	median.default() was altered in 2.8.1 to use sum() rather
	than mean(), although it was still documented to use mean().
	This caused problems for POSIXt objects, for which mean() but
	not sum() makes sense, so the change has been reverted.

    o	Assigning an extra 0-length column to a data frame by
	DF$foo <- value gave a corrupt data frame rather than failing.
	(PR#13724)  This also happened for DF[["foo"]] <- value.

    o	R CMD INSTALL no longer gives a spurious warning about old R
	versions ignoring multiple dependencies, if the conditions are
	known to be satisfied.

    o	The test for setting dim() allowed a value with two or more
	NAs to be set on a 0-length object.  (PR#13729)	 Also, it
	allowed an even number of negative values.

    o	xtfrm(), rank(), sort() and order() did not always make use of
	custom comparison methods specific to the class of elements
	being sorted.

    o	Increase NAMED value on 'seq' value in for() loop so loop code
	cannot modify 'seq' value.

    o	Prevent rectangles of size < 0.5 pixel from disappearing in
	Quartz when using rastered backend.  (PR#13744)

    o	Printing _NA_complex_ had a low-level thinko; patch thanks to
	Bill Dunlap.

    o	CP1257 encoding for postscript/PDF has been corrected.	(PR#13736)

    o	aov() with an error term was evaluating the ... arguments in
	2.9.0 whilst checking their names, so could fail by evaluating
	them in the wrong place.  (PR#13733)

    o	The print() method for arima() failed if all coefs were fixed.

    o	R CMD INSTALL --no-latex was not implemented in 2.9.0 (only).

    o	Added a needed PROTECT call in RunFinalizers to handle cases where
	the routine is called recursively from a GC in a finalizer.

    o	Constructing error messages about unused arguments in calls to
	closures no longer evaluates the arguments.

    o	qr(x, LAPACK=TRUE) did not coerce integer x to numeric.

    o	qr.coef() misbehaved in the LAPACK case with a matrix RHS, so
	that solve(qr(x, LAPACK=TRUE)) gave wrong results. (Found by
	Avraham Adler, PR#13762 by Ravi Varadhan.)



		CHANGES IN R VERSION 2.9.0


NEW FEATURES

    o	Package 'Matrix' is now a recommended package contained in the
	basic R distribution.  It provides S4 classes and methods for
	dense and sparse matrices, often by using the numerical
	libraries Lapack and from the SuiteSparse collection CHOLMOD,
	CSparse, and SPQR among others.

    o	pdf() and postscript() gain a 'useKerning' argument to place
	strings using kerning (which had previously been ignored in
	display but not in strwidth), based in part on an idea and
	code from Ei-ji Nakama. The default is TRUE.

	Kerning involving spaces is now ignored (it was previously
	only used in the computation of string widths).

    o	seq.default() and seq.int() ensure that the result is within the
	interval [from, to] even when the last value would previously
	have been slightly out of range because of the allowance for
	rounding error in computing the number of elements.

    o	boxplot() gains a simple 'matrix' method, enabling boxplot(mat)
	instead of boxplot(data.frame(mat)).

    o	zip.file.extract() gains an optional 'dir' argument (but use
	unzip() instead).

    o	source() with 'encoding' specified (and not as "unknown") marks
	the encoding of character strings in Latin-1 and UTF-8
	locales.

    o	parse(text=z) now marks the encoding of character strings in
	Latin-1 and UTF-8 locales if 'z' is of known encoding (that is
	all elements are either ASCII or marked as Latin-1 or UTF-8).

    o	sprintf() does stricter error checking on input formats to
	avoid passing invalid formats to the OS (which have a tendency
	to crash under such inputs).

    o	expand.grid() gains a 'stringsAsFactors' argument to ask for
	automatic conversion of character vectors to factors (which
	happened for many years but was not previously documented).
	[This did not actually work prior to R 2.9.1.]

    o	bxp() now computes the 'ylim' including the outliers only if
	'outline = TRUE'.  (Wish of PR#13196)

    o	barplot() gains a 'args.legend' argument.  (Wish of PR#13265).

    o	RweaveLatexSetup() now accepts all (and not just some) options
	passed through from Sweave()

    o	cumsum(x) and cumprod(x) for double precision x now use a long
	double accumulator where available and so more closely match
	sum() and prod() in potentially being more accurate.

    o	plot() methods for "stepfun" (and hence "ecdf") gain an 'col'
	argument, allowing to set all three colors simultaneously.

    o	Iterating over a factor in a for loop now coerces to a character
	vector (rather than using the integer codes).

    o	data.frame() now recycles columns of list arguments, not just
	vectors and factors.

    o	plot.ts(plot.type="multiple") now makes use of *.lab and
	*.axis graphical parameters (wish of PR#13134 and 13135).

    o	Classes can be exported from a name space using the NAMESPACE
	file directive 'exportClassPattern' which has the same syntax
	as 'exportPattern'.

    o	strftime() now converts its first argument with as.POSIXlt()
	and so is no longer an alias for format.POSIXLt.

    o	body<-() now treats list values consistently with other
	types: they no longer need to be wrapped in a list() call.

    o	option("pdfbrowser") is now set on Windows as well as on Unix-alikes.

    o	object.size() now returns an object of class "object_size" and
	has a print() method.

    o	[col/row]Sums(), *Means() now have an additional '...' argument,
	so that they can more easily be turned into generic functions.

    o	Package 'tools' contains dependsOnPkgs() to compute reverse
	dependencies.

    o	Strict type checking is now turned on: this catches more
	internal corruptions, and some badly written contributed code.

    o	There are new functions in package 'tcltk', tk_choose.files(),
	tk_choose.dir() and tk_messageBox(), analogues of functions
	available on Windows (the last is an analogue of winDialog).

    o	Sys.glob() now does tilde expansion on all platforms.

    o	read.table() and friends gain a 'fileEncoding' argument to
	make re-encoding of input just a little bit simpler.

    o	grep() gains an 'invert' argument mimicking 'grep -v/--invert'.

    o	strwrap() now allows a separate prefix for the first line.

    o	grep() has a more efficient sibling grepl() that returns a
	logical vector.

    o	xfig() has new arguments 'defaultFont' and 'textSpecial'
	contributed by Sebastian Fischmeister.

    o	parse() and parse_Rd() now point to syntax errors in the
	reported error context, and include the filename and line and
	column numbers so smart text editors can jump to the error
	location.

    o	str(<1d-array>) now writes "[1:n(1d)]" instead of the previous
	less clear "[, 1:n]".

    o	New function testInstalledPackage() in package 'tools' allows
	the examples (and if they were installed) any package-specific
	tests to be run on an installed package.

	testInstalledPackages() can run all the examples and tests in
	the standard and/or recommended packages.  Also
	testInstalledBasic() can run the basic tests (if installed).

    o	file.copy() now has a 'recursive' argument.

    o	Errors in setOldClass() will cause a previous definition to be restored.

    o	Ambiguities in class inheritance and method selection resulting
	from duplicates in superclasses are now resolved by requiring
	(if possible) consistency with all the superclass inheritance. The
	rules for method selection have been revised to take advantage of
	the improved ordering.
	See ?Methods and the reference there related to inheritance.

    o	New function unzip() in package 'utils' to expand or list zip
	archives.

    o	Replacement functions for class() and oldClass()  will unset
	the S4 bit when the replacement can't be an S4 object;
	oldClass() will return the S3 class for S4 objects with slot
	.S3Class.

    o	clip() takes extra steps to avoid the next graphics call
	resetting the clip region.

    o	New function sample.int() to provide documented access to the
	internal part of sample() (sampling from seq_len(n)).

    o	New version of withVisible() for better handling of cases like
	withVisible(eval.parent(....)). Moved to package 'base' with a
	view to replace .Internal(eval.with.vis) in source() later.

    o	showClass() which is also used to auto-print class definitions, now
	mentions the package where the class comes from, if there is one.

    o	simulate(obj) now also works for "glm" objects and for weighted
	fits, thanks in part to contributions from Ben Bolker and
	Heather Turner.	 There is now a means to extend the methods
	available for "glm" objects, as glm families can have an
	optional 'simulate' component.

    o	S4 classes that inherit from any of the "structure" classes or
	from "vector" will turn on methods for all the "Ops" group of
	functions when the package containing the classes is
	loaded. See class?structure.

    o	A mechanism now allows S4 classes to inherit from object types
	"environment", "externalptr" and symbol ("name").  See ?setClass.

    o	demo() gains 'echo' and 'ask' arguments, with defaults similar
	to example().

    o	library() no longer checks for the packages merged during the
	re-organization of 1.9.0.

    o	New function poisson.test() in package 'stats' for exact test
	of rates and rate ratios.

    o	New function isdebugged() indicates whether its argument has the
	debug flag set or not.

    o	ls.str() [via print method] now also works when some objects in
	the environment are missing().

    o	Subsetting S4-objects (without an explicit "[" method) no longer
	preserves the class in cases like setClass("C",
	contains="list"); This reverts a "bug fix" activated in	 R 2.8.0.

    o	.packages() and .find.packages() no longer check the package
	info for installed packages with dumped metadata, since this
	was checked when the package was installed.  .packages() only
	considers such packages to be validly installed (any others
	were installed in a long-obsolete version of R).  Both changes
	speed up searches in libraries of thousands of packages.

    o	boxplot() uses butt line endings for its median line
	(suggestion of Uwe Ligges, PR#13553).

    o	S4 objects passed to a non-default S3 method will be converted
	to a valid S3 object with the S3 class.	 See the section on
	inheriting from non-S4 classes in ?Classes.

    o	A new class "nonStructure" has been defined; classes that extend
	a vector class but that should lose their slots under Math or
	Ops functions should extend this class.	 See class?nonStructure.

    o	axis.POSIXct() now plots in the timezone marked for its inputs
	(if any) rather than in the local time.	 The latter was a
	deliberate choice, but is easy to select by removing the
	'tzone' attribute.  (Suggestion of Dan Kelley.)

    o	A new function classesToAM() returns an adjacency matrix
	representing the inheritance of the classes specified.	Allows
	better human examination of the patterns, e.g. by using the
	matrix as input to one of the graph packages (see the
	documentation).

    o	X11options(antialias = "none") now works, for consistency with
	X11().

    o	sprintf() now allows zero-length arguments (with a zero-length
	result).  (Suggestion of Bill Dunlap.)

    o	unlink() is now able to remove broken symbolic links on
	Unix-alikes.

    o	New selectSuperClasses() utility in package 'methods'.

    o	HoltWinters() now allows parameters alpha and beta to be fixed
	at 0 and hence beta = FALSE and gamma = FALSE are used to
	specify restricted models.

    o	A new function smoothScatter() has been added to package
	'graphics'.  It is appropriate for very dense scatter plots
	and uses density estimation and color to reflect density of
	plotting.


DEPRECATED & DEFUNCT

    o	allGenerics() is defunct.

    o	Use of allocVector(CHARSXP ...) is defunct and gives an error.

    o	The compatibility define for graphics structure NewDevDesc in
	GraphicsDevice.h has been removed.

    o	Support for versioned installs (R CMD INSTALL --with-package-versions
	and install.packages(installWithVers = TRUE)) has been removed.
	Packages installed with versioned names will be ignored.

    o	The numeric and power(0.5) forms of argument to make.link()
	which were deprecated in 2.4.0 are now defunct: use power()
	directly.

    o	Conversion to Sd and Ssgm by R CMD Rdconv is now defunct.

    o	Support for R --gui=gnome is now defunct (and package
	gnomeGUI has been withdrwan as it used a long-obsolete version
	of GNOME).

    o	R CMD SHLIB on Windows will call the first target (not 'all') in
	Makevars[.win] in future versions: so make 'all' the first
	target if you have any.


UTILITIES

    o	R CMD build now also uses a Makevars[.win] file for cleaning
	up src/.

    o	R CMD Rd2dvi and R CMD check are now able to cope with Cyrillic
	characters in UTF-8 if environment variable _R_CYRILLIC_TEX_
	is set to a non-empty value and the latex system has suitable
	fonts (thanks to a hint from Alexey Shipunov).

    o	New function rtags() in package 'utils' that provides etags-like
	indexing capabilities for R code files.

	New front-end script R CMD rtags provides an interface to the
	rtags() function (see R CMD rtags --help for details).

    o	New environment variable R_TEXI2DVICMD to hold the path (if any)
	to 'texi2dvi' found at configure time: this now provides the
	default to option("texi2dvi").

    o	massage-Examples.pl has been replaced by the R function
	tools:::massageExamples().

    o	R CMD REMOVE now uses remove.packages() and hence removes all
	members of a bundle.

    o	R CMD SHLIB is now an R script and has a new option -n aka
	--dry-run to show what commands would be run.  The same code
	is used on Unix and Windows.

    o	R CMD Rdconv has new options --package and --version to set the
	corresponding fields in HTML conversion.

    o	R CMD check runs the package tests with a custom startup file,
	currently containing 'options(useFancyQuotes = FALSE)'.

	Those tests are run by an R script: using a tests/Makefile
	(undocumented) no longer works.

    o	R CMD config now knows about DYLIB_EXT and SHLIB_EXT, for use
	in configure files.

    o	R CMD BATCH has a new option --no-timing to suppress printing
	out the session timing.

    o	R CMD Rd2dvi can now work on an installed package.

    o	R CMD check no longer loads package 'tcltk' when checking for
	code problems, so more problems may be reported.

    o	For R CMD SHLIB on Windows the default 'all' target only makes
	the DLL, and no longer call targets 'before' and 'after'.


Rd CONVERSION

    o	Rd files have an optional \Rdversion{} section, which if
	missing defaults to 1.0.  There is support for version 1.1, a
	slightly modified version with the following changes:

	- The warnings for \code{} inside example are suppressed.

	- Whitespace between arguments in \item and \section is
	  accepted without a warning (see below).

	- $ is treated literally in text, even for latex conversions.

	- \ is only an escape before % { } \ .

	- \R, \dots and \ldots can be followed by {}, and it is
	  recommended that they when not followed by whitespace.

	- The obsolete interpretation of \Alpha etc is no longer done.

    o	Rd conversion now handles ^ ~ < > | correctly in non-code
	environments (such as \samp), and # and _ even in latex
	conversion (but $ still needs to be escaped in version 1.0).

    o	Whitespace between first and second arguments is now accepted
	for \item and \section, e.g.  \item{foo} {some value}.
	Previously arguments after whitespace were silently ignored,
	and a warning is given for version 1.0 files.

    o	The Rd files created by prompt() and friends are declared to be
	version 1.1.

    o	\alias now supports the escaping of { as well as of %, and this
	is recommended.

    o	parse_Rd(), an experimental parser for Rd files, and Rd2txt(),
	Rd2HTML(), Rd2latex() and Rd2ex(), even more experimental
	converters, have been added to package 'tools'.

    o	R CMD check runs the package's Rd files through parse_Rd() for a
	stricter syntax check.	This can be suppressed by setting
	_R_CHECK_RD_PARSE_ to FALSE.

    o	Added markup \verb, which displays like \code, but parses as
	verbatim text.	Currently only supported by parse_Rd() and
	Rd2HTML().


INSTALLATION

    o	The shell used by the 'R' script and other shell scripts
	intended to be run directly can be specified at installation
	time by setting the (precious) configure variable R_SHELL.

    o	libtool has been updated to 2.2.6a.

    o	--with-ICU is now the default: this means that ICU will be
	used for collation on Mac OS >= 10.4.

    o	make install-tests can be used to install the test files,
	to allowed an installed version of R to be tested -- see the
	R-admin manual.	 This is also supported by the function
	testInstalledPackages() in package 'tools'.

    o	'make install' using a parallel make should now work.

    o	'make check' now always re-makes and re-runs the package
	examples, which are now collated in the locale's order (and
	not ASCII order).

    o	configure will now set the default optimization level for
	gfortran on x86_64 Linux to -O as -O2 has caused problems with
	gfortran 4.3.x.


PACKAGE INSTALLATION

    o	install.packages() is able to infer that repos=NULL was
	intended from the extension on the file name specified as 'pkgs'.

	On Mac OS X it now supports local binary packages with .tar.gz
	extension. Nonetheless .tgz remains the preferred extension
	and is expected in repositories.

	It now checks >= version dependencies for dependent packages,
	and so will install a newer version of a dependency if needed
	and available on the repositories.

	The library being installed into is considered when looking
	for installed packages if it is not already part of
	.libPaths() (as INSTALL already does).

	It has a new argument 'Ncpus' to support parallel installs of
	source packages.

    o	HTML links will be resolved first to the standard packages: this
	avoids other installed packages diverting help on e.g. qr()
	and plot() to themselves. The HTML files are only "touched" if
	they have changed.

    o	A check is done that the R files can be parsed: this both
	prevents a broken package without lazy-loading from being
	installed and gives better diagnostics.

    o	install.packages() gains a 'configure.vars' argument, and both
	this and 'configure.args' get their defaults from options().

    o	There is a unified R script for INSTALL on both Unix-alike and
	Windows that takes option names used by either in the past.

	It adds --no-multiarch to disable building other than the main
	sub-architecture, and allows multiple instances of
	--configure-args and --configure-vars (which will be
	concatenated).

	New option --install-tests will install any package-specific
	tests.

    o	Times in the Packaged: and Built: fields are now recorded in
	UTC, and in most cases in ISO 8601 format.


C-LEVEL FACILITIES

    o	A helper function, asCharacterFactor, converts from factors to
	character vectors.


BUG FIXES

    o	The postscript() output for setting text is faster and smaller.

    o	Subsetting a data frame with duplicate column names without
	selecting columns (e.g. z[i,]) no longer makes the column
	names unique.  This was never documented, but some packages
	have assumed it.

    o	data.frame() no longer ignores row names on objects if the
	first name is empty.  (PR#13230: this has been the behaviour
	for a long time, but apparently undocumented.)

    o	deparse(control="S_compatible") now never uses backticks.

    o	X-spline drawing is improved for cases where the control
	points are located well off the edges of the device.

	The symptom of this problem is the error "reached MAXNUMPTS".

    o	exists() with mode= "any" will no longer run an active binding's
	function.

    o	format(c(1 + 2i, NA)) no longer has extraneous space in "  NA".

    o	mood.test() could fail in 2.8.x on large samples because of
	integer overflow.

    o	heatmap() without a dendrogram could fail. (PR#13512)

    o	Checks for missing values will no longer occasionally result in
	an infinite loop or stack overflow error, depending on the
	compiler.  Active bindings are now always considered to be
	non-missing.

    o	Rd conversion was not accepting \p (as in \pkg} or (when using
	Perl 5.10.x) \k (as in \kbd) in any preamble text in a
	\value{} section, since those are nowadays interpreted by
	Perl.  (PR#13575)

    o	if(as.raw(1)) TRUE  now works as expected. (PR#13630)
	Also,  c(as.raw(12), TRUE) or c(raw(3), pi) do.

    o	duplicated(<data frame>, incomparables = NA) now gives the
	intended error message. (PR#13632)

    o	name handling of as.data.frame() has been sanitized somewhat

    o	Evaluating an assignment expression with a string on the left
	hand side no longer destructively changes the string to a symbol
	in the expression.



	**************************************************
	*						 *
	*	       2.8 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.8.1 patched


NEW FEATURES

    o	R CMD check has a new argument '--install-args' to pass
	command-line arguments to INSTALL.
	E.g. --install-args="--docs=normal" on Windows if the HTML
	Help Workshop is not installed.

    o	R-Forge has been added to R_HOME/etc/repositories, so it will
	be available interactively in setRepositories().

    o	The compiled loess() code has been updated to the current
	version of dloess from Netlib.	This includes patches from Ben
	Tyner which correct some errors when degree = 0 and hence
	solve PR#13570.


INSTALLATION

    o	--with-ICU is now supported (and recommended) on Mac OS X using
	Apple's supplied port.	Note however that the locale category
	LC_COLLATE cannot be changed whilst R is running on Apple's
	version of ICU.

	Configure supports a wider range of ICU versions on other
	OSes: version 3.0 should suffice, and 3.2, 3.8 and 4.0 have
	been tested.


BUG FIXES

    o	grid-based plots no longer reset the base text size to the
	default 96dpi in cairo-based bitmap devices.

    o	Rd conversion was incorrectly parsing \\\* and \\\{ (and other
	cases with an odd number of backslashes greater than one).

	Text conversion of \code{\ etc} was incorrect (a single
	backslash stands for itself inside \code).

	\code{} inside \examples{} is now fixed up (but the warning
	remains, since it will be handled incorrectly in earlier
	versions of R).

    o	as.matrix.data.frame() could fail if coercion changed the
	dimension of one of the columns (as e.g. the coercion of a "Surv"
	object to a character vector does).

    o	When extracting part of a complex list structure using [[]]
	with a vector index, the extracted part was not marked for
	duplication on change. (PR#13411)

    o	Assigning an additional element to a pairlist/language element
	by x[["foo"]] <- value did not name the additional element.

    o	.Call() and .External() were not accepting "NativeSymbolInfo"
	and "NativeSymbol" objects as claimed.	(Patch from Olaf
	Mersmann.)

    o	codoc() was missing some default value mismatches with
	unescaped backslashes, e.g. final="\\" needs to be written as
	final="\\\\" in the Rd file.

	The reports on values now give strings in the original quoted
	format (with \ and " escaped).

    o	The $<- method for pairlists (including language objects)
	failed to duplicate if NAMED was 2.

    o	read.table(blank.lines.skip = FALSE) gave a final empty row on
	files with less than 5 lines (PR#13433).

    o	Workaround for a bug in some versions of iconv that was seen
	with output lines of more than 10,000 bytes and with
	re-encoding requested on an output connection.

    o	The fullrefman.{dvi,pdf} duplicated part I in part II (at
	least on some systems).

    o	cbind() could crash with a zero-length input and a list result.

    o	pdf(colormodel = "gray") was setting the stroke colour for fills.

    o	file.show() with multiple files would only show multiple
	copies of the first one. (PR#13469)

    o	formatC(mode = "character") was documented to work, but
	did not. (PR#13474)

    o	besselI(x,.., expon.scaled=TRUE) now gives accurate results for
	x < 1e5 whereas it previously underflowed for x >~= 1500.
	Further, besselJ(x,..) also computes up to 1e5 (instead of 1e4).

    o	str() was incorrectly warning about its option component
	'formatNum' set by strOptions().

    o	nls(algorithm = "port") did not accept the [factor] notation.
	(PR#13650)

    o	The relational (aka "comparison") operators are now binary, also in
	a lower level sense, and an expression as  "<"(1)  is now erronous.

    o	The 'offset' argument for lm() and glm() is not longer
	documented to be allowed to be of length 1: this has not been
	true for a long time.

    o	format.info(x) is now also correct when x has no finite content.

    o	predict.lm() now works correctly when the fit had more than
	one offset (possibly specified both in the formula and as an
	argument).  This function is called by predict.glm(), so the
	same isses are corrected there.

    o	besselI(x, nu) with nu a negative integer (a singular case) is now
	correct. (PR#13556)



		CHANGES IN R VERSION 2.8.1


NEW FEATURES

    o	sum() now has a method for "difftime" objects (via the Summary
	group).

	max(), min() and range() applied to "difftime" object(s) now
	return a result in the common units of the objects, if there
	is one.

    o	installed.packages() is now tolerant of malformed DESCRIPTION
	files in installed packages (it ignores them, with a warning).

    o	qt() now works for 0 < df < 1.

    o	For consistency with matrix() and array(), dimnames(x) <-
	list() removes the dimnames (as assigning NULL would do).
	It was previously an error.

    o	nlminb() copies names from 'start' to the parameter vector
	used (for consistency with optim()).

    o	legend() gains a 'title.col' argument: the title colour was
	previously set from the first element of 'text.col' (which
	remains the default).

    o	In an Rd file, use of top-level \itemize{} inside a \value{}
	block is unnecessary and almost always gave a faulty
	conversion.  Most cases are now detected and corrected, but
	give a warning as such code will not work correctly in earlier
	versins of R.

	Also, use of \code{} inside a code block such as \examples{}
	will give a erroneous conversion that is now detected and
	warned against.

    o	Autoflushing of stdout is turned on when Rd processing, so
	warnings/error are likely to appear in the right place in
	redirected output (such as that from R CMD check).


UTILITIES

    o	R_PDFLATEXCMD is added to the environment variables set by
	'R CMD' and is used by R CMD Rd2dvi.

	R_LATEXCMD, R_PDFLATEXCMD, R_MAKEINDEXCMD and R_DVIPSCMD
	default to 'latex', 'pdflatex', 'makeindex' and 'dvips'
	respectively if no suitable executable was found at configure
	time (since they might well be available at run time,
	particularly for binary installations of R).  This affects
	R CMD Rd2dvi and help(offline=TRUE).

	R CMD Rd2dvi now gives an explicit error message if latex (or
	pdflatex) fails.

	R CMD Rd2dvi gains a --no-index argument: processing some
	special characters on PDF indices gave errors which used to be
	ignored.


DEPRECATED & DEFUNCT

    o	R CMD INSTALL --with-package-versions is deprecated (and
	support has always been incomplete on Windows).

	So is install.packages(installWithVers = TRUE).

    o	Rd conversion to Sd and Ssgm is now deprecated as we no longer
	have any means to check the results (and Sd is long obsolete).


BUG FIXES

    o	add1.glm() no longer warns if applied to a binomial glm with a
	factor response.

    o	aggregate.data.frame() now does something sensible with a
	zero-column 'x' rather than failing with an obscure error
	message.  It gives an explicit error message if called with a
	zero-row 'x'.

    o	integrate() now accepts integer results from f(): as documented,
	but only double was accepted.

    o	contrib.url() produced an incorrect URL for the type
	"mac.binary".

    o	pairwise.wilcox.test() did not pass on the 'paired' argument
	(caught by Matthias Kohl)

    o	bmp(), jpeg(), and png() on unix with type="cairo" would segfault
	on closure if the output file could not be opened.

    o	tiff() on unix would not write the output file for the first page
	when multiple pages were plotted.

    o	str(1 + structure(1, class = "test")) no longer recurses indefinitely.

    o	pf(x, .., ncp, lower.tail=FALSE, log=TRUE) is much more accurate
	for large x now.

    o	dev2bitmap() failed in 2.8.0 if 'taa' and 'gaa' were both NA.

    o	Under rare circumstances equality tests for character strings
	could fail to report equality in 2.8.0 in the same way as
	2.7.2.	(This needed a current encoding of Latin-1 or UTF-8,
	one string whose encoding was marked as that encoding and one
	that was marked as "unknown".  In that circumstance the two
	strings are not actually known to be equal, but earlier
	versions of R assumed that "unknown" meant the current
	encoding, and this is done once again.)

    o	R CMD config could echo messages from GNU make if called from
	within a Makefile (as e.g. package Rcpp did), especially from
	within a parallel make run.

    o	Rounding error could affect window(extend=TRUE) when applied
	to monthly series.  (PR#13272)

    o	Offline help on a Unix-alike now works even if options
	"latexcmd" and "dvipscmd" contain spaces
	(e.g. "dvips -Pmy_printer").

	Informative error messages are given if running latex or dvips
	fail.

    o	Using plot.lm() on a "glm" object since 2.7.1 with which=5
	caused the Pearson rather than deviance residuals to be used
	in which=2 or 3 (including in the default case).  (Thanks to
	Effie Greathouse and Greg Snow.)

	plot.lm() did not report on omitting observations with
	leverage one if they also had residual exactly zero.  This was
	seen in example(occupationalStatus).

    o	deparse(nlines=) no longer pads short results with blank
	lines. (PR#13299)

    o	legend(xpd=) now restores 'xpd' correctly.  (PR#12756)

    o	The "formula" method for lines() now works if 'subset' is
	supplied and no 'data' argument (as that for points() did).

    o	Sweave() now takes the defaults for the options 'pdf.version'
	and 'pdf.encoding' of its RweaveLatex driver from pdf.options().

    o	prettyNum(x, drop0trailing=TRUE) treated "1.1e20" as "1.1e2"
	and hence str() did as well, in 2.8.0 only.

    o	dchisq(x, df, ncp) no longer hangs for large x and ncp > 0,
	and is more accurate in some cases (PR#13309).

    o	installed.packages(lib.loc = D, priority="NA") now also works when
	D contains a single package.  (PR#13332)

    o	legend(...., merge=TRUE) now warns and has no effect in the
	case where no line segments are drawn.	(PR#13340)

    o	transform.data.frame() works better when two or more columns are
	added.

    o	Deparsing argument lists with non-syntactic names (e.g. that for
	transform()) now uses backticks rather than double quotes to
	produce syntactically valid output.

    o	matrix() failed to check for 0-length 'dimnames': it now
	treats them as NULL (as array did).  (PR#13361)

    o	0^NA is now NA, not Inf, consistent with x^NA, x != 1.

    o	anova.mlm() did not work if T had only one row (including
	e.g. the case M = ~1).

    o	axis.POSIXct() mislabelled for some time ranges of a few hours
	(reported by Martin Becker).

    o	mantelhaen.test() with 'exact=FALSE' was not respecting
	'alternative'. It now does one-sided tests similarly to
	prop.test().

    o	anova.mlm() had trouble with some designs where near-zero rows of
	the tranformation matrix were not removed (caught by Nils Skutara).

    o	Rd conversion was handling expressions like
	'\item{foo}{see \eqn{x}}' (with one argument to \eqn
	immediately followed by a right brace) incorrectly, sometimes
	giving a spurious warning about 'missing text'.

    o	R CMD INSTALL used the C locale to install the DESCRIPTION
	file, and so escaped non-ASCII characters in packages with a
	declared encoding of "latin1" or "UTF-8".  (However, the
	installed DESCRIPTION file was rarely used since the dumped
	metadata are available.)

    o	xspline() now respects inline par settings.

	It and grid.xspline() now handle the special case of only two
	control points, and splines with control points that are
	located well outside the device (e.g., a zoomed view of a
	larger curve).	(Both cases were giving the error "reached
	MAXNUMPTS").

    o	In setClass("C", contains="list"); x <- new("C", 1:3), x[2:3] now
	remains of class "C".  So does rep(x, 2) or rep.int(x, 3).
	[NOTE: This "feature" has been reverted for R 2.9.0, see above]

    o	median.default() now also works for "numeric"-like vectors.

    o	The pdf() device can now handle the case where an image uses a
	very large number of colours with different levels of
	semi-transparency (alpha-values).  It used to segfault.
	(Also PR#13264.)

    o	window() failed to apply a fuzz to 'start' or 'end' and so
	sometimes warned incorrectly for time series with 'freq' not a
	power of two (e.g. 12 or 24).

    o	unique.default() now preserves the "tzone" attribute on
	"POSIXct" objects.

    o	If all the packages had dependency lists of equal lengths,
	occasionally install.packages() would compute an incorrect
	sort order.

    o	col(x, as.factor=TRUE) and row(x, as.factor=TRUE) would fail
	if x had no column (row) names.	 It was documented
	incorrectly, and now returns a matrix factor.

    o	setRepositories() failed if "pkgType" was set to
	"mac.binary.leopard".

    o	formals<-() changed the body of the function if this was a
	length-one list.

    o	body<-() failed if the function had no arguments.  It now
	warns if discarding elements from a 'value' of type "expression".

    o	qr.coef() failed in the complex case for non-square systems.
	(PR#13305)

    o	plot.dendrogram(horizontal=TRUE) did not not plot 'edgetext'
	at the correct locations.  (PR#13313)

    o	The starting point for plot.acf(ci.type="ma") was lag 0 when it
	should have been lag 1.	 (PR#13071)

    o	There was an obscure bug with srcrefs, which could put the
	parser into a condition giving "Error: bad value" on any input



		CHANGES IN R VERSION 2.8.0


SIGNIFICANT USER-VISIBLE CHANGES

    o	var(), cov(), cor(), sd() etc now by default (when 'use' is not
	specified) return NA in many cases where they signalled an
	error before.


NEW FEATURES

    o	abbreviate() gains an optional argument 'strict' allowing cheap
	and fast strict abbrevation.

    o	The "lm" methods of add1(), anova() and drop1() warn if they are
	mis-used on an essentially exact fit.

    o	as.array() is now generic, gains a '...' argument.

    o	New function as.hexmode() for converting integers in hex format.
	format.hexmode() and as.character.hexmode() gain an 'upper.case'
	argument.

    o	bitmap() and dev2bitmap() gain support for anti-aliasing.
	The default type has been changed to 'png16m', which supports
	anti-aliasing.

    o	Box.test() gains a 'fitdf' argument to adjust the degrees of
	freedom if applied to residuals.

    o	browseURL() has a new argument 'encodeIfNeeded' to use
	URLencode() in cases where it seems likely that would be
	helpful.  (Unfortunately, those are hard to guess.)

    o	by() gains a 'simplify' argument, passed to tapply().

    o	capabilities() gains a new argument "tiff" to report if tiff()
	is operational.

    o	chol2inv() now treats <numeric(1)> as a [1 x 1]-matrix.

    o	cov() and cor() have the option 'use = "everything"' as default,
	and so does var() with its default 'na.rm = FALSE'.  This
	returns NA instead of signalling an error for NA observations.
	Another new option is 'use = "na.or.complete"' which is the default
	for var(*, na.rm=FALSE).
	var(double(0), na.rm= L) now returns NA instead of signalling an error,
	for both L = TRUE or FALSE, as one consequence of these changes.

    o	data.matrix() now tries harder to convert non-numeric columns,
	via as.numeric() or as(, "numeric").

    o	dev.interactive() is able to recognize the standard screen
	devices if getOption("device") is a function (as well as by name).

    o	dev.new() gains a '...' argument which can be used to pass
	named arguments which will be used if appropriate to the
	device selected.

    o	dimnames(x) <- value extends 'value' if it a list and too
	short, and 'x' is an array.  This allows constructions such as
	dimnames(x)[[1]] <- 1:3 to work whether or not 'x' already has
	dimnames.

    o	format(), formatC() and prettyNum() gain a new argument
	'drop0trailing' which can be used to suppress trailing "0"s.

    o	format() now works for environments; also print(env) and str(env)
	share the same code for environments.

    o	It is now possible to create and open a text-mode gzfile()
	connection by explicitly using e.g. open="rt".

    o	New help.request() function for compiling an e-mail to R-help
	according to "the rules". It is built on the new utility,
	create.post() on which also bug.report() is based now; both
	thanks to a contribution by Heather Turner.

    o	help.search() now assumes that non-ASCII items are in latin1
	if that makes sense (all known examples on CRAN are).

    o	HoltWinters() and decompose() use a (statistically) more
	efficient computation for seasonal fits (they used to waste
	one period).

    o	intToUtf8() and intToBits() now accept numeric vectors,
	truncating them to integers.

    o	is.unsorted() gains an argument 'strictly'.  It now works for
	classed objects with a >= or > method (as incorrectly
	documented earlier).

    o	library() no longer warns about the masking objects that are
	identical(.,.) to those they mask.

    o	lockBinding(), unlockBinding(), lockEnvironment() and
	makeActiveBinding() now all return invisibly (they always
	return NULL).

    o	mood.test() now behaves better in the presence of ties.

    o	na.action() now works on fits of classes "lm", "glm", ....

    o	optim(.., method="SANN", .., trace=TRUE) is now customizable via
	the 'REPORT' control argument, thanks to code proposals by
	Thomas Petzoldt.

    o	The 'factory-fresh' defaults for options("device") have been
	changed to refer to the devices as functions in the grDevices
	namespace and not as names.  This makes it more likely that
	the incorrect (since R 2.5.0) assumption in packages that
	get(getOption("device"))() will work will catch users of those
	packages.

    o	pch=16 now has no border (for consistency with 15, 17, 18) and
	hence is now different from pch=19.

    o	pdf() has new arguments 'useDingbats' (set this to FALSE for use
	with broken viewers) and 'colormodel'.	It now only references
	the ZapfDingbats font if it is used (for small opaque circles).

	The default PDF version is now 1.4, since viewers that do not
	accept that are now rare.

	Different viewers were rendering consecutive text() calls on a
	pdf() device in different ways where translucency was
	involved.  The PDF generated has been changed to force each
	call to be rendered separately (which is the way xpdf or
	ghostscript was rendering, but Acrobat was forming a
	transparency group), which is consistent with other graphics
	devices supporting semi-transparency.

    o	plot.dendrogram() has new arguments (xlim, ylim) which allows
	zooming into a hiearchical clustering dendrogram.

    o	plot.ecdf() now defaults to pch=19 so as to better convey the
	left-closed line segments.

    o	plot.histogram() gains an 'ann' argument. (Wish from Ben Bolker.)

    o	plot(<lm_obj>) now warns when it omits points with leverage one
	from a plot.

    o	Plotmath now recognizes 'aleph' and 'nabla' (the Adobe Symbol
	'gradient' glyph) as symbol names.

    o	polyroot() no longer has a maximum degree.

    o	The alpha/alphamax argument of the 'nls' and 'mle' profile()
	methods is used to compute confidence limits for univariate
	t-statistics rather than a confidence region for all the
	parameters (and not just those being profiled).

    o	quantile.default() allows 'probs' to stray just beyond [0, 1],
	to allow for computed values.

    o	New functions rawConnection() and rawConnectionValue() allow
	raw vectors to be treated as connections.

    o	read.dcf() now consistently gives an error for malformed DCF.

    o	read.fwf() no longer passes its default for 'as.is' to
	read.table(): this allows the latter's default to be used.

    o	readBin(), writeBin(), readChar() and writeChar() now open a
	connection which was not already open in an appropriate binary
	mode rather than the default mode.

	readLines(), cat() and sink() now open a connection which was
	not already open in an appropriate text mode rather than the
	default mode.

    o	readCitationFile() (and hence citation) now reads a package's
	CITATION file in the package's declared encoding (if there is one).

    o	The behaviour of readLines() for incomplete final lines on
	binary-mode connections has been changed to be like blocking
	rather than non-blocking text-mode connections.

    o	A new reorder.character() method has been added.  This allows
	use of 'reorder(x, ...)' as a shorthand for
	'reorder(factor(x), ...)' when 'x' is a character vector.

    o	round() now computes in long doubles where possible so the
	results are more likely to be correct to representation error.

    o	rug() now uses axis()'s new arguments from 2.7.2, hence no
	longer draws an axis line.

    o	save() (optionally, but by default) checks for the existence
	of objects before opening the file/connection (wish of
	PR#12543).

    o	segments(), arrows() and rect() allow zero-length
	coordinates.  (Wish of PR#11192)

    o	set.seed(kind=NULL) now takes 'kind' from a saved seed if the
	workspace has been restored or .Random.seed has been set in
	some other way.	 Previously it took the 'currently used' value,
	which was "default" unless random numbers had been used in
	the current session.  Similarly for the values reported by
	RNGkind().  (Related to PR#12567.)

	set.seed() gains a 'normal.kind' argument.

    o	setEPS() and setPS() gain '...' to allow other arguments to be
	passed to ps.options(), including overriding 'width' and 'height'.

    o	setTimeLimit() function to set limits on the CPU
	and/or elapsed time for each top-level computation, and
	setSessionLimit() to set limits for the rest of the session.

    o	splinefun() has a new method = "monoH.FC" for monotone Hermite
	spline interpolation.

    o	sprintf() optionally supports the %a/%A notation of C99 (if the
	platform does, including under Windows).

    o	str()'s default method gains a 'formatNum' function argument which
	is used for formatting numeric vectors.	 Note that this is very
	slightly not backward compatible.

    o	The summary() method for class "ecdf" now uses a print()
	method rather than printing directly.

    o	summary.manova() uses a stabler computation of the test
	statistics, and gains a 'tol' argument to allow highly
	correlated responses to be explored (with probable loss of
	accuracy).  Similar changes have been made to anova.mlm() and
	anova.mlmlist().

    o	Sweave() now writes concordance information inside a
	\Sconcordance LaTeX macro, which allows it to be inserted into
	PDF output.

    o	system.time() now uses lazy evaluation rather than
	eval/substitute, which results in more natural scoping. (PR#11169)

    o	In table(), 'exclude=NULL' now does something also for factor
	arguments. A new 'useNA' argument allows you to control
	whether to add NA levels unconditionally or only when present
	in data. A new convenience function addNA() gives similar
	functionality by adding NA levels to individual factors.

    o	unlink() tries the literal pattern if it does not match with
	wildcards interpreted -- this helps with e.g. unlink("a[b")
	which previously needed to be unlink("a\\[b").

    o	update.packages() gains an argument 'oldPkgs', where
	new.packages() and old.packages() get 'instPkgs'.  These allow
	consideration of only subsets of packages instead of all
	installed ones.

    o	which(b) is somewhat faster now, notably for named vectors, thanks
	to a suggestion by Henrik Bengtsson.

    o	New generic function xtfrm() as an auxiliary helper for
	sort(), order() and rank().  This should return a numeric
	vector that sorts in the same way as its input.	 The default
	method supports any class with ==, > and is.na() methods but
	specific methods can be much faster.

	As a side-effect, rank() will now work better on classed
	objects, although possibly rather slowly.

    o	X11() and capabilities("X11") now catch some X11 I/O errors that
	previously terminated R.  These were rare and have only be
	seen with a misconfigured X11 setup on some versions of X11.


    o	The handling of nuls in character strings has been changed --
	they are no longer allowed, and attempting to create such a
	string now gives a truncation warning (unless
	options("warnEscapes") is false).

    o	The user environment and profile files can now be specified via
	environment variables 'R_ENVIRON_USER' and 'R_PROFILE_USER',
	respectively.

    o	?pkg::topic and ?pkg:::topic now find help on 'topic' from
	package 'pkg' (and not help on :: or :::).

    o	??topic now does help.search("topic"); variations such as
	??pkg::topic or field??topic are also supported.

    o	There is support for using ICU (International Components for
	Unicode) for collation, enabled by configure option --with-ICU
	on a Unix-alike and by a setting in MkRules on Windows.
	Function icuSetCollate() allows the collation rules (including
	the locale) to be tuned.

    o	If S4 method dispatch is on and S4 objects are found as
	attributes, show() rather than print() is used to print the
	S4 attributes.

    o	Starting package tcltk without access to Tk (e.g. no available
	display) is now a warning rather than an error, as Tcl
	will still be usable.  (On most platforms it was possible to
	inhibit Tk by not having DISPLAY set, but not on Windows nor
	Mac OS X builds with --with-aqua.)

    o	Using $ on a non-subsettable object (such as a function) is
	now an error (rather than returning NULL).

    o	Hexadecimal numerical constants (such as 0xab.cdp+12) may now
	contain a decimal point.

    o	PCRE has been updated to version 7.8 (mainly bug fixes).


NEW FEATURES IN PACKAGE 'methods'

    o	S3 classes that are registered by a call to setOldClass() now
	have the S3 class as a special slot, and therefore so do
	any S4 classes that contain them.  This mechanism is used to
	support S4 classes that extend S3 classes, to the extent
	possible.  See ?Classes, ?setOldClass, and ?S3Class.

	The treatment of special pseudo-classes "matrix", "array", and
	"ts" as S4 classes has also been modified to be more
	consistent and, within limitations imposed by special
	treatment of these objects in the base code, to allow other
	classes to contain them.  See class?ts.

	A general feature added to implement "ts" and also
	"data.frame" as S4 classes is that an S4 class definition can
	be supplied to setOldClass() when the S3 class has known
	attributes of known class.

	setOldClass() now saves all the S3 inheritance, allowing the
	calls to be built up in stages, rather than including all the
	S3 classes in each call.  Also allows as(x,"S3") to generate
	valid S3 inheritance from the stored definition.  See ?S3.

    o	S4 methods may now be defined corresponding to "...", by
	creating a generic function that has "..." as its signature.
	A method will be selected and called if all the arguments
	matching "..." are from this class or a subclass.  See ?dotsMethods.

    o	New functions S3Part() and S3Class() provide access to the
	corresponding S3 object and class for S4 classes that extend
	either an S3 class or a basic R object type.

    o	show(<class definition>) now also shows the class name.


INSTALLATION

    o	If sub-architectures are used, a copy of Rscript is installed
	in ${R_HOME}/bin/exec${R_ARCH} (since that in ${R_HOME}/bin
	and /usr/bin might be overwritten in a subsequent installation).


PACKAGE INSTALLATION

    o	LazyLoad: yes is now the default, so packages wanting to avoid
	lazy loading must set 'LazyLoad: no' (or an equivalent value) in
	the DESCRIPTION file.

    o	R CMD INSTALL will now fail if it finds a non-executable
	'configure' script in the package -- this usually indicates a
	file system with insufficient permissions.  If a
	non-executable 'cleanup' script is found and either
	--clean or --preclean is used, a warning is given.


DEPRECATED & DEFUNCT

    o	Use in packages of the graphics headers Rdevices.h and
	Rgraphics.h is defunct: they are no longer installed.

    o	options("par.ask.default") is defunct in favour of
	"device.ask.default".

    o	The 'device-independent' family "symbol" is defunct: use
	font=5 (base) or fontface=5 (grid) instead.

    o	gammaCody() is defunct.

    o	par("gamma") is defunct.

    o	'methods' package functions getAccess(), getAllMethods(),
	getClassName(), getClassPackage(), getExtends(),
	getProperties(), getPrototype(), getSubclasses, getVirtual(),
	mlistMetaName(), removeMethodsObject() and seemsS4Object() are
	defunct.

    o	Use of a non-integer .Random.seed is now an error.  (R itself
	has never generated such values, but user code has, and
	R >= 2.6.0 has given a warning.)

    o	methods::allGenerics() is deprecated.

    o	In package installation, SaveImage: yes is now ignored, and
	any use of the field will give a warning.

    o	unserialize() no longer accepts character strings as input.

    o	The C macro 'allocString' has been removed -- use 'mkChar' and
	variants.

    o	Use of allocVector(CHARSXP ...) is deprecated and gives a warning.


UTILITIES

    o	The default for 'stylepath' in Sweave's (default) RweaveLatex
	driver is now FALSE rather than TRUE if
	SWEAVE_STYLEPATH_DEFAULT is unset : see ?RweaveLatex.
	To support this, tools::texi2dvi adds the R 'texmf' directory
	to the input search path.

    o	R CMD Rd2dvi now previews PDF output (as was documented) if
	R_PDFVIEWER is set (as it will normally be on a Unix-alike but
	not on Windows, where the file association is used by default).

    o	R CMD check checks for binary executable files (which should not
	appear in a source package), using a suitable 'file' if
	available, else by name.

    o	R CMD check now also uses codetools' checks on the body of S4
	methods.


C-LEVEL FACILITIES

    o	R_ReadConsole will now be called with a buffer size of 4096
	bytes (rather than 1024): maintainers of alternative
	front-ends should check that they do not have a smaller limit.

    o	Graphics structure NewDevDesc has been renamed to DevDesc.
	For now there is a compatibility define in GraphicsDevice.h,
	but it will be removed in R 2.9.0.

    o	PROTECT and UNPROTECT macros now work even with R_NO_REMAP.


BUG FIXES

    o	@ now gives an error (and not just a warning) if it is being
	applied to a non-S4 object.

    o	R CMD appends (not prepends) R's texmf path to TEXINPUTS.

    o	Objects generated by new() from S4 classes should now all
	satisfy isS4(object).  Previously, prototypes not of object
	type S4 would not be S4 objects.  new() applied to basic,
	non-S4 classes still will (and should) return non-S4 objects.

    o	Functions writing to connections such as writeLines(),
	writeBin(), writeChar(), save(), dput() and dump() now check
	more carefully that the connections are opened for writing,
	including connections that they open themselves.

	Similarly functions which read such as readLines(), scan(),
	dcf() and parse() check connections for being open for reading.

    o	Equality comparison of factors with <NA> levels now works
	correctly again.

    o	Repainting of open X11 View() windows is now done whilst an
	X11 dataentry window is in use.

    o	Indexing of data frames with NA column names and a numeric or
	logical column index works again even if columns with NA names
	are selected.

    o	on.exit() has been fixed to use lexical scope in determining
	where to evaluate the exit action when the on.exit expression
	appears in a function argument.

    o	rank() now consistently returns a double result for
	ties.method = "average" and an integer result otherwise.
	Previously the storage mode depended on 'na.last' and if any
	NAs were present.

    o	The "lm" methods of add1(), and drop1() now also work on a model
	fit with  na.action = na.exclude.

    o	median(c(x = NA_real_)) no longer has spurious names().

    o	isoreg(x, y) now returns the correct result also when x has ties,
	in all cases.

    o	What na.action() does is now correctly documented.

    o	source() with echo=TRUE now behaves like ordinary automatic
	printing, by using methods::show() for S4 objects.

    o	Several bugs fixed in `?` with topics: it previously died trying
	to construct some error messages; for S4 methods, class "ANY"
	should be used for omitted arguments and default methods.

    o	trace() should create missing traceable classes in the global
	environment, not in baseenv() where other classes will not be
	found.

    o	Class inheritance using explicit coerce= methods via setIs()
	failed	to coerce the argument in method dispatch.  With this
	fixed, a mechanism was needed to prohibit such inheritance
	when it would break the generic function (e.g.,
	initialize). See ?setIs and ?setGeneric.

    o	RSiteSearch() encodes its query (it seems this is occasionally
	needed on some platforms, but encoding other fields is harmful).

    o	'incomparables' in match() was looking up indices in the wrong
	table.

    o	write.dcf() did not escape "." according to Debian policy
	(PR#12816).

    o	col2rgb() sometimes opened a graphics device unnecessarily, and
	col2rgb(NA) did not return a transparent color, as documented.

    o	pdf(family="Japan") [and other CIDfonts] no longer seg.faults
	when writing "western" text strings.

    o	as.list() applied to an environment now forces promises and
	returns values.

    o	Promises capturing calls to sys.parent() and friends did not
	work properly when evaluated via method dispatch for internal
	S3 generics.

    o	The default "pkgType" option for non-CRAN builds of R on Mac OS X
	is now correctly "source" as documented.

    o	The default R_LIBS_USER path in AQUA builds now matches the
	Mac-specifc path used by the Mac GUI: ~/Library/R/x.y/library

    o	splinefun() with natural splines incorrectly evaluated derivatives
	to the left of the first knot. (PR#13132, fix thanks to
	Berwin Turlach)

    o	anova(glm(..., y=FALSE)) now works.  (PR#13098)

    o	cut.Date(x, "weeks") could fail if x has only one unique value
	which fell on a week boundary.	(PR#13159)




	**************************************************
	*						 *
	*	       2.7 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.7.2 patched


BUG FIXES

    o	within(<dataframe>, { ... }) now also works when '...' removes
	more than one column.

    o	Attempting to open an X11() device on a non-existent display
	when one is already open on another display now gives a
	warning rather than terminating R via a fatal X11 error.
	(PR#12628)

    o	source() did not respect the setting of options("keep.source")
	when setting source references.

    o	seek() now clears the pushback on a text-mode connection if
	used to set a new position.  (PR#12640)

    o	quartz() would segfault if asked to create a file for bitmap
	output which could not be created.  This applied also to the
	type="quartz" versions of bmp(), jpeg(), png() and tiff().

    o	dnbinom(0, size, mu = <large>) suffered from cancellation in 2.7.2
	only.



		CHANGES IN R VERSION 2.7.2


NEW FEATURES

    o	sprintf() returns elements of the result in UTF-8 when the
	format or any character input has a corresponding element
	declared as UTF-8.  Similarly for paste(), elements of the
	result are in UTF-8 when any input to that element is declared
	as UTF-8.

    o	axis() has new arguments 'col.ticks' and 'lwd.ticks' to allow
	the colour and line width of ticks to be set separately from
	that of the line (e.g. to set one or the other to transparent
	or zero width).

    o	legend() has a new argument 'box.col' to set the colour of the
	enclosing box.

    o	legend() gains a 'xpd' argument to make it easier to place a
	legend in the margins or outer margins.

    o	stripchart() now passes '...' to title() (as well as to
	plot.default() and axis()). (Wish of PR#12202)

    o	help.search() has new argument 'searchEngine' to go directly
	to the search form: this is needed by users of Firefox 3.0.x,
	for x <= 6, to workaround a bug in interpreting the search
	results pages.


BUG FIXES

    o	Plotmath computed the glyph metrics for the wrong character (and
	perhaps for a non-existent one) if this was a single-byte
	character with the top bit set.	 An example was	symbol("\300").

    o	sink() and cat() could divert output to a non-writable connection.

    o	phyper(x, 0,0,0) no longer hangs for huge x and gives 1 for x >= 0.
	(PR#11813)

    o	plnorm(x, ..., log.p=TRUE) is now correct for x <= 0. (PR#11867)

    o	<data.frame>[, ch] gives an error (again!) when ch is a string not
	exactly matching the column names, thanks to an oral bug report by
	Matthew Dowle.

    o	data.frame(x=1:2, y=3:4, row.names=c("a","NA"))[c(2,NA),] has
	correct row names c("NA,"NA.1") again.

    o	The GUI data editor for dataframes did not handle escape
	characters in entries properly. (PR#11897)

    o	PCRE has been updated to 7.7 (bugfix release).

    o	package.skeleton() wrongly warned about invalid code_files names
	when these were not in the current directory.

    o	shapiro.test(c(0,0,1)) now has P value >= 0 (instead of barely
	negative).

    o	assign() now warns if given a character vector of length > 1,
	rather than silently taking the first element.

    o	rcond(<exactly singular matrix>) now gives 0 instead of an error.

    o	There was a memory leak in C function ucstoutf8 used by some
	graphics devices.

    o	Plots of profile.mle() objects (package 'stats4') were
	misbehaving when the 'which' argument had been used in their
	calculation.

    o	dnbinom(x, size, mu=*, ..) is now more accurate for very large
	'size'.	 The same applies to pnbinom() and rnbinom().

    o	axis() was ignoring par() mgp[3] if mgp was set in-line.

    o	Closing an X11 View() or dataentry window via its frame's
	close control now works better on some window managers.

    o	Calling lapply() was not handling method dispatch correctly for
	is.numeric(), is.matrix(), is.array(), log() and the Math2
	group.	This affected data.matrix() which incorrectly regarded
	"Date" and "POSIXct" objects as numeric, and has been adjusted
	to do so as exceptions.

    o	package.skeleton() was not looking for non-function objects in
	its 'environment' argument.

    o	nls() was only finding its 'weights' argument in the case when
	all the variables in the formula were of the same length and
	hence that model.frame() could be used.

	It was silently ignoring 'subset' and 'na.action' except in
	that case.  Now they are ignored only if 'data' is a list and
	variables taken from 'data' are not all of the same length,
	in which case a warning is given.

    o	The 'mle' confint() method now takes 'level' into account when
	setting 'alpha' for the profile.

    o	within() was not handling correctly expressions that produced
	NULL columns.  (PR#11131)

    o	dev.print() and dev.copy2{eps,pdf}() now ensure that the current
	device is restored as the active device even if an error
	occurs. (PR#9801)

    o	as.Date() could fail to convert character strings representing
	days on which midnight did not exist in the current timezone
	(as happened in parts of Africa on 1960-01-01).

    o	The automatic placement of legend() with 'title' and a
	reversed 'x' axis was incorrect. (PR#12019)

    o	The use of multiple packages in 'LinkingTo' works again, and
	now works when the dependent packages are in the library to be
	installed to (but not in the library path seen by R --vanilla).

    o	bxp() (and hence boxplot) now respects in-line graphical
	parameters 'xaxp'/'yaxp' as appropriate.  (PR#11463)

    o	barplot(log = "y") failed if there were NAs in the 'height'
	argument.  (PR#11585)

    o	pbeta() is more accurate in some cases with extreme values of
	'ncp'.	(PR#11277).

    o	edit.data.frame() no longer fails if called on a 0-column
	data frame and no column is created.

    o	pchisq(x, df=0) was always one even for x < 0; similarly for
	pgamma(x, alpha=0).

    o	add1() and drop1() now return a P-value of NaN in cases with
	df=0 for test="Chisq" (they gave NaN until pchisq was altered
	in R 2.6.2).

    o	The default methods of drop1() and add1() now re-evaluate in the
	object's formula environment, rather than simply in the parent
	(informal bug report by Werner Stahel).

    o	The undocumented limit of 8191 bytes on comments (from # to
	the end of the line) in R code has been removed.

    o	qgamma() warns if used with shape < 1e-10, when it may be
	unreliable.  (PR#12324)

    o	Installing a source package was not using the package's declared
	encoding (if any) as a default encoding for the help.search()
	database in Meta/hsearch.rds.  This could cause packages with
	a default encoding to have some of their entries rejected by
	help.search() in a multi-byte locale (such as a UTF-8 locale).

    o	duplicated() and unique() now handle 'incomparables' better,
	and avoid occasional segfaults (PR#12551).

    o	plot(isoreg(x, y)) now plots the points correctly when 'x'
	is unssorted.

    o	data.frame(row.names=NULL) once again behaves differently from
	the default (as documented).



		CHANGES IN R VERSION 2.7.1


NEW FEATURES

    o	tools::texi2dvi() has a new argument 'texinputs' to allow the
	TeX and bibtex input paths to be specified (even on MiKTeX).

    o	dev.copy2pdf() gains an 'out.type' argument to allow it to be
	used with cairo_pdf() or quartz(type = "pdf").

    o	poly() has additional checks against user error (as in PR#11243).

    o	The Mac OS quartz() device draws contiguous lines much faster.

    o	A field containing just a sign is no longer regarded as numeric
	(it was on all platforms in 2.7.0, but not on most in earlier
	versions of R).	 Similarly, '.' is now always non-numeric.

    o	CITATION files are now read in Latin-1: quite a few were
	failing if used in a multibyte locale such as UTF-8.

    o	The DESCRIPTION file of a package can specify an 'OS_type' field
	as either 'unix' or 'windows' to confine installation to that
	OS type.

    o	HoltWinters() now uses optimize() rather than optim for
	one-parameter problems which should be more reliable (PR#11469).

    o	axis() now respects the setting of par("xpd") when clipping.

    o	The 'factor' method of format() now preserves names, dims and
	dimnames in the same way as for character and numeric inputs.
	(PR#11512)

    o	read.DIF(*, transpose=TRUE) now allows to correctly read DIF files
	produced by some versions of Excel.


DEPRECATED & DEFUNCT

    o	The use of unserialize() on character strings is deprecated:
	that was a format used in R < 2.4.0.

    o	The use of embedded nuls in character strings is deprecated:
	They will no longer be allowed in R 2.8.0.


UTILITIES

    o	R CMD check checks for possible check directories in the
	sources -- in mid-2008 there were about 20 examples on CRAN.

    o	R CMD build tries harder to clean up the inst/doc directory
	from the remnants of earlier builds.

	It also removes any directories with extension .Rcheck, and
	files .DS_Store and ._* (created by tar on Mac OS X under some
	circumstances: it now sets environment variables to ask for
	such files not to be created by that tar.)


BUG FIXES

    o	Encoding<- on NA_character_ converted it to "NA".

    o	Adobe Symbol was missing from the encodings in
	tools::charset_to_Unicode.

    o	diag(matrix(x, 0, 0)) now returns a 0-length vector of the
	correct mode, instead of always numeric.

    o	The parser sometimes accepted invalid quoted strings in a UTF-8
	locale.

    o	plot.default(x, y) now dispatches to Axis() methods whether
	y is NULL or not.

    o	On Mac OS X, the Cocoa Quartz window could close without warning
	under certain circumstances (specific autorelease pool flush).

    o	Plotting symbols with separate border and fill colours (e.g.,
	plot(pch = 21)) now works with transparent 'col', but opaque
	or semi-transparent 'bg'.  Previously, if 'col' was
	transparent then 'bg' was ignored and nothing was drawn.

    o	file.path() did not work correctly in 2.7.0 if the components
	had different encodings.

    o	merge() failed if there were no common columns and one of the
	inputs had zero rows.

    o	expand.grid() failed if an input had length 0.

    o	match() does again truncate strings at embedded nuls (as newly
	documented in 2.7.0).

    o	Because of a typo, 'pointsize' in png(type="cairo") (and jpeg,
	bmp, tiff) devices was being interpreted in pixels not bigpoints.

    o	is() was wrong for some S3 class objects with class of length
	greater than one.

    o	undoc() / codoc() were not checking all S4 methods in some cases.

    o	Use of textConnection(NULL, mode="w") could segfault.

    o	Use of strwidth/height(units="user") (the default) is again an
	error before a user coordinate system has been set on the
	device, rather than giving nonsensical values (the effect of
	r31367).

    o	Rare string width calculations in package grid were not
	interpreting the string encoding correctly.

    o	hasMethods(f, env) {without specified 'package'} now works better.

    o	A missing PROTECT could cause segfaults on string
	comparisons.  (PR#11421)

    o	str(structure(1, classID = "Pooh")) now works fine.

    o	A missing PROTECT could cause segfaults in if() if coercion of
	the condition was required or a warning was to be given.

    o	plot(<table>) now uses a sensible default main title.

    o	validObject() called with complete=TRUE did not use inherited
	validity methods for slot classes.

    o	Several bugs fixed in as(): the initial method lookup was not
	using the table with inherited methods (so inheritance had to
	be recomputed each time); coerce() should not be called
	directly--it can insert invalid inherited methods; the
	constructed as() methods were not retaining the function's
	environment.

    o	influence.measures(<glm-object>) now computes the same
	Cook's distance approximations as cooks.distance().

    o	plot(<glm>, which=5) uses more correct Cook's distance contours;
	(fix to fix to PR#9316).

    o	pdf() and postscript() were not working correctly in 2.7.0 with
	UTF-8 encoded data in a non-UTF-8 MBCS (e.g. EUC-JP on Unix,
	CJK locales on Windows).

    o	conformMethod(), called by setMethod(), now checks better about
	argument names in wrong order.	Whereas it only warns currently,
	it is planned to become an error in the future.

    o	The predict() method for prcomp() had an incorrect check for
	the number of columns of 'newdata' if the columns were not named.

    o	The axis() function now distinguishes between setting "at" to
	NULL or a zero-length vector, treating the latter as a request
	for no ticks.  This corrects the handling of the "x" parameter
	to rug().

    o	glob2rx("*[*") now produces a correct regular expression.

    o	The canvas is no longer painted on copy or save in Cocoa Quartz.

    o	identify() in Quartz can now be terminated by either using popup
	menu equivalent (Ctrl-click or second mouse button) or by pressing
	the <Esc> key. The latter was documented but did not work.

    o	tools:::.check_package_depends() {called from 'R CMD check'} now
	also works correctly when directory-name != package-name.

    o	Source references were sometimes off by a line.

    o	The quartz() parameter 'antialias' is no longer ignored.

    o	The Quartz device is now trying hard to remove anti-aliasing
	effects for rasterized backends in plots that use adjacent,
	borderless rectangles such as image().

    o	The srcfilecopy() function now adds a timestamp to the object it
	creates.

    o	parse() would lose a token when run on stdin().

    o	socketConnection() was using internally the class "socket"
	and not "sockconn", which caused a conflict with make.socket().
	(PR#11515)

    o	Quartz is now trying harder to find the proper font for a given
	family which resolves font issues on Mac OS X 10.4. Full font
	names and PostScript names can be used interchangeably. (Note,
	however that italic/oblique font faces of Helvetica are not
	included in the Mac OS X 10.4 system).

    o	qf() no longer gives NaN when one of df1 and df2 is large and
	the other is infinite (including if both are infinite); it is more
	accurate e.g. for qf(1e-18, 2,4).

    o	qbeta(-1e10, 50, 40, log.p=TRUE) no longer hangs.

    o	Cocoa Quartz backend autodetection of display DPI was not
	correct for screens rotated by 90 or 270 degrees.

    o	selectMethod("coerce", .) now uses a correct default for
	'useInherited', and hence no longer may mess up the method cache.

    o	show() now also works on "unregistered" S3 class objects.

    o	formatC(*, format="fg", flag="#") is no longer dropping trailing
	zeros.

    o	read.table(file = stdin()) with invalid input could leave the
	connection in an invalid state and hence cause a later
	segfault.  (PR#11627)

    o	read.DIF() did not obey the default 'stringsAsFactors = TRUE'.

    o	The 'noquote' method for c() now works correctly with three or
	more arguments.

    o	symbol() in plotmath expressions works again with non-ASCII
	input on devices that use UTF-8 for the symbol font.



		CHANGES IN R VERSION 2.7.0


SIGNIFICANT USER-VISIBLE CHANGES

    o	The default graphics device in non-interactive use is now
	pdf() rather than postscript().	 [PDF viewers are now
	more widely available than PostScript viewers.]

	The default width and height for pdf() and bitmap() have been
	changed to 7 (inches) to match the screen devices.

    o	Most users of the X11() device will see a new device that has
	different fonts, anti-aliasing of lines and fonts and
	supports semi-transparent colours.

    o	Considerable efforts have been made to make the default output
	from graphics devices as similar as possible (and in
	particular close to that from postscript/pdf).	Many devices
	were misinterpreting 'pointsize' in some way, for example as
	being in device units (pixels) rather than in points.

    o	Packages which include graphics devices need to be re-installed
	for this version of R, with recently updated versions.


NEW FEATURES

    o	The apse code used by agrep() has been updated to version
	0.16, with various bug fixes.

	agrep() now supports multibyte character sets.

    o	any() and all() avoid coercing zero-length arguments (which
	used a surprising amount of memory) since they cannot affect
	the answer.

	Coercion of other than integer arguments now gives a warning
	as this is often a mistake (e.g. writing all(pr) > 0 instead
	of all(pr > 0) ).

    o	as.Date(), as.POSIXct() and as.POSIXlt() now convert numeric
	arguments (days or seconds since some epoch) provided the
	'origin' argument is specified.

    o	New function as.octmode() to create objects such as file
	permissions.

    o	as.POSIXlt() is now generic, and it and as.POSIXct() gain a
	'...' argument.	 The character/factor methods now accept a
	'format' argument (analogous to that for as.Date).

    o	New function browseVignettes() lists available vignettes in an
	HTML browser with links to PDF, Rnw, and R files.

    o	There are new capabilities "aqua" (for the AQUA GUI and quartz()
	device on Mac OS X) and "cairo" (for cairo-based graphics
	devices).

    o	New function checkNEWS() in package 'tools' that detects common
	errors in NEWS file formatting.

    o	deparse() gains a new argument 'nlines' to limit the number of
	lines of output, and this is used internally to make several
	functions more efficient.

    o	deriv() now knows the derivatives of digamma(x), trigamma(x)
	and psigamma(x, deriv) (wrt to x).

    o	dir.create() has a new argument 'mode', used on Unix-alikes
	(only) to set the permissions on the created directory.

    o	Where an array is dropped to a length-one vector by drop() or
	[, drop = TRUE], the result now has names if exactly one of
	the dimensions was named.  (This is compatible with S.)
	Previously there were no names.

    o	The 'incomparables' argument to duplicated(), unique() and
	match() is now implemented, and passed to match() from merge().

    o	dyn.load() gains a 'DLLpath' argument to specify the path for
	dependent DLLs: currently only used on Windows.

    o	The spreadsheet edit() methods (and used by fix()) for data
	frames and matrices now warn when classes are discarded.

	When editing a data frame, columns of unknown type (that is
	not numeric, logical, character or factor) are now converted
	to character (instead of numeric).

    o	file.create() has a new argument 'showWarnings' (default TRUE)
	to show an informative warning when creation fails, and
	dir.create() warns under more error conditions.

    o	New higher-order functions Find(), Negate() and Position().

    o	[dpqr]gamma(*, shape = 0) now work as limits of 'shape -> 0',
	corresponding to the point distribution with all mass at 0.

    o	An informative warning (in addition to the error message) will
	be given when the basic, extended or perl mode of grep(),
	strsplit() and friends fails to compile the pattern.

    o	More study is done of perl=TRUE patterns in grep() and friends
	when length(x) > 10: this should improve performance on long
	vectors.

    o	grep(), strsplit() and friends with fixed=TRUE or perl=TRUE
	work in UTF-8 and preserve the UTF-8 encoding for UTF-8 inputs
	where supported.

    o	help.search() now builds the database about 3x times faster.

    o	iconv() now accepts "UTF8" on all platforms (many did, but not
	e.g. libiconv as used on Windows).

    o	identity() convenience function to be used for programming.

    o	In addition to warning when 'pkgs' is not found,
	install.packages() now reports if it finds a valid package
	with only a case mismatch in the name.

    o	intToUtf8() now marks the Encoding of its output.

    o	The function is() now works with S3 inheritance; that is, with
	objects having multiple strings in the class attribute.

    o	Extensions to condition number computation for matrices, notably
	complex ones are provided, both in kappa() and the new rcond().

    o	list.files() gains a 'ignore.case' argument, to allow
	case-insensitive matching on some Windows/MacOS file systems.

    o	ls.str() and lsf.str() have slightly changed arguments and
	defaults such that ls.str() {no arguments} works when debugging.

    o	Under Unix, utils::make.packages.html() can now be used directly
	to set up linked HTML help pages, optionally without creating
	the package listing and search database (which can be much
	faster).

    o	new.packages() now knows about the front-end package gnomeGUI
	(which does not install into a library).

    o	optim(*, control = list(...)) now warns when '...' contains
	unexpected names, instead of silently ignoring them.

    o	The options "browser" and "editor" may now be set to functions,
	just as "pager" already could.

    o	packageDescription() makes use of installed metadata where
	available (for speed, e.g. in make.packages.html()).

    o	pairwise.t.test() and pairwise.wilcox.test() now more explicitly
	allow paired tests. In the former case it is now flagged as an
	error if both 'paired' and 'pool.SD' are set TRUE (formerly,
	'paired' was silently ignored), and one-sided tests are generated
	according to 'alternative' also if 'pool.SD' is TRUE.

    o	paste() and file.path() are now completely internal, for speed.
	(This speeds up make.packages.html(packages=FALSE)
	severalfold, for example.)

    o	paste() now sets the encoding on the result under some
	circumstances (see ?paste).

    o	predict.loess() now works when loess() was fitted with
	transformed explanatory variables, e.g, loess(y ~ log(x) + log(z)).

    o	print(<data.frame>)'s new argument 'row.names' allows to suppress
	printing rownames.

    o	print() and str() now also "work" for 'logLik' vectors longer than
	one.

    o	Progress-bar functions txtProgressBar(), tkProgressBar() in
	package tcltk and winProgressBar() (Windows only).

    o	readChar() gains an argument 'useBytes' to allow it to read a
	fixed number of bytes in an MBCS locale.

    o	readNEWS() has been moved to the tools package.

    o	round() and signif() now do internal argument matching if
	supplied with two arguments and at least one is named.

    o	New function showNonASCII() in package tools to aid detection
	of non-ASCII characters in .R and .Rd files.

    o	The [dpq]signrank() functions now typically use considerably
	less memory than previously, thanks to a patch from Ivo
	Ugrina.

    o	spec.ar() now uses frequency(x) when calculating the
	frequencies of the estimated spectrum, so that for monthly
	series the frequencies are now per year (as for spec.pgram)
	rather than per month as before.

    o	spline() gets an 'xout' argument, analogously to approx().

    o	sprintf() now does all the conversions needed in a first pass if
	length(fmt) == 1, and so can be many times faster if called
	with long vector arguments.

    o	[g]sub(useBytes = FALSE) now sets the encoding on changed
	elements of the result when working on an element of known
	encoding.  (This was previously done only for perl = TRUE.)

    o	New function Sys.chmod(), a wrapper for 'chmod' on platforms
	which support it.  (On Windows it handles only the read-only
	bit.)

    o	New function Sys.umask(), a wrapper for 'umask' on platforms
	which support it.

    o	New bindings ttk*() in package tcltk for the 'themed widgets'
	of Tk 8.5.  The tcltk demos make use of these widgets where
	available.

    o	write.table(d, row.names=FALSE) is faster when 'd' has millions of
	rows; in particular for a data frame with automatic row names.
	(Suggestion from Martin Morgan.)


    o	The parser limit on string size has been removed.

    o	If a NEWS file is present in the root of a source package, it
	is installed (analogously to LICENSE, LICENCE and COPYING).

    o	Rd conversion to 'example' now quotes aliases which contain
	spaces.

    o	The handling of DST on dates outside the range 1902-2037 has
	been improved.	Dates after 2037 are assumed to have the same
	DST rules as currently predicted for the 2030's (rather than
	the 1970s), and dates prior to 1902 are assumed to have no DST
	and the same offset as in 1902 (if known, otherwise as in the
	1970s).

    o	On platforms where we can detect that mktime sets errno
	(e.g. Solaris and the code used on Windows but not Linux nor
	Mac OS X), 1969-12-31 23:59:59 GMT is converted from POSIXlt
	to POSIXct as -1 and not NA.

    o	The definition of 'whitespace' used by the parser is slightly
	wider: it includes Unicode space characters on Windows and in
	UTF-8 locales on machines which use Unicode wide characters.

    o	The src/extra/intl sources have been updated to those from
	gettext 0.17.

    o	New flag --interactive on Unix-alikes forces the session to be
	interactive (as --ess does on Windows).

    o	x[<zero-length>] <- NULL is always a no-op: previously
	type-checking was done on the replacement value and so this
	failed, whereas we now assume NULL can be promoted to any
	zero-length vector-like object.

	Other cases of a zero-length index are done more efficiently.

    o	There is a new option in Rd markup of \donttest{} to mark
	example code that should be run by example() but not tested
	(e.g. because it might fail in some locales).

    o	The error handler in the parser now reports line numbers for
	more syntax errors (MBCS and Unicode encoding errors, line
	length and context stack overflows, and mis-specified argument
	lists to functions).

    o	The "MethodsList" objects originally used for method selection
	are being phased out.  New utilities provide simpler
	alternatives (see ?findMethods), and direct use of the mangled
	names for the objects is now deprecated.

    o	Creating new S4 class and method definitions in an environment
	that could not be identified (as package, namespace or global)
	previously generated an error.	It now results in creating and
	using an artificial package name from the current date/time,
	with a warning.	 See ?getPackageName.

    o	Unix-alikes now give a warning on startup if locale settings
	fail.  (The Windows port has long done so.)

    o	Parsing and scanning of numerical constants is now done by R's
	own C code.  This ensures cross-platform consistency, and
	mitigates the effects of setting LC_NUMERIC (within base R it
	only applies to output -- packages may differ).

	The format accepted is more general than before and includes
	binary exponents in hexadecimal constants: see
	?NumericConstants for details.

    o	Dependence specifications for R or packages in the Depends
	field in a DESCRIPTION file can now make use of operators
	< > == and != (in addition to <= and >=): such packages will
	not be installable nor loadable in R < 2.7.0.

	There can be multiple mentions of R or a package in the Depends
	field in a DESCRIPTION file: only the first mention will be
	used in R < 2.7.0.


GRAPHICS CHANGES

    o	The default graphics devices in interactive and
	non-interactive sessions are now configurable via environment
	variables R_INTERACTIVE_DEVICE and R_DEFAULT_DEVICE
	respectively.

    o	New function dev.new() to launch a new copy of the default
	graphics device (and taking care if it is "pdf" or
	"postscript" not to trample on the file of an already running
	copy).

    o	dev.copy2eps() uses dev.displaylist() to detect screen
	devices, rather than list them in the function.

    o	New function dev.copy2pdf(), the analogue of dev.copy2eps().

    o	dev.interactive() no longer treats a graphics device as
	interactive if it has a display list (but devices can still
	register themselves on the list of interactive devices).

    o	The X11() and windows() graphics devices have a new argument
	'title' to set the window title.

    o	X11() now has the defaults for all of its arguments set by the
	new function X11.options(), inter alia replacing options
	"gamma", "colortype" and "X11fonts".

    o	ps.options() now warns on unused option 'append'.

	xfig() no longer takes default arguments from ps.options().
	(This was not documented prior to 2.6.1 patched.)

	pdf() now takes defaults from the new function pdf.options()
	rather that from ps.options() (and the latter was not
	documented prior to 2.6.1 patched).

	The defaults for all arguments other than 'file' in
	postscript() and pdf() can now be set by ps.options() or
	pdf.options()

    o	New functions setEPS() and setPS() as wrappers to ps.options()
	to set appropriate defaults for figures for inclusion in other
	documents and for spooling to a printer respectively.

    o	The meaning of numeric 'pch' has been extended where MBCSes are
	supported.  Now negative integer values indicate Unicode
	points, integer values in 32-127 represent ASCII characters,
	and 128-255 are valid only in single-byte locales.
	(Previously what happened with negative pch values was
	undocumented: they were replaced by the current setting of
	par("pch").)

    o	Graphics devices can say if they can rotate text well
	(e.g. postscript() and pdf() can) and if so the device's
	native text becomes the default for contour labels rather than
	using Hershey fonts.

    o	The setting of the line spacing (par("cra")[2]) on the X11() and
	windows() devices is now comparable with postscript() etc, and
	roughly 20% smaller than before (it used to depend on the
	locale for X11).  (So is the pictex() device, now 20% larger.)
	This affects the margin size in plots, and should result in
	better-looking plots.

    o	There is a per-device setting for whether new frames need
	confirmation.  This is controlled by either par("ask") or
	grid.prompt() and affects all subsequent plots on the device
	using base or grid graphics.

    o	There is a new version of the X11() device based on cairo
	graphics which is selected by type "cairo" or "nbcairo", and
	is available on machines with cairo installed and preferably
	pango (which most machines with gtk+ >= 2.8 will have).	 This
	version supports translucent colours and normally does a
	better job of font selection so it has been possible to
	display (e.g.)	English, Polish, Russian and Japanese text on
	a single X11() window.	It is the default where available.

	There is a companion function, savePlot(), to save the current
	plot to a PNG file.

	On Unix-alikes, devices jpeg() and png() also accept
	type = "cairo", and with that option do not need a running
	X server.  The meaning of capabilities("jpeg") and
	capabilities("png") has changed to reflect this.  On MacOS X,
	there is a further type = "quartz".  The default type is
	selected by the new option "bitmapType", and is "quartz" or
	"cairo" where available.

	Where cairo 1.2 or later is supported, there is a svg() device
	to write SVG files, and cairo_pdf() and cairo_ps() devices to
	write (possibly bitmap) PDF and postscript files via cairo.

	Some features require cairo >= 1.2, and some which are
	nominally supported under 1.2 seem to need 1.4 to work well.

    o	There are new bmp() and tiff() devices.

    o	New function devSize() to report the size of the current
	graphics device surface (in inches or device units).  This
	gives the same information as par("din"), but independent of
	the graphics subsystem.

    o	New base graphics function clip() to set the clipping region (in
	user coordinates).

    o	New functions grconvertX() and grconvertY() to convert between
	coordinate systems in base graphics.

    o	identify() recycles its 'labels' argument if necessary.

    o	stripchart() is now a generic function, with default and
	formula methods defined.  Additional graphics parameters may
	be included in the call.  Formula handling is now
	similar to boxplot().

    o	strwidth() and strheight() gain 'font' and 'vfont' arguments and
	accept in-line pars such as 'family' in the same way as text()
	does.  (Longstanding wish of PR#776)

    o	example(ask=TRUE) now applies to grid graphics (e.g. from
	lattice) as well as to base graphics.

    o	Option "device.ask.default" replaces "par.ask.default" now it
	applies also to grid.prompt().

    o	plot.formula() only prompts between plots for interactive
	devices (it used to prompt for all devices).

    o	When plot.default() is called with y=NULL it now calls Axis()
	with the 'y' it constructs rather than use the default axis.


DEPRECATED & DEFUNCT

    o	In package installation, SaveImage: yes is defunct and
	lazyloading is attempted instead.

    o	$ on an atomic vector or S4 object is now defunct.

    o	Partial matching in [[ is now only performed if explicitly
	requested (by exact=FALSE or exact=NA).

    o	Command-line completion has been moved from package 'rcompgen'
	to package 'utils': the former no longer exists as a separate
	package in the R distribution.

    o	The S4 pseudo-classes "single" and double have been removed.
	(The S4 class for a REALSXP is "numeric": for back-compatibility
	as(x, "double") coerces to "numeric".)

    o	gpar(gamma=) in the grid package is now defunct.

    o	Several S4 class definition utilities, get*(), have been said
	to be deprecated since R 1.8.0; these are now formally deprecated.
	Ditto for removeMethodsObject().

    o	Use of the graphics headers Rgraphics.h and Rdevices.h is
	deprecated, and these will be unavailable in R 2.8.0.
	(They are hardly used except in graphics devices, for which
	there is an updated API in this version of R.)

    o	options("par.ask.default") is deprecated in favour of
	"device.ask.default".

    o	The 'device-independent' family "symbol" is deprecated as it was
	highly locale- and device-dependent (it only did something
	useful in single-byte locales on most devices) and font=5
	(base) or fontface=5 (grid) did the job it was intended to do
	more reliably.

    o	gammaCody() is now formally deprecated.

    o	Two low-level functions using MethodsList metadata objects
	(mlistMetaName() and getAllMethods()) are deprecated.

    o	Setting par(gamma=) is now deprecated, and the windows()
	device (the only known example) no longer allows it.

    o	The C macro 'allocString' will be removed in 2.8.0 -- use
	'mkChar', or 'allocVector' directly if really necessary.


INSTALLATION

    o	Tcl/Tk >= 8.3 (released in 2000) is now required to build
	package tcltk.

    o	configure first tries TCL_INCLUDE_SPEC and TK_INCLUDE_SPEC
	when looking for Tcl/Tk headers.  (The existing scheme did
	not work for the ActiveTcl package on Mac OS X.)

    o	The Windows build only supports Windows 2000 or later (XP,
	Vista, Server 2003 and Server 2008).

    o	New option --enable-R-static-lib installs libR.a which can
	be linked to a front-end via 'R CMD config --ldflags'.
	The tests/Embedding examples now work with a static R
	library.

    o	Netscape (which was discontinued in Feb 2008) is no longer
	considered when selecting a browser.

    o	xdg-open (the freedesktop.org interface to
	kfmclient/gnome-open/...) is considered as a possible browser,
	after real browsers such as firefox, mozilla and opera.

    o	The search for tclConfig.sh and tkConfig.sh now only looks in
	directories with names containing $(LIBnn) in the hope of
	finding the version for the appropriate architecture
	(e.g. x86_64 or i386).

    o	libtool has been updated to version 2.2.

    o	Use of --with-system-zlib, --with-system-bzlib or
	--with-system-pcre now requires version >= 1.2.3, 1.0.5, 7.6
	respectively, for security.


UTILITIES

    o	Rdconv now removes empty sections including alias and keyword
	entries, with a note.

    o	Keyword entries are no longer mandatory in Rd files.

    o	R CMD INSTALL now also installs tangled versions of all vignettes.

    o	R CMD check now warns if spaces or non-ASCII characters are
	used in file paths, since these are not in general portable.

    o	R CMD check (via massage-Examples.pl) now checks all examples
	with a 7 inch square device region on A4 paper, for
	locale-independence and to be similar to viewing examples on
	an on-screen device.

	If a package declares an encoding in the DESCRIPTION file,
	the examples are assumed to be in that encoding when running
	the tests. (This avoids errors in running latin1 examples in a
	UTF-8 locale.)

    o	R CMD check uses pdflatex (if available) to check the typeset
	version of the manual, producing PDF rather than DVI.  (This
	is a better check since the package reference manuals on CRAN
	are in PDF.)

    o	R CMD Rd2dvi gains a --encoding argument to be passed to
	R CMD Rdconv, to set the default encoding for conversions.
	If this is not supplied and the files are package sources and
	the DESCRIPTION file contains an Encoding field, that is used
	for the default encoding.

    o	available.packages() (and hence install.packages() etc) now
	supports subdirectories in a repository, and
	tools::write_PACKAGES() can now produce PACKAGES files
	including subdirectories.

    o	The default for 'stylepath' in Sweave's (default) RweaveLatex
	driver can be set by the environment variable
	SWEAVE_STYLEPATH_DEFAULT: see ?RweaveLatex.


C-LEVEL FACILITIES

    o	Both the Unix and Windows interfaces for embedding now make
	use of 'const char *' declarations where appropriate.

    o	Rprintf() and REprintf() now use 'const char *' for their format
	argument -- this should reduce warnings when called from C++.

    o	There is a new description of the interface for graphics
	devices in the 'R Internals' manual, and several new entry
	points.	 The API has been updated to version R_GE_version = 5,
	and graphics devices will need to be updated accordingly.

    o	Graphics devices can now select to be sent text in UTF-8, even
	if the current locale is not UTF-8 (and so enable text entered
	in UTF-8 to be plotted).  This is used by postscript(), pdf()
	and the windows() family of devices, as well as the new
	cairo-based devices.

    o	More Lapack routines are available (and declared in R_Ext/Lapack.h),
	notably for (reciprocal) condition number estimation of complex
	matrices.

    o	Experimental utility R_has_slot supplementing R_do_slot.

    o	There is a new public interface to the encoding info stored on
	CHARSXPs, getCharCE and mkCharCE using the enumeration type
	cetype_t.

    o	A new header 'R_ext/Visibility.h' contains some definitions for
	controlling the visibility of entry points, and how to control
	visibility is now documented in 'Writing R Extensions'.


BUG FIXES

    o	pt(x, df) is now even more accurate in some cases (e.g. 12 instead
	of 8 significant digits), when x^2 << df, thanks to a remark from
	Ian Smith, related to PR#9945.

    o	co[rv](use = "complete.obs") now always gives an error if there
	are no complete cases: they used to give NA if
	method = "pearson" but an error for the other two methods.
	(Note that this is pretty arbitrary, but zero-length vectors
	always give an error so it is at least consistent.)

	Since sd(na.rm=TRUE) and var(na.rm=TRUE) both call cov(use =
	"complete.obs"), this applies also to them.

	cor(use="pair") used to give diagonal 1 even if the variable
	was completely missing for the rank methods but NA for the
	Pearson method: it now gives NA in all cases.

	cor(use="pair") for the rank methods gave a matrix result with
	dimensions > 0 even if one of the inputs had 0 columns.

    o	Supplying edit.row.names = TRUE when editing a matrix without
	row names is now an error and not a segfault. (PR#10500)

    o	The error handler in the parser reported unexpected
	& as && and | as ||.

    o	ps.options(reset = TRUE) had not reset for a long time.

    o	paste() and file.path() no longer allow NA_character_ for
	their 'sep' and 'collapse' arguments.

    o	by() failed for 1-column matrices and dataframes.  (PR#10506)
	However, to preserve the old behaviour, the default method
	when operating on a vector still passes subsets of the vector
	to FUN, and this is now documented.

    o	Better behaviour of str.default() for non-default
	'strict.width' (it was calling str() rather than str.default()
	internally); also, more useful handling of options("str").

    o	wilcox.test(exact=FALSE, conf.int=TRUE) could fail in some
	extreme two-sample problems.  (Reported by Wolfgang Huber.)

    o	par(pch=) would accept a multi-byte string but only use the
	first byte.  This would lead to incorrect results in an MBCS
	locale if a non-ASCII character was supplied.

    o	There are some checks for valid C-style formats in, e.g.
	png(filename=).	 (PR#10571)

    o	vector() was misinterpreting some double 'length' values, e.g,
	NaN and NA_real_ were interpreted as zero.  Also, invalid
	types of 'length' were interpreted as -1 and hence reported as
	negative.  (length<- shared the code and hence the same
	misinterpretations.)

    o	A basic class "S4" was added to correspond to the "S4" object
	type, so that objects with this type will print, etc.  The
	class is VIRTUAL, since all actual S4 objects must have a real
	class.

    o	Classes with no slots that contain only VIRTUAL classes are now
	VIRTUAL, as was intended but confused by having an empty S4
	object as prototype. ## backed out temporarily ##

    o	format.AsIs() discarded dimnames, causing dataframes with matrix
	variables to be printed without using the column names, unlike
	what happens in S-PLUS (Tim Hesterberg, PR#10730).

    o	xspline() and grid::grid.xspline() work in device coordinates
	and now correct for anisotropy in the device coordinate
	system.

    o	grid.locator() now indicates to the graphics device that it is
	is in 'graphics input' mode (as locator() and identify()
	always have).  This means that devices can now indicate the
	'graphics input' mode by e.g. a change of cursor.

    o	Locales without encoding specification and non-UTF-8 locales
	now work properly on Mac OS X.	Note that locales without
	encoding specification always use UTF-8 encoding in Mac OS X
	(except for specials "POSIX" and "C") - this is different from
	other operating systems.

    o	iconv() now correctly handles to="" and from="" on Mac OS X.

    o	In diag()'s argument list, drop the explicit default (' = n')
	for 'ncol' which is ugly when making diag() generic.

    o	S4 classes with the same name from different packages were not
	recognized because of a bug in caching the new definition.

    o	jpeg() and png() no longer maintain a display list, as they
	are not interactive devices.

    o	Using attr(x, "names") <- value (instead of the correct
	names<-) with 'value' a pairlist (instead of the correct
	character vector) worked incorrectly.  (PR#10807)

    o	Using [<- to add a column to a data frame dropped other
	attributes whereas [[<- and $<- did not: now all preserve
	attributes.  (PR#10873)

    o	File access functions such as file.exists(), file.info(),
	dirname() and unlink() now treat an NA filename as a
	non-existent file and not the file "NA".

    o	r<foo>(), the random number generators, are now more consistent
	in warning when NA's (specifically NaN's) are generated.

    o	rnorm(n, mu = Inf) now returns rep(Inf, n) instead of NaN;
	similar changes are applied to rlnorm(), rexp(), etc.

    o	[l]choose() now warns when rounding non-integer 'k' instead of
	doing so silently.  (May help confused users such as PR#10766.)

    o	gamma() was warning incorrectly for most negative values as being
	too near a negative integer.  This also affected other
	functions making use of its C-level implementation.

    o	dumpMethod() and dumpMethods() now work again.

    o	package.skeleton() now also works for code_files with only
	metadata (e.g. S4 setClass) definitions; it handles S4 classes and
	methods, producing documentation and NAMESPACE exports if requested.

    o	Some methods package utilities (implicitGeneric(), makeGeneric())
	will be more robust in dealing with primitive functions (not a
	useful idea to call them with primitives, though)

    o	Making a MethodsList from a function with no methods table will
	return an empty list, rather than cause an error (questionably
	a bug, but caused some obscure failures).

    o	setAs() now catches 2 arguments in the method definition, if
	they do not match the arguments of coerce().

    o	S4 methods with missing arguments in the definition are handled
	correctly  when non-signature arguments exist, and check for
	conflicting local names in the method definition.

    o	qgamma() and qchisq() could be inaccurate for small p,
	e.g. qgamma(1.2e-10, shape = 19) was 2.52 rather than 2.73.

    o	dbeta(.., ncp) is now more accurate for large ncp, and typically no
	longer underflows for give.log = TRUE.

    o	coerce() is now a proper S4 object and so prints correctly.

    o	@ now checks it is being applied to an S4 object, and if not
	gives a warning (which will become an error in 2.8.0).

    o	dump() and friends now warn that all S4 objects (even those
	based on vectors) are not source()able, with a stronger wording.

    o	read.dcf(all = TRUE) was leaking connections.

    o	scan() with a non-default separator could skip nul bytes,
	including those entered as \0 with allowEscapes=TRUE.  This
	was different from the default separator.

    o	determinant(matrix(,0,0)) now returns a correct "det" result;
	also value 1 or 0 depending on 'logarithm', rather than numeric(0).

    o	Name space 'grDevices' was not unloading its DLL when the
	name space was unloaded.

    o	getNativeSymbolInfo() was unaware of non-registered Fortran
	names, because one of the C support routines ignored them.

    o	load() again reads correctly character strings with embedded nuls.
	(This was broken in 2.6.x, but worked in earlier versions.)




	**************************************************
	*						 *
	*	       2.6 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.6.2 patched


BUG FIXES

    o	src/extra/pcre has been updated to PCRE 7.6 (bugfix release).

    o	unlink(..., recursive=TRUE) no longer crashes on some platforms
	if a directory cannot be opened.

    o	Loading in 2.6.2 a saved workspace could give an unimportant
	warning in a non-UTF-8 multibyte locale (in particular a CJK
	locale on Windows) which is now suppressed.

    o	print() methods are more consistent in returning the original
	argument invisibly.

    o	Using the X11 data editor (e.g. via edit(), fix() or View())
	could crash if the 'End' key was used and all the columns
	would have fitted into the window.

    o	Creating a new page on an X11() device (by plot.new() or
	grid.newpage()) did not flush out the XClearWindow call, so
	the X11 window might not be refreshed immediately.

    o	libtool has been updated to version 1.5.26, which avoids
	many spurious configure warnings on Darwin/Mac OS X.

    o	l10n_info() now recognizes how Darwin/Mac OS X reports
	Latin-1 locales (as charset ISO8859-1 rather than ISO-8859-1).

    o	Checking examples which used grid (e.g. via lattice) without
	attaching grid no longer give errors from grid_plot_hook().

    o	kappa(m, exact=TRUE) no longer wrongly uses 'exact=FALSE' when m
	is an 'lm' or 'qr' object because the kappa.tri(x, exact=TRUE)
	now works correctly.

    o	help(topic, offline=TRUE) misbehaved when there were multiple
	matches to 'topic'.  (PR#10859)

    o	The 'multilib' changes on Linux broke the use of
	sub-architectures without a main architecture.

    o	source(echo=TRUE) would skip lines consisting entirely of the
	letter t. (PR#10923)

    o	bzip2 has been updated to 1.0.5 (security fix).



		CHANGES IN R VERSION 2.6.2


NEW FEATURES

    o	colnames(DF) is now also fast for large dataframes DF with
	automatic row.names.  Note that the correct usage is
	names(DF).  (PR#10470)

    o	tools::texi2dvi() works around the failure of 'texi2dvi --quiet'
	to be quiet in texinfo 4.11.

    o	On Linux, parallel 32/64-bit installations are supported using
	multilib.

BUG FIXES

    o	A compilation problem on one system where glob was not found
	has been corrected.  (PR#10468)

    o	The "profile.nls" method of plot() was losing the x axis labels.

    o	array() computed the total number of entries in the array before
	coercing the dimensions to integer.  (Reported by Allen McIntosh.)

    o	persp() misreported errors in the y parameter.	(Reported by Allen
	McIntosh.)

    o	source("clipboard", echo=TRUE) and file("clipboard", open="rt")
	gave spurious errors.  (Reported by Fernando Saldanha.)

    o	attributes<-() stripped any existing attributes before checking
	that all elements of the right-hand side had names.

    o	rbinom(n, size, *) gave NaN when 'size > .Machine$integer.max'.

    o	print.summary.lm() is now consistent in the capitalization of
	"R-squared".

    o	confint() misreported on some rank-deficient lm() models.
	(PR#10496)  This could also occur in the default method.

    o	\code{\var{<name>}} was not rendered correctly to latex in Rd
	files for non-alphabetic arguments <name>.

    o	In 2.6.1, curve(*, add=TRUE) used a wrong default 'xlim' when x
	coordinates were logged.

    o	The Java-based search in help.start() now only requires a
	JVM >= 1.4 (2.6.1 accidentally required >= 1.5).

    o	The default method for range() was omitting 'na.rm' for
	non-numeric objects such as those of class "Date".  (PR#10508)

    o	cut(x, breaks=<n>) misbehaved on a constant vector of negative
	values.

    o	bxp(), the plotting engine of boxplot(), no longer plots staple
	ticks multiple times.  (PR#10499)

    o	The automatic detection of the domain for message translation
	was not working correctly for messages in message(), warning()
	and stop() in packages other than 'base'.

    o	The profile.nls() function misbehaved when encountering
	non-convergence of the "port" algorithm.

    o	Under certain rare circumstances in R 2.6.x, log(), round()
	and trunc() could alter their arguments in the caller.	This
	involved passing of empty '...' arguments, and was spotted
	when using apply(x, 2, log).

    o	par() no longer warns unnecessarily when asked to set new=FALSE
	on an unused graphics device.

    o	plot.formula() was not passing on '...' when used with a
	one-sided formula.

	plot.formula() was not accepting expressions for annotations
	passed to title().  (PR#10525)

    o	pchisq(x, df=0, ncp=L) now returns the correct limit exp(-L/2) for
	x=0 and is no longer returning NaN for x > 0, L < 80.  (PR#10551)

    o	Non-ASCII characters were only working correctly in Hershey
	fonts if these were specified by the 'vfont' argument to
	text() and not if specified as a font family.

    o	There were several errors in Hershey$allowed, but the help
	page listed the allowed combinations correctly.

    o	text() no longer attempts to use 'vfont' with an expression
	for 'labels' (it was documented not to work).

    o	fisher.test(simulate.p.value = TRUE) gave incorrect answers
	in some extremely degenerate problems.	(PR#10558)

    o	src/extra/pcre has been updated to PCRE 7.5 (bugfix release).

    o	capture.output() completes an incomplete final line of
	output when file = NULL.  (PR#10534)

    o	capture.output() now returns invisibly if output is written to
	a file/connection.

    o	format.AsIs() did not remove the "AsIs" class and so could go
	into an infinite loop.

    o	summary.mlm() lost the names of the coefficients when there
	was only one.

    o	Rdconv was not marking examples files with an encoding if
	this was known from the package's DESCRIPTION file.

    o	readChar() from a raw vector was reading a number of bytes,
	not characters.

    o	slotNames() was erroneously treating classes that extend
	"character" as strings.

    o	R no longer ignores SIGPIPE signals even in processes launched
	by system().  Instead PR#1959 is handled by a simple error
	handler which will give an error message in circumstances
	where none was given before.

    o	The AIC() S4 generic in package stats4 no longer disables
	dispatch of S3 methods for AIC().

    o	The conflicts check in library() excluded all S4 generics, even
	where they were unrelated to the function masked.  It is now
	more selective (although still too generous to S4 generics).

    o	proc.time() was missing a protect and could misbehave if
	provoked by gctorture().  (PR#10600)

    o	The cut() and hist() methods for dates and datetimes are now
	more accurate for intervals of "months" and "years", thanks to
	Marc Schwarz.

    o	url()/download.file() could segfault if the HTTP interaction
	involved a redirect to an address starting with '/' on the
	same server.

    o	Memory allocations used in format() and in an internal utility
	function could be off by one byte. (PR#10635)

    o	isoreg(x, y) no longer segfaults when y has NAs.

    o	split(x, g) always returns a list as documented.  (It used to
	return NULL for a zero-length 'x'.)

    o	tapply(x, g, ...) misbehaved if the args were of zero length.
	(PR#10644)

    o	hist.POSIXt(*, xaxt = "n") no longer suppresses the y-axis.

    o	strptime() crashed under certain locales on Mac OS X.

    o	gregexpr() no longer segfaults when "" is given as the search
	pattern.  Thanks to Hervé Pagès for the bug report.

    o	matplot(x, *) with default 'pch' did not plot columns from column
	number 37 on (because the default pch was NA for those). (PR#10676)

    o	print.htest() lost output when used within sink(file, split=TRUE).

    o	Setting par(col.main=) also set par("col") to the same colour.

    o	Anonymous fifos were broken (again).



		CHANGES IN R VERSION 2.6.1


NEW FEATURES

    o	The "data.frame" and "factor" methods for [[ now support
	the 'exact' argument introduced in 2.6.0.

    o	plot.lm() gains a new argument 'cex.caption' to allow the
	size of the captions to be controlled.

    o	A series of changes make the CHARSXP cache introduced in 2.6.0
	faster (and in some cases many times faster) in sessions with
	a large number (e.g. a million) of unique character strings,
	and also if there are many empty strings.

    o	embedFonts(), bitmap() and dev2bitmap() explicitly turn off
	auto-rotation in Ghostscript when generating PDF.

    o	The canonical architecture is no longer checked when loading
	packages using a non-empty sub-architecture, since it is
	possible to (e.g.) build packages for i386-pc-linux-gnu on both
	that architecture and on x86_64-unknown-linux-gnu.

    o	Deparsing will (if option warnIncomplete is set) warn on
	strings longer than the parser limit (8192 bytes).

    o	url() now uses the UserAgent header in http transactions in
	the same way as download.file() (making use of option
	"HTTPUserAgent").


BUG FIXES

    o	iconv() is again able to translate character strings with
	embedded nuls (such as those in UCS-2).

    o	new.packages() and update.packages() failed when called on an
	empty library, since old.packages() threw an error.
	old.packages() now returns NULL (as documented) in that case.

    o	Builds on Mac OS X 10.4 or higher now allocate enough space
	in the binary headers to relocate dependent libraries into the
	framework.

    o	R CMD build now computes the exclusion list on the copy it
	makes: this avoids problems if the original sources contain
	symbolic links (which are resolved in the copy).  Thanks to
	Michael Lawrence for diagnosis and patch.

    o	object.size() had slightly too low a size for objects of type "S4".

    o	symbol() in plotmath expressions was only accepting valid
	character strings, which made it impossible to specify symbols
	such as aleph (obtained by symbol("\300")) in a UTF-8 locale.

    o	An event handling issue caused autorepeat functions to
	misbehave with tcltk (notably scrollbars).

    o	plot(sin, -5, 5) gives ylab 'sin(x)' again, where it resulted
	in 'x(x)' in 2.6.0.  Further,  plot(sin)  again plots from
	[0,1] also in cases where a previously used coordinate system
	differs.

    o	curve() with unspecified 'from', 'to' and 'xlim' now reuses the
	previous x limits, and not slightly larger ones.

    o	It was intended that R code filenames in packages should start
	with an ASCII letter or digits (and R CMD INSTALL uses that),
	but the test used in R CMD build ([A-Za-z0-9]) was
	locale-specific (and excluded t to y in Estonian, for
	example).  (PR#10351)

    o	'R CMD build' could misbehave when faced with files with CRLF
	line endings *and* no line ending on the final line of the
	file, removing the last byte of the file.

    o	DF[i, j] failed in 2.6.0 if j was a logical vector selecting a
	single column.

    o	Unix x11() would fail if a valid 'display' was specified but
	DISPLAY was unset. (PR#10379)

    o	postscript() was not always ignoring .Postscript.Options in
	the workspace (where it should not have occurred).

    o	help.search() would give an error if it found a badly
	installed package, even if 'package' was not specified.

    o	tclServiceMode() (package tcltk) now works under Unix-alikes.
	(Although documented, it used only to work under Windows.)

    o	As Mac OS X 10.5.x comes with incompatible /bin/sh shell, we
	force SHELL=/bin/bash (which is ok) in that case. [Only for
	2.6.x: another solution is used in 2.7.0.]

    o	Deliberately using malformed source attributes no longer
	causes deparsing/printing of functions to crash R. (PR#10437)

    o	R CMD check and R CMD INSTALL now work with (some) directory
	names containing spaces.

    o	choose(n, k) gave incorrect values for negative n and small k.

    o	plot.ts(x,y) could use wrong default labels; fixed thanks to
	Antonio, Fabio di Narzo.

    o	reshape() got column names out of sync with contents in some
	cases; found by Antonio Fabio Di Narzo.

    o	ar(x) for short 'x' (i.e. length <= 10) could fail because the
	default 'order.max' was >= length(x) which is non-sensical.

    o	Keyboard events in getGraphicsEvent() could cause stack
	imbalance errors. (PR#10453)



		CHANGES IN R VERSION 2.6.0


SIGNIFICANT USER-VISIBLE CHANGES

    o	integrate(), nlm(), nlminb(), optim(), optimize() and uniroot()
	now have '...' much earlier in their argument list.  This
	reduces the chances of unintentional partial matching but
	means that the later arguments must be named in full.

    o	The default type for nchar() is now "chars".  This is almost
	always what was intended, and differs from the previous default
	only for non-ASCII strings in a MBCS locale.  There is a new
	argument 'allowNA', and the default behaviour is now to throw
	an error on an invalid multibyte string if type="chars" or
	type="width".

    o	Connections will be closed if there is no R object referring to
	them.  A warning is issued if this is done, either at garbage
	collection or if all the connection slots are in use.


NEW FEATURES

    o	abs(), sign(), sqrt(), floor(), ceiling(), exp() and the gamma,
	trig and hyperbolic trig functions now only accept one
	argument even when dispatching to a Math group method (which
	may accept more than one argument for other group members).

    o	abbreviate() gains a 'method' argument with a new option
	"both.sides" which can make shorter abbreviations.

    o	aggregate.data.frame() no longer changes the group variables
	into factors, and leaves alone the levels of those which are
	factors.  (Inter alia grants the wish of PR#9666.)

    o	The default 'max.names' in all.names() and all.vars() is now
	-1 which means unlimited.  This fixes PR#9873.

    o	as.vector() and the default methods of as.character(),
	as.complex(), as.double(), as.expression(), as.integer(),
	as.logical() and as.raw() no longer duplicate in most cases
	where the object is unchanged.	(Beware: some code has been
	written that invalidly assumes that they do duplicate, often
	when using .C/.Fortran(DUP=FALSE).)

    o	as.complex(), as.double(), as.integer(), as.logical() and
	as.raw() are now primitive and internally generic for
	efficiency. They no longer dispatch on S3 methods for
	as.vector() (which was never documented).  as.real() and
	as.numeric() remain as alternative names for as.double().

	expm1(), log(), log1p(), log2(), log10(), gamma(), lgamma(),
	digamma() and trigamma() are now primitive.  (Note that logb()
	is not.)

	The Math2 and Summary groups (round, signif, all, any, max, min,
	sum, prod, range) are now primitive.

	See under METHODS PACKAGE below for some consequences for S4 methods.

    o	apropos() now sorts by name and not by position on the search
	path.

    o	attr() gains an 'exact = TRUE' argument to disable partial
	matching.

    o	bxp() now allows 'xlim' to be specified. (PR#9754)

    o	C(f, SAS) now works in the same way as C(f, treatment), etc.

    o	chol() is now generic.

    o	dev2bitmap() has a new option to go via PDF and so allow
	semi-transparent colours to be used.

    o	dev.interactive() regards devices with the displaylist enabled
	as interactive, and packages can register the names of their
	devices as interactive via deviceIsInteractive().

    o	download.packages() and available.packages() (and functions
	which use them) now support in 'repos' or 'contriburl' either
	file: plus a general path (including drives on a UNC path on
	Windows) or a file:/// URL in the same way as url().

    o	dQuote() and sQuote() are more flexible, with rendering
	controlled by the new option 'useFancyQuotes'.	This includes
	the ability to have TeX-style rendering and directional quotes
	(the so-called 'smart quotes') on Windows.  The default is to
	use directional quotes in UTF-8 locales (as before) and in the
	Rgui console on Windows (new).

    o	duplicated() and unique() and their methods in base gain an
	additional argument 'fromLast'.

    o	fifo() no longer has a default 'description' argument.

	fifo("") is now implemented, and works in the same way as file("").

    o	file.edit() and file.show() now tilde-expand file paths on all
	interfaces (they used to on some and not others).

    o	The find() argument is now named 'numeric' and not 'numeric.':
	the latter was needed to avoid warnings about name clashes
	many years ago, but partial matching was used.

    o	stats:::.getXlevels() confines attention to factors since some
	users expected R to treat unclass(<a factor>) as a numeric
	vector.

    o	grep(), strsplit() and friends now warn if incompatible sets
	of options are used, instead of silently using the documented
	priority.

    o	gsub()/sub() with perl = TRUE now preserves attributes from the
	argument x on the result.

    o	is.finite() and is.infinite() are now S3 and S4 generic.

    o	jpeg(), png(), bmp() (Windows), dev2bitmap() and bitmap() have
	a new argument 'units' to specify the units of 'width' and
	'height'.

    o	levels() is now generic (levels<- has been for a long time).

    o	Loading serialized raw objects with load() is now considerably
	faster.

    o	New primitive nzchar() as a faster alternative to
	nchar(x) > 0 (and avoids having to convert to wide chars in
	a MBCS locale and hence consider validity).

    o	The way old.packages() and hence update.packages() handle
	packages with different versions in multiple package
	repositories has been changed.	The first package encountered
	was selected, now the one with highest version number.

    o	optim(method = "L-BFGS-B") now accepts zero-length parameters,
	like the other methods.	 Also, method = "SANN" no longer
	attempts to optimize in this case.

    o	New options 'showWarnCalls' and 'showErrorCalls' to give a
	concise traceback on warnings and errors.  showErrorCalls=TRUE
	is the default for non-interactive sessions.  Option
	'showNCalls' controls how abbreviated the call sequence is.

    o	New options 'warnPartialMatchDollar', 'warnPartialMatchArgs'
	and 'warnPartialMatchAttr' to help detect the unintended use
	of partial matching in $, argument matching and attr()
	respectively.

    o	A device named as a character string in options(device =) is now
	looked for in the grDevices name space if it is not visible
	from the global environment.

    o	pmatch(x, y, duplicates.ok = TRUE) now uses hashing and so is
	much faster for large x and y when most matches are exact.

    o	qr() is now generic.

    o	It is now a warning to have an non-integer object for
	.Random.seed: this indicates a user had been playing with it,
	and it has always been documented that users should only save
	and restore it.

    o	New higher-order functions Reduce(), Filter() and Map().

    o	[g]regexpr() gain an 'ignore.case' argument for consistency with
	grep().	 (This does change the positional matching
	of arguments, but no instances of positional matching beyond
	the second were found.)

    o	relist() utility, an S3 generic with several methods, providing
	an 'inverse' for unlist(); thanks to a code proposal from
	Andrew Clausen.

    o	require() now returns invisibly.

    o	The interface to reshape() has been revised, allowing some
	simplified forms that did not work before, and somewhat
	improved error handling. A new argument 'sep' has been
	introduced to replace simple usages of 'split' (the old
	features are retained).

    o	rmultinom() uses a high-precision accumulator where available,
	and so is more likely to give the same result on different
	platforms (although it is still possible to get different
	results, and the result may differ from previous versions of R).

    o	row() and col() now work on matrix-like objects such as data
	frames, not just matrices.

    o	Rprof() allows smaller values of 'interval' on machines that
	support it: for example modern Linux systems support
	interval = 0.001.

    o	sample() now requires its first argument 'x' to be numeric
	(in the sense of is.numeric()) as well as of length 1 and >= 1
	before it is regarded as shorthand for 1:x.

    o	sessionInfo() now provides details about package name spaces
	that are loaded but not attached.  The output of sessionInfo
	has been improved to make it easier to read when it is
	inadvertently wrapped after being pasted into an email
	message.

    o	setRepositories() has a new argument 'ind' to allow selections
	to be made programmatically.

    o	sprintf() no longer has a output string length limit.

    o	storage.mode<- is now primitive, and hence makes fewer copies
	of an object (none if the mode is unchanged).  It is a little
	less general than mode<-, which remains available.  (See also
	the entry under DEFUNCT below.)

    o	sweep() gains an argument 'check.margin = TRUE' which warns
	about mismatched dimensions.

    o	The mathematical annotation facility (plotmath) now recognises
	a symbol() function which forces the font to be a symbol font.
	This allows access to all characters in the Adobe Symbol
	encoding within plotmath expressions.

    o	For OSes that cannot unset environment variables, Sys.unsetenv()
	sets the value to "", with a warning.

    o	New function Sys.which(), an interface to 'which' on
	Unix-alikes and an emulation on Windows.

    o	On Unix-alikes, system(, intern = TRUE) reports on very long
	lines that may be truncated, giving the line number of the
	content being read.

    o	termplot() has a default for 'ask' that uses dev.interactive().

	It allows 'ylim' to be set, or computed to cover all the
	plots to be made (the new default) or computed for each plot
	(the previous default).

    o	uniroot(f, *) is slightly faster for non-trivial f() because it
	computes f(lower) and f(upper) only once, and it has new optional
	arguments 'f.lower' and 'f.upper' by which the caller can pass these.

    o	unlink() is now internal, using common POSIX code on all platforms.

    o	unsplit() now works with lists of dataframes.

    o	The vcov() methods for classes "gls" and "nlme" have migrated to
	package 'nlme'.

    o	vignette() has a new argument 'all' to choose between showing
	vignettes in attached packages or in all installed packages.

    o	New function within(), which is like with(), except that it
	returns modified versions back of lists and data frames.

    o	X11(), postscript() (and hence bitmap()), xfig(), jpeg(), png()
	and the Windows devices win.print(), win.metafile() and bmp()
	now warn (once at first use) if semi-transparent colours are
	used (rather than silently treating them as fully
	transparent).

    o	New function xspline() to provide base graphics support of
	X-splines (cf grid.xspline).

    o	New function xyTable() does the 2D gridding "computations" used by
	sunflowerplot().


    o	Rd conversion to HTML and CHM now makes use of classes, which
	are set in the stylesheets.  Editing R.css will change the
	styles used for \env, \option, \pkg etc.  (CHM styles are set
	at compilation time.)

    o	The documented arguments of '%*%' have been changed to be x
	and y, to match S and the implicit S4 generic.

    o	If members of the Ops group (the arithmetic, logical and
	comparison operators) and '%*%' are called as functions,
	e.g. '>'(x, y), positional matching is always used.  (It used
	to be the case that positional matching was used for the
	default methods, but names would be matched for S3 and S4
	methods and in the case of '!' the argument name differed
	between S3 and S4 methods.)

    o	Imports environments of name spaces are named (as
	"imports:foo"), and so are known e.g. to environmentName().

    o	Package 'stats4' uses lazy-loading not SaveImage (which is now
	deprecated).

    o	Installing help for a package now parses the .Rd file only
	once, rather than once for each type.

    o	PCRE has been updated to version 7.2.

    o	bzip2 has been updated to version 1.0.4.

    o	gettext has been updated to version 0.16.1.

    o	There is now a global CHARSXP cache, R_StringHash.  CHARSXPs
	are no longer duplicated and must not be modified in place.
	Developers should strive to only use mkChar (and mkString) for
	creating new CHARSXPs and avoid use of allocString.  A new
	macro, CallocCharBuf, can be used to obtain a temporary char
	buffer for manipulating character data.	 This patch was
	written by Seth Falcon.

    o	The internal equivalents of as.complex, as.double, as.integer
	and as.logical used to handle length=1 arguments now accept
	character strings (rather than report that this is
	'unimplemented').

    o	Lazy-loading a package is now substantially more efficient (in
	memory saved and load time).

    o	Various performance improvements lead to a 45% reduction
	in the startup time without 'methods' (and one-sixth with -
	'methods' now takes 75% of the startup time of a default session).

    o	The [[ subsetting operator now has an argument 'exact' that
	allows programmers to disable partial matching (which will in
	due course become the default).	 The default value is exact=NA
	which causes a warning to be issued when partial matching
	occurs.	 When exact = TRUE, no partial matching will be
	performed.  When exact = FALSE, partial matching can occur and
	no warning will be issued.  This patch was written by Seth
	Falcon.

    o	Many of the C-level warning / error messages (e.g. from
	subscripting) have been re-worked to give more detailed
	information on either the location or the cause of the
	problem.

    o	The S3 and S4 Math groups have been harmonized.	 Functions
	log1p(), expm1(), log10() and log2() are members of the S3
	group, and sign(), log1p(), expm1(), log2(), cummax(),
	cummin(), digamma(), trigamma() and trunk() are members of the
	S4 group.  gammaCody() is no longer in the S3 Math group.
	They are now all primitive.

    o	The initialization of the random-number stream makes use of the
	sub-second part of the current time where available.

	Initialization of the 1997 Knuth TAOCP generator is now done
	in R code, avoiding some C code whose licence status has been
	questioned.

    o	The reporting of syntax errors has been made more user-
	friendly.


METHODS PACKAGE

    o	Packages using 'methods' have to have been installed in R 2.4.0
	or later (when various internal representations were changed).

    o	Internally generic primitives no longer dispatch S4 methods on
	S3 objects.

    o	load() and restoring a workspace attempt to detect and warn on
	the loading of pre-2.4.0 S4 objects.

    o	Making functions primitive changes the semantics of S4
	dispatch: these no longer dispatch on classes based on types
	but do dispatch whenever the function in the base name space is
	called.

	This applies to as.complex(), as.integer(), as.logical(),
	as.numeric(), as.raw(), expm1(), log(), log1p(), log2(),
	log10(), gamma(), lgamma(), digamma() and trigamma(), as
	well as the Math2 and Summary groups.

	Because all members of the group generics are now primitive,
	they are all S4 generic and setting an S4 group generic does
	at last apply to all members and not just those already made
	S4 generic.

	as.double() and as.real() are identical to as.numeric(), and
	now remain so even if S4 methods are set on any of them.
	Since 'as.numeric' is the traditional name used in S4,
	currently methods must be exported from a NAMESPACE for
	'as.numeric' only.

    o	The S4 generic for '!' has been changed to have signature (x)
	(was (e1)) to match the documentation and the S3 generic.
	setMethod() will fix up methods defined for (e1), with a
	warning.

    o	The "structure" S4 class now has methods that implement the
	concept of structures as described in the Blue Book--that
	element-by-element functions and operators leave structure
	intact unless they change the length.  The informal behavior
	of R for vectors with attributes was inconsistent.

    o	The implicitGeneric() function and relatives have been added to
	specify how a function in a package should look when methods are
	defined for it.	 This will be used to ensure that generic versions
	of functions in R core are consistent.	See ?implicitGeneric.

    o	Error messages generated by some of the functions in the methods
	package provide the name of the generic to provide more
	contextual information.

    o	It is now possible to use setGeneric(useAsDefault = FALSE) to
	define a new generic with the name of a primitive function
	(but having no connection with the primitive).

    o	showMethods() has a "smart" default for 'inherited' such that
	showMethods(<genfun>, incl = TRUE)  becomes a useful short cut.


DEPRECATED & DEFUNCT

    o	$ on an atomic vector now gives a warning that it is 'invalid'.
	It remains deprecated, but may be removed in R >= 2.7.0.

    o	storage.mode(x) <- "real" and storage.mode(x) <- "single" are
	defunct: use instead storage.mode(x) <- "double" and
	mode(x) <- "single".

    o	In package installation, SaveImage: yes is deprecated in
	favour of LazyLoad: yes.

    o	seemsS4Object (methods package) is deprecated in favour of isS4().

    o	It is planned that [[exact=TRUE]] will become the default in
	R 2.7.0.


UTILITIES

    o	checkS3methods() (invoked by R CMD check) now checks the
	arguments of methods for primitive members of the S3 group
	generics.

    o	R CMD check now does a recursive copy on the 'tests' directory.

    o	R CMD check now warns on non-ASCII .Rd files without an
	\encoding field, rather than just on ones that are definitely
	not from an ISO-8859 encoding.	This agrees with the
	long-standing stipulation in 'Writing R Extensions', and
	catches some packages with UTF-8 man pages.

    o	R CMD check now warns on DESCRIPTION files with a non-portable
	Encoding field, or with non-ASCII data and no Encoding field.

    o	R CMD check now loads all the 'Suggests' and 'Enhances'
	dependencies to reduce warnings about non-visible objects, and
	also emulates standard functions (such as shell()) on
	alternative R platforms.

    o	R CMD check now (by default) attempts to latex the vignettes
	rather than just weave and tangle them: this will give a NOTE
	if there are latex errors.

    o	R CMD check computations no longer ignore Rd \usage entries for
	functions for extracting or replacing parts of an object, so S3
	methods should use the appropriate \method{} markup.

    o	R CMD check now checks for CR (as well as CRLF) line endings in
	C/C++/Fortran source files, and for non-LF line endings in
	Makefile[.in] and Makevars[.in] in the package 'src'
	directory.  R CMD build will correct non-LF line endings in
	source files and in the make files mentioned.

    o	Rdconv now warns about unmatched braces rather than silently
	omitting sections containing them.  (Suggestion by Bill
	Dunlap, PR#9649)

	Rdconv now renders (rather than ignores) \var{} inside \code{}
	markup in latex conversion.

	R CMD  Rdconv gains a --encoding argument to set the default
	encoding for conversions.

    o	The list of CRAN mirrors now has a new (manually maintained)
	column "OK" which flags mirrors that seem to be OK, only those
	are used by chooseCRANmirror(). The now exported function
	getCRANmirrors() can be used to get all known mirrors or only
	the ones that are OK.

    o	R CMD SHLIB gains arguments --clean and --preclean to clean up
	intermediate files after and before building.

    o	R CMD config now knows about FC and FCFLAGS (used for F9x
	compilation).

    o	R CMD Rdconv now does a better job of rendering quotes in
	titles in HTML, and \sQuote and \dQuote into text on Windows.


C-LEVEL FACILITIES

    o	New utility function alloc3DArray similar to allocMatrix.

    o	The entry point R_seemsS4Object in Rinternals.h has not been
	needed since R 2.4.0 and has been removed.  Use IS_S4_OBJECT
	instead.

    o	Applications embedding R can use R_getEmbeddingDllInfo() to
	obtain DllInfo for registering symbols present in the
	application itself.

    o	The instructions for making and using standalone libRmath have
	been moved to the R Installation and Administration manual.

    o	CHAR() now returns (const char *) since CHARSXPs should no
	longer be modified in place.  This change allows compilers to
	warn or error about improper modification.  Thanks to Hervé
	Pagès for the suggestion.

    o	acopy_string is a (provisional) new helper function that
	copies character data and returns a pointer to memory
	allocated using R_alloc.  This can be used to create a copy of
	a string stored in a CHARSXP before passing the data on to a
	function that modifies its arguments.

    o	asLogical, asInteger, asReal and asComplex now accept STRSXP
	and CHARSXP arguments, and asChar accepts CHARSXP.

    o	New entry point R_GE_str2col listed in R_ext/GraphicsEngine.h
	for external graphics device developers.

    o	doKeybd and doMouseevent are now exported in GraphicsDevice.h.

    o	R_alloc now has first argument of type 'size_t' to support
	64-bit platforms (e.g. Win64) with a 32-bit 'long' type.

    o	The type of the last two arguments of getMatrixDimnames (non-API
	but mentioned in R-exts.texi and in Rinternals.h) has been
	changed to 'const char **' (from char **).

    o	R_FINITE now always resolves to the function call R_finite in
	packages (rather than sometimes substituting isfinite).	 This
	avoids some issues where R headers are called from C++ code
	using features tested on the C compiler.

    o	The advice to include R headers from C++ inside extern "C" {}
	has been changed.  It is nowadays better *not* to wrap the
	headers, as they include other headers which on some OSes
	should not be wrapped.

    o	Rinternals.h no longer includes a substantial set of C headers.
	All but ctype.h and errno.h are included by R.h which is supposed
	to be used before Rinternals.h.

    o	Including C system headers can be avoided by defining NO_C_HEADERS
	before including R headers.  This is intended to be used from
	C++ code, and you will need to include C++ equivalents such as
	<cmath> before the R headers.


INSTALLATION

    o	The 'test-Lapack' test is now part of 'make check'.

    o	The 'stat' system call is now required, along with 'opendir'
	(which had long been used but not tested for).	('make check'
	would have failed in earlier versions without these calls.)

    o	'evince' is now considered as a possible PDF viewer.

    o	'make install-strip' now also strips the DLLs in the standard
	packages.

    o	Perl 5.8.0 (released in July 2002) or later is now required.
	(R 2.4.0 and later have in fact required 5.6.1 or later.)

    o	The C function 'finite' is no longer used: we expect a C99
	compiler which will have 'isfinite'.  (If that is missing, we
	test separately for NaN, Inf and -Inf.)

    o	A script/executable 'texi2dvi' is now required on Unix-alikes:
	it is part of the texinfo distribution.

    o	Files texinfo.tex and txi-en.tex are no longer supplied in
	doc/manual (as the latest versions have an incompatible
	licence).  You will need to ensure that your texinfo and/or
	TeX installations supply them.

    o	wcstod is now required for MBCS support.

    o	There are some experimental provisions for building on Cygwin.


PACKAGE INSTALLATION

    o	The encoding declared in the DESCRIPTION file is now used as
	the default encoding for .Rd files.

    o	A standard for specifying package license information in the
	DESCRIPTION License field was introduced, see 'Writing R
	Extensions'.  In addition, files LICENSE or LICENCE in a package
	top-level source directory are now installed (so putting copies
	into the 'inst' subdirectory is no longer necessary).

    o	install.packages() on a Unix-alike now updates
	doc/html/packages.html only if packages are installed to
	.Library (by that exact name).

    o	R CMD INSTALL --clean now runs SHLIB --clean to do the clean
	up (unless there is a src/Makefile), and this will remove
	$(OBJECTS) (which might have been redefined in Makevars).

	R CMD INSTALL --preclean cleans up the sources after a
	previous installation (as if that had used --clean) before
	attempting to install.

	R CMD INSTALL will now run R CMD SHLIB in the 'src' directory
	if src/Makevars is present, even if there are no source files
	with known extensions.

    o	If there is a file src/Makefile, src/Makevars is now ignored
	(it could be included by src/Makefile if desired), and it is
	preceded by etc/Makeconf rather than share/make/shlib.mk.
	Thus the makefiles read are R_HOME/etc/Makeconf, src/Makefile
	in the package and then any personal Makevars files.

    o	R CMD SHLIB used to support the use of 'OBJS' in Makevars, but
	this was changed to 'OBJECTS' in 2001.	The undocumented
	alternative of 'OBJS' has finally been removed.

    o	R CMD check no longer issues a warning about no data sets
	being present if a lazyload db is found (as determined by the
	presence of Rdata.rdb, Rdata.rds, and Rdata.rdx in the 'data'
	subdirectory.


BUG FIXES

    o	charmatch() and pmatch() used to accept non-integer values for
	'nomatch' even though the return value was documented to be
	integer.  Now 'nomatch' is coerced to integer (rather than the
	result being coerced to the type of 'nomatch').

    o	match.call() no longer 'works' outside a function unless
	'definition' is supplied.  (Under some circumstances it used
	to 'work', matching itself.)

    o	The formula methods of boxplot, cdplot, pairs and spineplot
	now attach 'stats' so that model.frame() is visible where
	they evaluate it.

    o	Date-time objects are no longer regarded as numeric by
	is.numeric().

    o	methods("Math") did not work if 'methods' was not attached.

    o	readChar() read an extra empty item (or more than one) beyond
	the end of the source; in some conditions it would terminate
	early when reading an item of length 0.

    o	Added a promise evaluation stack so interrupted promise
	evaluations can be restarted.

    o	R.version[1:10] now nicely prints.

    o	In the methods package, prototypes are now inherited for the
	.Data "slot"; i.e., for classes that contain one of the basic
	data types.

    o	<data frame>[[i, j]] now works if 'i' is character.

    o	write.dcf() no longer writes NA fields (PR#9796), and works
	correctly on empty descriptions.

    o	pbeta(x, log.p = TRUE) now has improved accuracy in many cases,
	and so have functions depending on it such as pt(), pf() and
	pbinom().

    o	mle() had problems with the L-BFGS-B in the no-parameter case
	and consequentially also when profiling 1-parameter models
	(fix thanks to Ben Bolker).

    o	Two bugs fixed in methods that in involve the "..." argument in
	the generic function: previously failed to catch methods that
	just dropped the "..."; and use of callGeneric() with no arguments
	failed in some circumstances when "..." was a formal argument.

    o	sequence() now behaves more reasonably, although not
	back-compatibly for zero or negative input.

    o	nls() now allows more peculiar but reasonable ways of being called,
	e.g., with data=list(<uneven lengths>) or a model without variables.

    o	match.arg() was not behaving as documented when
	several.ok=TRUE (PR#9859), gave spurious warnings when 'arg'
	had the wrong length and was incorrectly documented (exact
	matches are returned even when there is more than one partial
	match).

    o	The data.frame method for split<-() was broken.

    o	The test for -D__NO_MATH_INLINES was badly broken and returned
	true on all non-glibc platforms and false on all glibc ones
	(whether they were broken or not).

    o	LF was missing after the last prompt when --quiet was used without
	--slave. Use --slave when no final LF is desired.

    o	Fixed bug in initialisation code in 'grid' package for
	determining the boundaries of shapes.  Problem reported
	by Hadley Wickham;  symptom was error message:
	"Polygon edge not found".

    o	str() is no longer slow for large POSIXct objects.  Its output
	is also slightly more compact for such objects; implementation
	via new optional argument 'give.head'.

    o	strsplit(*, fixed=TRUE), potentially iconv() and internal string
	formatting is now faster for large strings, thanks to report
	PR#9902 by John Brzustowski.

    o	de.restore() gave a spurious warning for matrices (Ben Bolker)

    o	plot(fn, xlim=c(a,b)) would not set "from" and "to" properly
	when plotting a function.  The argument lists to curve() and
	plot.function() have been modified slightly as part of the
	fix.

    o	julian() was documented to work with POSIXt origins, but did
	not work with POSIXlt ones.  (PR#9908)

    o	Dataset HairEyeColor has been corrected to agree with
	Friendly (2000): the change involves the breakdown of the
	Brown hair / Brown eye cell by Sex, and only totals over Sex
	are given in the original source.

    o	Trailing spaces are now consistently stripped from \alias{}
	entries in .Rd files, and this is now documented.  (PR#9915)

    o	.find.packages(), packageDescription() and sessionInfo()
	assumed that attached environments named "package:foo" were
	package environments, although misguided users could use such
	a name in attach().

    o	spline() and splinefun() with method = "periodic" could return
	incorrect results when length(x) was 2 or 3.

    o	getS3method() could fail if the method name contained a regexp
	metacharacter such as "+".

    o	help(<a character vector>) now uses the name and not the
	value of the vector unless it has length exactly one, so
	e.g. help(letters) now gives help on 'letters'.
	(Related to PR#9927)

    o	Ranges in chartr() now work better in CJK locales, thanks to
	Ei-ji Nakama.




	**************************************************
	*						 *
	*	       2.5 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.5.1 patched

INSTALLATION

    o	doc/manual now includes the texinfo support file epsf.tex which
	basic TeX installations often omit.


BUG FIXES

    o	Attempting to do in-memory serialization of an object requiring
	more than 1Gb might have failed.

    o	Using formals<- on a function whose body was NULL worked
	incorrectly.  (PR#9758)

    o	logb() is now strictly a wrapper for log(), so if S4 methods
	are set on log(), logb() will also dispatch on them.

    o	conflicts(where=) did not work correctly. (PR#9760)

    o	log(x, base) was intended to handle complex 'base' even for
	real 'x', but there was a typo in the code to do so.

    o	Syntax errors would sometimes misreport the error context.

    o	qt(p, df=1) is now also correct for very small p. (PR#9804)
	qt(p, df=2) ditto; also is more accurate for  0 < |p - 0.5| << 1.
	qt(*, log.p=TRUE) now is finite and monotone (again!) where possible.

    o	Several functions including those making use of printCoefmat(),
	layout() and sortedXyData() now work correctly with
	non-default settings of options("OutDec").

    o	S4 method dispatch for group generics (and %*%) failed to pass
	arguments to methods as promises and so in some circumstances
	methods could change their arguments.  (Seen for the 'Math'
	group with package Matrix.)

    o	The print() method for "ts" now handles quarterly and monthly
	series which do not start at the beginning of a quarter or
	month respectively.

    o	Deserializing raw objects saved using save(..., ascii=TRUE)
	now works correctly.

    o	ISOLatin7 encoding for postscript/PDF has been corrected.
	(PR#9845)

    o	rbind(x,y) and cbind(x,y) did not dispatch properly when x and
	y had multiple S3-style classes.

    o	The workaround for seeking on > 2Gb files did not work correctly
	on Unix-alike 32-bit systems.  (PR#9883)

    o	We had identical(NaN, NA_real_) != identical(NA_real_, NaN),
	spotted by Petr Savicky.



		CHANGES IN R VERSION 2.5.1


NEW FEATURES

    o	density(1:20, bw = "SJ") now works as bw.SJ() now tries a larger
	search interval than the default (lower, upper) if it does not
	find a solution within the latter.

    o	The output of library() (no arguments) is now sorted by library
	trees in the order of .libPaths() and not alphabetically.

    o	R_LIBS_USER and R_LIBS_SITE feature possible expansion of
	specifiers for R version specific information as part of the
	startup process.

    o	C-level warning calls now print a more informative context,
	as C-level errors have for a while.

    o	There is a new option "rl_word_breaks" to control the way the
	input line is tokenized in the readline-based terminal
	interface for object- and file-name completion.
	This allows it to be tuned for people who use their space bar
	vs those who do not.  The default now allows filename-completion
	with +-* in the filenames.

    o	If the srcfile argument to parse() is not NULL, it will be added
	to the result as a "srcfile" attribute.

    o	It is no longer possible to interrupt lazy-loading (which was
	only at all likely when lazy-loading environments), which
	would leave the object being loaded in an unusable state.
	This is a temporary measure: error-recovery when evaluating
	promises will be tackled more comprehensively in 2.6.0.


INSTALLATION

    o	'make check' will work with --without-iconv, to accommodate
	building on AIX where the system iconv conflicts with
	libiconv and is not compatible with R's requirements.

    o	There is support for 'DESTDIR': see the R-admin manual.

    o	The texinfo manuals are now converted to HTML with a style
	sheet: in recent versions of makeinfo the markup such as @file
	was being lost in the HTML rendering.

    o	The use of inlining has been tweaked to avoid warnings from
	gcc >= 4.2.0 when compiling in C99 mode (which is the default
	from configure).


BUG FIXES

    o	as.dendrogram() failed on objects of class "dendrogram".

    o	plot(type ="s") (or "S") with many (hundreds of thousands)
	of points could overflow the stack.  (PR#9629)

    o	Coercing an S4 classed object to "matrix" (or other basic class)
	failed to unset the S4 bit.

    o	The 'useS4' argument of print.default() had been broken by an
	unrelated change prior to 2.4.1.  This allowed print() and
	show() to bounce badly constructed S4 objects between
	themselves indefinitely.

    o	Prediction of the seasonal component in HoltWinters() was one
	step out at one point in the calculations.

	decompose() incorrectly computed the 'random' component for a
	multiplicative fit.

    o	Wildcards work again in unlink() on Unix-alikes (they did not
	in 2.5.0).

    o	When qr() used pivoting, the coefficient names in qr.coef() were
	not pivoted to match.  (PR#9623)

    o	UseMethod() could crash R if the first argument was not a
	character string.

    o	R and Rscript on Unix-alikes were not accepting spaces in -e
	arguments (even if quoted).

    o	Hexadecimal integer constants (e.g. 0x10L) were not being parsed
	correctly on platforms where the C function atof did not
	accept hexadecimal prefixes (as required by C99, but not
	implemented in MinGW as used by R on Windows).	(PR#9648)

    o	libRlapack.dylib on Mac OS X had no version information and
	sometimes an invalid identification name.

    o	Rd conversion of \usage treated '\\' as a single backslash in
	all but latex: it now acts consistently with the other
	verbatim-like environments (it was never 'verbatim' despite
	the documentation).

	\code{\.} is now rendered as '\.' in all formats, as
	documented (it was not the case for latex conversion).

	codoc() (and checkDocStyle() and checkDocUsage()) now apply
	the same transformations to \usage as Rd conversion does,
	so {, % and \\ in strings in usages will now be related
	correctly to the help files.

    o	rbind() failed if the only data frame had 0 rows. (PR#9657)

    o	<a data.frame>[i, j] could sometimes select the wrong column
	when j is numeric if there are duplicate column names.

    o	sample(x, size, replace=TRUE, prob) had a memory leak if
	10000 < size <= 100000.

    o	x <- cbind(1:2); rownames(x) <- factor(c("A",NA))  now longer
	segfaults.

    o	R CMD BATCH no longer assumes Sys.unsetenv() is supported (it
	is not on older Solaris systems).

    o	median() returned a logical result when it was 'NA': it now
	returns an NA of appropriate type (e.g. integer or double).

    o	grep(fixed = TRUE, perl = TRUE) ignored 'fixed', although it
	was documented to ignore 'perl'
	Same for [g]regexpr and [g]sub.

    o	getNamespaceExports("base") works again.

    o	runmed(c(), 1) no longer segfaults.

    o	qr.coef(QR, b) failed for an LAPACK-produced QR if b was
	integer or for an over-determined system.

	qr.solve() for an under-determined system produces a
	solution with 0 and not NA for columns which are unused.

    o	segments() was not handling full transparency correctly in PDF.
	(PR#9694)

	Nor was arrows().

    o	callGeneric() inside a method with extra arguments {and hence
	currently defined via .local()} now works.

    o	[g]sub(fixed=TRUE, useBytes=FALSE) could substitute in the
	wrong place in an MBCS locale.

	gregexpr() could give incorrect answers in MBCS locales for
	perl = TRUE or fixed = TRUE (unless useBytes = TRUE).

    o	The legacy quartz() device no longer crashes in locator()
	if the user attempts to close the window.

    o	"CGGStackRestore: gstack underflow" warning is no longer shown
	in legacy quartz() device.

    o	formatC() now limits 'digits' to 50 to avoid problems in
	C-level sprintf in some OSes.

    o	seq.int(x, y, by=z) gave 'x' (and not an error) if
	0 > (y-x)/z > -1.

    o	promptClass() now lists methods, including those for generics in
	other attached packages.

    o	Connection-related functions such as readBin() no longer crash
	when supplied with a non-connection object.

    o	as.character.srcref() didn't handle bad srcref objects cleanly.

    o	predict.nls() no longer requires 'newdata' to contain exactly
	the variable names needed to fit the model: variables used on
	the LHS only are no longer required and further variables are
	allowed.

    o	plot.hclust() had a 'out by one' error, and ignored the last
	object when computing the window region (and could overrun
	arrays).

    o	deriv() was creating results with double (and not integer) dims.

    o	The unserialize code (e.g. as called by load()) looked for a
	function findPackageEnv() to set a saved package environment.
	This was missing, but is now supplied.

    o	[cr]bind could segfault when creating a list matrix result.
	(Reported by Martin Morgan.)

    o	besselI(x, nu, exp=TRUE) and besselY(x, nu) could give wrong
	answers for nu < 0. (Reported by Hiroyuki Kawakatsu.)

    o	[g]sub could confuse a trailing byte '\' for a backreference
	in MBCSs where '\' can occur as a trailing byte (not UTF-8 nor
	EUC-JP, but SJIS and the CJK character sets used on Windows).
	(PR#9751)



		CHANGES IN R VERSION 2.5.0


USER-VISIBLE CHANGES

    o	apropos(x) and find(x) now both only work for character 'x',
	and hence drop all non-standard evaluation behaviour.

    o	Data frames can have 'automatic' row names which are not
	converted to dimnames by as.matrix().  (Consequently, e.g.,
	t(.)  for such data frames has NULL column names.)  This
	change leads to memory reductions in several places, but can
	break code which assumes character dimnames for data frames
	derived from matrices.

	No existing R object is regarded as having 'automatic' row
	names, and it may be beneficial to recreate such objects via
	read.table() or data.frame().

    o	Using $ on an atomic vector now raises a warning, as does use
	on an S4 class for which a method has not been defined.

    o	The Unix-alike readline terminal interface now does
	command-completion for R objects, incorporating the
	functionality formerly in package 'rcompletion' by Deepayan
	Sarkar.	 This can be disabled by setting the environment
	variable R_COMPLETION=FALSE when starting R (e.g. in
	~/.Renviron).  (Note that when this is enabled, filename
	completion no longer works for file paths containing R
	operators such as '+' and '-'.)


NEW FEATURES

    o	abbreviate() no longer has an 8191 byte limit on the size of
	strings it can handle.

    o	abs(x) now returns integer for integer or logical arguments.

    o	apropos() has a new argument 'ignore.case' which defaults to
	TRUE, potentially matching more than previously, thanks to a
	suggestion by Seth Falcon.

    o	args(), str() and print() now give the argument lists of primitive
	functions.

    o	as.matrix() gains the '...' argument that several packages have
	assumed it always had (and S-PLUS has).

    o	Manipulation of integers as roman numerals via as.roman() in
	package utils.

    o	attr() no longer treats name = NA_character_ as meaning
	name = "NA".

    o	binom.test() now allows a 'fuzz' for calculated integer values
	in its x and n arguments.

    o	boxplot(*, notch = TRUE) now warns when notches are outside
	hinges; related to PR#7690.

    o	New function callCC() providing a downward-only version of
	Scheme's call with current continuation.

    o	capabilities() now has a "profmem" entry indicating whether
	R has been compiled with memory profiling.

    o	colnames<-() and rownames<-() now handle data frames explicitly,
	so calling colnames<- on a data frame no longer alters the
	representation of the row names.

    o	commandArgs() has a new 'trailingOnly' argument to be used in
	conjunction with --args.

    o	contour() now passes graphical parameters in '...' to axis()
	and box().

    o	New data set 'crimtab' on Student(1908)'s 3000 criminals.

    o	cut.default() has a new argument 'ordered_result'.

    o	.deparseOpts() has two new options: "keepNA" to ensure that
	different types (logical, integer, double, character and
	complex) of NAs are distinguished, and "S_compatible" to
	suppress the use of R-specific features such as 123L and to
	deparse integer values of a double vector with a trailing
	decimal point.

	The 'keepInteger' option now uses the suffix 'L' rather than
	as.integer() where possible (unless all entries are NA or
	"S_compatible" is also set).

	Other deparse options can now be added to "all" (which has not
	for some time actually switched on all options).

	Integer sequences m:n are now deparsed in that form.

    o	deparse() and dput() now include "keepInteger" and "keepNA" in
	their defaults for the 'control' argument.

    o	detach() now takes another argument, unload, which indicates
	whether or not to unload the package and then only cleans
	up the S4 methods if the package successfully unloads.

    o	There are new constants NA_integer_, NA_real_, NA_complex_ and
	NA_character_ to denote NAs of those types, and they will be
	used in deparsing in place of as.integer(NA) etc unless
	.deparseOpts() includes "S_compatible".

    o	dev.print() now recognizes 'screen devices' as all those with
	an enabled display list, rather than a hard-coded set.

    o	Objects of class "difftime" are now handled more flexibly. The
	units of such objects can now be accessed via a units()
	function, which also has a replacement form, and there are
	conversion methods to and from numeric, which also allow the
	specification of units.	 Objects of this class can also be
	stored in data frames now.  A format() method has been added,
	and the print method was revised.

    o	New function environmentName() to give the print name of
	environments such as "namespace:base".
	This is now used by str().

    o	New function env.profile() provides R level access to summary
	statistics on environments.  In a related patch, new.env()
	now allows the user to specify an initial size for a hashed
	environment.

    o	file() can read the X11 clipboard selection as "X11_clipboard"
	on suitable X11-using systems.

    o	file("stdin") is now recognized, and refers to the process's
	'stdin' file stream whereas stdin() refers to the console.
	These may differ, for example for a GUI console, an embedded
	application of R or if --file= has been used.

    o	file_test() is now also available in package utils.
	(It is now private in package tools.)

    o	file.show() gains an 'encoding' argument.

    o	New functions formatUL() and formatOL() in package utils for
	formatting unordered (itemize) and ordered (enumerate) lists.

    o	The statistics reported when gcinfo(TRUE) are now of the amounts
	used (in Mb) and not of the amounts free (which are not really
	relevant when there are no hard limits, only gc trigger points).

    o	New function get_all_vars() to retrieve all the
	(untransformed) variables that the default method of
	model.frame() would use to create the model frame.

    o	interaction() has a new argument 'lex.order'.

    o	initialize() (in methods) now tries to be smarter about
	updating the new instance in place, thereby reducing
	copying.

    o	install.packages(dependencies = NA) is a new default, which is
	to install essential dependencies when installing from
	repositories to a single library.  As a result of this change,
	update.packages() will install any new dependencies of the
	packages it is updating (alongside the package in the same
	library tree).

	If 'lib' is not specified or is specified of length one and
	the chosen location is not a writable directory,
	install.packages() offers to create a personal library
	directory for you if one does not already exist, and to
	install there.

    o	is.atomic, is.call, is.character, is.complex, is.double (== is.real),
	is.environment, is.expression, is.function, is.integer,
	is.list, is.logical, is.null, is.object, is.pairlist,
	is.recursive, is.single and is.symbol (== is.name) are no
	longer internally S3 generic, nor can S4 methods be written
	for them.

	The "factor" methods of is.integer and is.numeric have been
	replaced by internal code.

    o	Added is.raw() for completeness.

    o	l10n_info() also reports if the current locale is Latin-1.

    o	levels<-(), names() and names<-() now dispatch internally for
	efficiency and so no longer have S3 default methods.

    o	.libPaths() now does both tilde and glob expansion.

    o	Functions lm(), glm() loess(), xtabs() and the default method
	of model.frame() coerce their 'formula'	argument (if supplied)
	to a formula.

    o	max(), min() and range() now work with character vectors.

    o	message() has a new argument 'appendLF' to handle messages
	with and without newlines.  There is a new message class
	packageStartupMessage() that can be suppressed separately.

    o	A new function, method.skeleton() writes a skeleton version of
	a call to setMethod() to a file, with correct arguments and
	format, given the name of the function and the method signature.

    o	mode<- and storage.mode<- do slightly less copying.

    o	nls.control(* , printEval = FALSE, warnOnly = FALSE) are two new
	options to help better analyze (non-)convergence of nls(),
	thanks to Kate Mullen.

	nls() and summary(nls()) now contain more information and also
	print information about convergence.

    o	options(device = ) now accepts a function object as well as
	the name of a function.

    o	pdf() supports new values for 'paper' of "US" (same as
	"letter"), "a4r" and "USr" (the latter two meaning rotated to
	landscape).  postscript() also accepts paper = "US".

    o	persp() now respects the graphical pars 'cex.axis', 'cex.lab',
	'font.axis' and 'font.lab'.

    o	New faster internal functions pmax.int() and pmin.int() for
	inputs which are atomic vectors without classes (called by
	pmax/pmin where applicable).

	pmin/pmax are now more likely to work with classed objects:
	they work with POSIXlt datetimes, for example.

    o	postscript() now by default writes grey colors (including black
	and white) via 'setgray', which gives more widely acceptable
	output.	 There are options to write pure RGB, CMYK or gray via
	the new argument 'colormodel'.

    o	rbind.data.frame() now ignores all zero-row inputs, as well as
	zero-column inputs (which it used to do, undocumented).	 This
	is because read.table() can create zero-row data frames with
	NULL columns, and those cannot be extended.

    o	readChar() and writeChar() can now work with a raw vector.

    o	read.table(), write.table() and allies have been moved to package
	utils.

    o	rgb() now accepts the red, green and blue components in a
	single matrix or data frame.

    o	New utility function RShowDoc() in package 'utils' to find and
	display manuals and other documentation files.

    o	New .row_names_info() utility function finds the number of rows
	efficiently for data frames; consequently, dim.data.frame()
	has become very fast for large data frames with 'automatic'
	row names.

    o	RSiteSearch() now also allows to search postings of the 'R-devel'
	mailing list.

    o	screeplot() is now (S3) generic with a default method, thanks
	to a patch from Gavin Simpson.

    o	Experimental 'verbose' argument for selectMethod().  Might be
	replaced later by a better interface for method selection
	inspection.

    o	Added links to source files to the parsing routines, so that
	source() can now echo the original source and comments (rather
	than deparsing).  This affects example() and Sweave() as well.

    o	stack() and unstack() have been moved to package utils.

    o	strptime() now sets the "tzone" attribute on the result if
	tz != "".

    o	str.default() typically prints fewer entries of logical vectors.

    o	The RweaveLatex driver for Sweave() now supports two new
	options: expand=FALSE, to show chunk references in the output,
	and concordance=TRUE, to output the concordance between input
	and output lines.

    o	system() now takes the same set of arguments on all platforms,
	with those which are not applicable being ignored with a
	warning.  Unix-alikes gain 'input' and 'wait', and Windows
	gains 'ignore.stderr'.

    o	system.time() and proc.time() now return an object of class
	"proc_time" with a print() method that returns a POSIX-like
	format with names.

    o	Sys.getenv() has a new argument 'unset' to allow unset and set
	to "" to be distinguished (if the OS does).  The results of
	Sys.getenv() are now sorted (by name).

    o	New function Sys.glob(), a wrapper for the POSIX.2 function
	glob(3) to do wildcard expansion (on systems which have it,
	plus an emulation on Windows).

    o	Sys.setenv() is a new (and preferred) synonym for Sys.putenv().
	The internal C code uses the POSIX-preferred 'setenv' rather
	than 'putenv' where the former is available.

    o	New function Sys.unsetenv() to remove environment variables
	(on systems where unsetenv is implemented or putenv can remove
	variables, such as on Windows).

    o	text(), mtext(), strheight(), strwidth(), legend(), axis(),
	title(), pie(), grid.text() and textGrob() all attempt to
	coerce non-language annotation objects (in the sense of is.object)
	to character vectors.  This is principally intended to cover
	factors and POSIXt and Date objects, and is done via the
	new utility function as.graphicsAnnot() in package grDevices.

    o	tcltk:tk_select.list() now chooses the width to fit the widest item.

    o	{re,un}tracemem() are now primitives for efficiency and so
	migrate from 'utils' to 'base'.

    o	union(), interect(), setdiff() and setequal() now coerce their
	arguments to be vectors (and they were documented only to
	apply to vectors).

    o	uniroot() now works if the zero occurs at one of the ends of
	the interval (suggestion of Tamas Papp).

    o	There is a new function View() for viewing matrix-like
	objects in a spreadsheet, which can be left up whilst R is
	running.

    o	New function withVisible() allows R level access to the
	visibility flag.

    o	zip.file.extract() has been moved to package utils.


    o	A few more cases of subassignment work, e.g. <raw>[] <- <list>
	and <vector>[] <- <expression>, with suitable coercion of the LHS.

    o	There is a warning if \ is used unnecessarily in a string when
	being parsed, e.g. "\." where probably "\\." was intended.
	("\." is valid, but the same as ".".)  Thanks to Bill Dunlap
	for the suggestion.

    o	Introduced the suffix L for integer literals to create
	integer rather than numeric values, e.g. 100L, 0x10L, 1e2L.

    o	Set the parser to give verbose error messages in case of
	syntax errors.

    o	The class "LinearMethodsList" has been extended and will be
	used to create list versions of methods, derived from the
	methods tables (environments).	The older recursive
	"MethodsList" class will be deprecated (by the release of
	2.5.0 if possible).

    o	There are more flexible ways to specify the default library
	search path.  In addition to R_LIBS and .Library, there are
	.Library.site (defaults to R_HOME/site-library) and
	R_LIBS_USER (defaults to a platform- and version-specific
	directory in ~/R).  See ?.libPaths for details.

    o	LAPACK has been updated to version 3.1.0.  This should cause
	only small changes to the output, but do remember that the sign
	of eigenvectors (and principal components) is indeterminate.

    o	PCRE has been updated to version 7.0.

    o	Several functions handle row names more efficiently:

	- read.table() and read.DIF() make use of integer row names
	  where appropriate, and avoid at least one copy in assigning
	  them.

	- data.frame() and the standard as.data.frame() methods avoid
	  generating long dummy row names and then discarding them.

	- expand.grid() and merge() generate compact 'automatic' row
	  names.

	- data.matrix() and as.matrix.data.frame() have a new argument
	  'rownames.force' that by default drops 'automatic' row names.

    o	<data frame>[i, j] is substantially more memory-efficient when
	only a small part of the data frame is selected, especially
	when (part of) a single column is selected.

    o	Command-line R (and Rterm.exe under Windows) accepts the options
	'-f filename', '--file=filename' and '-e expression' to follow
	other script interpreters.  These imply --no-save unless
	--save is specified.

    o	Invalid bytes in character strings in an MBCS now deparse/print
	in the form "\xc1" rather than "<c1>", which means they can be
	parsed/scanned.

    o	Printing functions (without source attributes) and expressions
	now preserves integers (using the L suffix) and NAs (using
	NA_real_ etc where necessary).

    o	The 'internal' objects .helpForCall, .tryHelp and topicName are
	no longer exported from 'utils'.

    o	The internal regex code has been upgraded to glibc 2.5 (from 2.3.6).

    o	Text help now attempts to display files which have an \encoding
	section in the specified encoding via file.show().

    o	R now attempts to keep track of character strings which are
	known to be in Latin-1 or UTF-8 and print or plot them
	appropriately in other locales.	 This is primarily intended
	to make it possible to use data in Western European languages
	in both Latin-1 and UTF-8 locales.  Currently scan(),
	read.table(), readLines(), parse() and source() allow
	encodings to be declared, and console input in suitable
	locales is also recognized.

	New function Encoding() can read or set the declared encodings
	for a character vector.

    o	There have been numerous performance improvements to the data
	editor on both Windows and X11.	 In particular, resizing the
	window works much better on X11.

    o	Packages graphics and grid no longer require grDevices, as
	they might be used only with third-party devices.


DEPRECATED & DEFUNCT

    o	symbol.C() and symbol.For() are defunct, and have been replaced
	by wrappers that give a warning.

    o	Calling a builtin function with an empty argument is now always
	an error.

    o	The autoloading of ts() is defunct.

    o	The undocumented reserved word GLOBAL.ENV has been removed.
	(It was yet another way to get the value of the symbol
	.GlobalEnv.)

    o	The deprecated behaviour of structure() in adding a class when
	specifying with "tsp" or "levels" attributes is now defunct.

    o	unix() is now finally defunct, having been deprecated for
	at least seven years.

    o	Sys.putenv() is now deprecated in favour of Sys.setenv(),
	following the POSIX recommendation.

    o	Building R with --without-iconv is deprecated.

    o	Using $ on an atomic vector is deprecated (it was previously
	valid and documented to return NULL).

    o	The use of storage.mode<- for other than standard types (and
	in particular for value "single") is deprecated: use mode<-
	instead.


INSTALLATION

    o	A suitable iconv (e.g. from glibc or GNU libiconv) is
	required.  For 2.5.x only you can build R without it by
	configuring using --without-iconv.

    o	There is support again for building on AIX (tested on 5.2 and 5.3)
	thanks to Ei-ji Nakama.

    o	Autoconf 2.60 or later is used to create 'configure'.  This
	makes a number of small changes, and incorporates the changes
	to the detection of a C99-compliant C compiler backported for
	2.4.1.

    o	Detection of a Java development environment was added such that
	packages don't need to provide their own Java detection. Newly
	added make variables are JAVAC, JAVAH, JAR and JAVA_CPPFLAGS.

	R CMD javareconf was updated to look for the corresponding
	Java tools as well.

	In addition, Java detection honors user-supplied environment
	variables JAVA_CPPFLAGS, JAVA_LIBS and JAVA_LD_LIBRARY_PATH.

    o	Added workaround for reported non-POSIX sh on OSF1.  (PR#9375)

    o	'make install-strip' now works, stripping the executables and
	also the shared libraries and modules on platforms where
	'libtool' knows how to do so.

    o	Building R as a shared library and standalone nmath now
	installs pkg-config files 'libR.pc' and 'libRmath.pc' respectively.

    o	Added test for insufficiently complete implementation of sigaction.


C-LEVEL FACILITIES

    o	Functions str2type, type2char and type2str are now available in
	Rinternals.h.

    o	Added support for Objective C in R and packages (if available).

    o	R_ParseVector() has a new 4th argument 'SEXP srcfile' allowing
	source references to be attached to the returned expression list.

    o	Added ptr_R_WriteConsoleEx callback which allows consoles to
	distinguish between regular output and errors/warnings.
	To ensure backward compatibility it is only used if
	ptr_R_WriteConsole is set to NULL.


UTILITIES

    o	Additional Sweave() internal functions are exported to help
	writing new drivers, and RweaveLatexRuncode() is now created
	using a helper function (all from a patch submitted by Seth
	Falcon).

    o	The following additional flags are accessible from R CMD config:
	OBJC, OBJCFLAGS, JAR, JAVA, JAVAC, JAVAH, JAVA_HOME, JAVA_LIBS
	and JAVA_CPPFLAGS.

    o	R CMD build now takes the package name from the DESCRIPTION
	file and not from the directory.  (PR#9266)

    o	checkS3methods() (and hence R CMD check) now checks agreement
	with primitive internal generics, and checks for additional
	arguments in methods where the generic does not have a '...'
	argument.

	codoc() now knows the argument lists of primitive functions.

    o	R CMD INSTALL and R CMD REMOVE now use as the default library
	(if -l is not specified) the first library that would be used
	if R were run in the current environment (and they run R to
	find it).

    o	There is a new front-end Rscript which can be used for #!
	scripts and similar tasks.  See help("Rscript") and 'An
	Introduction to R' for further details.

    o	R CMD BATCH (not Windows) no longer prepends
	'invisible(options(echo = TRUE))' to the input script.	This
	was the default unless --slave is specified and the latter is
	no longer overridden.

	On all OSes it makes use of the -f argument to R, so
	file("stdin") can be used from BATCH scripts.

	On all OSes it reports proc.time() at the end of the script
	unless q() is called with options to inhibit this.

    o	R CMD INSTALL now prepends the installation directory (if
	specified) to the library search path.

    o	Package installation now re-encodes R files and the NAMESPACE
	file if the DESCRIPTION file specifies an encoding, and sets
	the encoding used for reading files in preparing for
	LazyData.  This will help if a package needs to be used in
	(say) both latin1 and UTF-8 locales on different systems.

    o	R CMD check now reports on non-ASCII strings in datasets.
	(These are a portability issue, which can be alleviated by
	marking their encoding: see 'Writing R Extensions'.)

    o	Rdiff now converts CRLF endings in the target file, and
	converts UTF-8 single quotes in either to ASCII quotes.

    o	New recommended package 'codetools' by Luke Tierney provides
	code-analysis tools.  This can optionally be used by 'R CMD
	check' to detect problems, especially symbols which are not
	visible.

    o	R CMD config now knows about LIBnn .

    o	New recommended package 'rcompgen' by Deepayan Sarkar
	provides support for command-line completion under the Unix
	terminal interface (provided readline is enabled) and the
	Windows Rgui and Rterm front ends.


BUG FIXES

    o	gc() can now report quantities of 'Vcells' in excess of 16Gb on
	64-bit systems (rather than reporting NA).

    o	Assigning class "factor" to an object now requires it has
	integer (and not say double) codes.

    o	structure() ensures that objects with added class "factor" have
	integer codes.

    o	The "formula" and "outer" attributes of datasets 'ChickWeight',
	'CO2', 'DNase', 'Indometh', 'Loblolly', 'Orange' and 'Theoph'
	now have an empty environment and not the environment used to
	dump the datasets in the package.

    o	Dataset 'Seatbelts' now correctly has class c("mts", "ts").

    o	str() now labels classes on data frames more coherently.

    o	Several 'special' primitives and .Internals could return
	invisibly if the evaluation of an argument led to the
	visibility flag being turned off.  These included
	as.character(), as.vector(), call(), dim(), dimnames(),
	lapply(), rep(), seq() and seq_along().	 Others (e.g. dput()
	and print.default()) could return visibly when this was not
	intended.

    o	Several primitives such as dim() were not checking the number
	of arguments supplied before method dispatch.

    o	Tracing of primitive functions has been corrected.  It should
	now be the case that tracing either works or is not allowed
	for all primitive functions. (Problems remain if you make a
	primitive into a generic when it is being traced.  To be fixed
	later.)

    o	max.col() now omits infinite values in determining the
	relative tolerance.

    o	R CMD Sweave and R CMD Stangle now respond to --help and --version
	like other utilities.

    o	.libPaths() adds only existing directories (as it was
	documented to, but could add non-directories).

    o	setIs() and setClassUnion() failed to find some existing
	subclasses and produced spurious warnings, now fixed.

    o	data.frame() ignored 'row.names' for 0-column data frames, and
	no longer treats an explicit row.names=NULL differently from
	the default value.

    o	identical() looked at the internal structure of the
	'row.names' attribute, and not the value visible at R level.

    o	abline(reg) now also correctly works with intercept-only lm
	models, and abline() warns more when it's called illogically.

    o	warning() was truncating messages at
	getOption("warning.length") - 1 (not as documented), with no
	indication.  It now appends '[... truncated]'.

    o	Stangle/Sweave were throwing spurious warnings if options
	'result' or 'strip.white' were unset.

    o	all.equal() was ignoring 'check.attributes' for list and
	expression targets, and checking only attributes on raw vectors.
	Logical vectors were being compared as if they were numeric,
	(with a mean difference being quoted).

    o	Calculating the number of significant digits in a number was
	itself subject to rounding errors for digits >= 16.  The
	calculation has been changed to err on the side of slightly
	too few significant digits (but still at least 15) rather than
	far too many.  (An example is print(1.001, digits=16).)

    o	unlink() on Unix-alikes failed for paths containing spaces.

    o	substr() and friends treated NA 'start' or 'stop' incorrectly.

    o	merge(x, y, all.y = TRUE) would sometimes incorrectly return
	logical columns for columns only in y when there were no
	common rows.

    o	read.table(fn, col.names=) on an empty file returned NULL
	columns, rather than logical(0) columns (which is what results
	from reading a file with just a header).

    o	grid.[xy]axis(label=logical(0)) failed.

    o	expression() was unnecessarily duplicating arguments.

    o	as.expression(<list>) returned a single-element expression
	vector, which was not compatible with S: it now copies lists
	element-by-element.

    o	supsmu(periodic = TRUE) could segfault.	 (PR#9502, detection
	and patch by Bill Dunlap.)

    o	pmax/pmin called with only logical arguments did not coerce to
	numeric, although they were documented to do so (as max/min
	do).

    o	methods() did not know that cbind() and rbind() are internally
	generic.

    o	dim(x) <- NULL removed the names of x, but this was always
	undocumented.  It is not clear that it is desirable but it is
	S-compatible and relied on, so is now documented.

    o	which(x, arr.ind = TRUE) did not return a matrix (as
	documented) if 'x' was an array of length 0.

    o	C-level duplicate() truncated CHARSXPs with embedded nuls.

    o	Partial matching of attributes was not working as documented
	in some cases if there were more than two partial matches or
	if "names" was involved.

    o	data(package=character(0)) was not looking in ./data as
	documented.

    o	summary.mlm() failed if some response names were "" (as can
	easily happen if cbind() is used).

    o	The postscript() and pdf() drivers shared an encoding list
	but used slightly different formats.  This caused problems if
	both were used with the same non-default encoding in the same
	session.  (PR#9517)

    o	The data editor was not allowing Inf, NA and NaN to be entered
	in numerical columns.  It was intended to differentiate
	between empty cells and NAs, but did not do so: it now does
	so for strings.

    o	supsmu() could segfault if all cases had non-finite values.
	(PR#9519)

    o	plnorm(x, lower.tail=FALSE) was returning the wrong tail for
	x <= 0.	 (PR#9520)

    o	which.min() would not report a minimum of +Inf, and
	analogously for which.max().  (PR#9522)

    o	'R CMD check' could fail with an unhelpful error when checking
	Rd files for errors if there was only one file and that had a
	serious error.	(PR#9459)

    o	try() has been reimplemented using tryCatch() to solve two
	problems with the original implementation: (i) try() would run
	non-NULL options("error") expressions for errors within a try, and
	(ii) try() would catch user interrupts.

    o	str(obj) could fail when obj contained a dendrogram.

    o	Using <data frame>[, <last column>] <- NULL failed (PR#9565)

    o	choose(n, k) could return non-integer values for integer n and
	small k on some platforms.

    o	nclass.scott(x) and nclass.FD(x) no longer return NaN when var(x)
	or IQR(x) (respectively) is zero.

	hist() now allows breaks = 1 (which the above patch will
	return), but not breaks = Inf (which gave an obscure error).

    o	strptime("%j") now also works for the first days of Feb-Dec.
	(PR#9577)

    o	write.table() now recovers better if 'file' is an unopened
	connection.  (It used to open it for both the column names and
	the data.)

    o	Fixed bug in mosaicplot(sort=) introduced by undocumented
	change in R 2.4.1 (changeset r39655).

    o	contr.treatment(n=0) failed with a spurious error message.
	(It remains an error.)

    o	as.numeric() was incorrectly documented: it is identical to
	as.double.

    o	jitter(rep(-1, 3)) gave NaNs. (PR#9580)

    o	max.col() was not random for a row of zeroes. (PR#9542)

    o	ansari.test(conf.int=TRUE, exact=FALSE) failed.

    o	trace() now works on S3 registered methods, by modifying the
	version in the S3 methods table.

    o	rep(length=1, each=0) segfaulted.

    o	postscript() could overflow a buffer if used with a long
	'command' argument.

    o	The internal computations to copy complete attribute lists did
	not copy the flag marking S4 objects, so the copies no longer
	behaved like S4 objects.

    o	The C code of nlminb() was altering a variable without
	duplicating it.	 (This did not affect nlminb() but would have
	if the code was called from a different wrapper.)

    o	smooth(kind = "3RS3R") (the current default) used .C(DUP =
	FALSE) but altered its input argument.	(This was masked by
	duplication in as.double.)

    o	The signature for the predefined S4 method for as.character()
	was missing '...' .

    o	readBin(<raw vector>) could read beyond the end of the vector
	when size-changing was involved.

    o	The C entry point PrintValue (designed to emulate auto-printing)
	would not find show() for use on S4 objects, and did not have
	the same search path (for show(), print() and print() methods)
	as auto-printing.  Also, auto-printing and print() of S4
	objects would fail to find 'show' if the methods name space was
	loaded but the package was not attached (or otherwise not in
	the search path).

    o	print() (and auto-printing) now recognize S4 objects even when
	'methods' is not loaded, and print a short summary rather than
	dump the internal structure.

    o	Sweave and Stangle had problems due to partial matching of code
	chunk names when run with split=TRUE.

    o	install.packages() on a source package now ensures that
	R CMD INSTALL sees the same library search path as
	install.packages() did when computing dependencies.

    o	density() now ensures its 'y' values are non-negative. (PR#8876)

    o	is.finite() and is.infinite() (and many other primitives)
	are not internally generic and so do not support S4 methods,
	which can no longer be set. (PR#7951)

    o	nls(algorithm = "port") now accepts a list 'start' argument,
	as for the other methods (and as documented).

    o	Standard errors from the "ar" method of predict() could be
	wrong for the last p predictions for models near
	non-stationarity. (PR#9614)




	**************************************************
	*						 *
	*	       2.4 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.4.1 patched

NEW FEATURES

    o	The Simplified Chinese translations have been completed.


BUG FIXES

    o	co.intervals() sometimes failed to cover the largest value.

    o	tempfile() is now random across sessions as well as within a
	session.  (On some systems it would give the same hex suffix
	at the start of each session.)

    o	Added infinite recursion test to internal function isMissing.
	(PR#9426)

    o	The "Date" and "POSIXt" methods for cut() were not choosing
	the first day of the year for breaks = "years".
	(In part, PR#9433.)

    o	R is now able to deparse/print invalid multibyte strings in
	MBCS locales (such as UTF-8) using hex escapes.	 This means
	that e.g. demo(Hershey) works in all such locales.

    o	optimize() could give incorrect answers in some rare problems
	with exact symmetry about the midpoint of the interval
	supplied.  (PR#9438)

    o	The residuals from an lm() fit with no coefficients but an
	offset were incorrect.

    o	oneway.test() was expecting a literal formula and did not
	accept a variable containing a formula.

    o	The legacy Quartz device (used by console R) displayed its
	window outside the screen estate in some dual-head setups.
	Now it will be always displayed in the center of the main
	screen.

    o	read.ftable() was not functional on non-seekable connections
	such as URLs.

    o	Some large memory allocations could cause segfaults or
	crashes (e.g. followup to PR#9557).

    o	Sweave() would drop characters from the end of chunk names
	ending in "R".	(PR#9567)

    o	library(), i.e. its internal checkConflicts(), now (again) prints
	"The following object(s) are masked .." only once per masked package.

    o	methods:::cbind(x) {one argument} now works, calling cbind2(x)
	when 'x' is an S4 object.



		CHANGES IN R VERSION 2.4.1


INSTALLATION

    o	The extraction of info from Subversion for an SVN checkout now
	also works for svn >= 1.4.0.  However, on Windows the 'Last
	Changed Date' will be in the local timezone, and not in GMT as
	previously.

    o	configure uses code borrowed from autoconf 2.60 to try harder to
	ensure that a C99-compliant compiler is used.  (It does so by
	appending to CC.)  This avoids problems with systems such as FC5
	which override CFLAGS and thereby lose flags such as -std=gnu99.


NEW FEATURES

    o	rainbow(), heat.colors(), terrain.colors(), topo.colors() and
	cm.colors() all gain an 'alpha' argument to be passed to hsv().

    o	dput() will give an incorrect representation of the row names
	of a data frame with integer row names.	 This is now corrected
	when the object is recreated.


C-LEVEL FACILITIES

    o	Using STRICT_R_HEADERS applies to more reported clashes with
	Windows headers, including Calloc and Realloc.	These and
	Free need to be prefixed by R_ when STRICT_R_HEADERS is defined.


DEPRECATED & DEFUNCT

    o	The previously undocumented behaviour of structure() in adding a
	class when specifying "tsp" or "levels" attributes is now
	deprecated (with a warning).


BUG FIXES

    o	Fixed warning() to use .dfltWarn intead of .dfltStop for default
	handling (PR#9274).

    o	R would slow down when the product of the length of a vector and
	the length of a character vector used to subset it exceeded 2^31.
	(PR#9280)

    o	merge() now allows zero-row data frames.

    o	add1.lm() had been broken by other changes for weighted fits.

    o	axis.POSIXct() would sometimes give the wrong labels.

    o	Help for a method call would fail. (PR#9291)

    o	gzfile() returned an object of class "file" not "gzfile". (PR#9271)

    o	load()ing from a connection had a logic bug in when it closed
	the connection. (PR#9271)

    o	The lowess() algorithm is unstable if the MAD of the residuals
	becomes (effectively) zero: R now terminates the iterations at
	that point.  (This may result in quite different answers.)

	The 'delta' argument was incorrectly documented.  (PR#9264)

    o	abbreviate() would only work for strings of up to 8191 bytes,
	but this was not checked.  Now longer strings are errors.

    o	Drawing X11 rotated text was buggy for VERY small (negative)
	angle of rotation.  Reported by Ben Bolker. (PR#9301)

    o	The X11 data editor would crash in an MBCS locale if R was
	compiled with FC's CFLAGS that add buffer overflow and
	stack-smashing detection.

    o	rect() was not accepting border=NA in some cases involving
	cross-hatching.

    o	Fixes to S4 group generics to ensure that the correct number of
	active arguments are in the signature of the group and all
	members.  Also a fix to keep the 'groupMembers' slot up to date.

    o	S4 group generic "Logic" (with '&', '|', but not '!') has been
	created, following the green book (apart from '!').

    o	removeClass() now takes care to remove any subclass references
	to the deleted class.

    o	mle() (in stats4) might not have worked as intended when the
	order of parameters in 'start' differed from that in the
	log-likelihood.	 (PR#9313)

    o	dotchart() now properly restores par() settings after itself.

    o	system() on Mac OS X was blocking arbitrary signals during the
	call although only SIGPROF was meant to be blocked.

    o	methods cached via callNextMethod() and (sometimes) as() were
	being cached as directly specified although in fact they were
	inherited.  Caused problems in later search for inherited methods.

    o	str() works properly for method definitions and other S4-classed
	function objects.

    o	JAVA_LIBS are now set correctly on MacOS X.

    o	Fix null-termination issue suspected of causing crash with Fedora
	Extra RPMS (PR#9339, Justin Harrington, analysis and fix from Bill
	Dunlap).

    o	Name spaces restored via a saved session silently failed to cache
	their methods because the methods package was not yet
	attached.  Fixed by attaching methods before restoring data.

    o	rbind()ing a list to a data frame generated invalid row names,
	which were an error in 2.4.0. (PR#9346)

    o	boxplot.stats(x) now returns the correct minimum instead of an
	error for x <- c(1,Inf,Inf,Inf), and hence boxplot(x) "works".

    o	promptClass() now uses \linkS4class{<ClassName>} instead of
	of \link{<ClassName>-class}.

    o	gc() no longer reports nonsense values for the number of used
	Vcells if the true value exceeds 2^31 (and hence over 16Gb of
	heap is in use): it now reports NA. (PR#9345)

    o	rapply() now detects more user errors in supplying arguments. (PR#9349)

    o	boxplot() was ignoring argument 'boxfill'. (PR#9352)

    o	plot.lm(which = 6, id.n = 0) did not work. (PR#9333)

    o	.deparseOpts("delayPromises") was not matching the C code,
	returning 64 rather than 32.

    o	bxp() could use partial matching on 'pars' when finding
	defaults for some of its parameters, e.g. a setting of 'cex.axis'
	in 'pars' or inline was used to set a default for 'outcex'.

    o	acf() now allows lag.max = 0 except when type="partial", and
	forces the lag 0 autocorrelation to 1. (PR#9360)

    o	hist(*, include.lowest=., right=., plot=FALSE) does not warn
	anymore, (PR#9356) and more.

    o	Some bugs in caching superclass/subclass relations and in
	removing those relations on detach and on removeClass() have
	been fixed.

    o	readBin() could return one too many strings if 'n' was an
	over-estimate. (PR#9361)

    o	A request for an opaque colour in the pdf() device after a
	translucent one did not set the transparency back to opaque in
	2.4.0.

	Semi-transparent background colours were not being plotted on
	the pdf() device.

    o	plot.lm(which=5) in the case of constant leverage re-ordered
	the factor levels but not the residuals, so the labelling by
	factor level was often incorrect.

    o	packBits() was not accepting a logical argument. (PR#9374)

    o	make install was omitting doc/FAQ and doc/RESOURCES.

    o	A two-sample t.test(x, y, var.equal=TRUE) did not allow one of the
	groups to be of size one.

    o	The "ts" method for print() failed on some corrupted objects
	of class "ts", e.g. those without a "tsp" attribute.

    o	structure() reordered the "class" value given if there was a
	"tsp" value specified.

    o	pairs() now does pass appropriate parts of '...' to the
	'diag.panel' argument. (PR#9384)

    o	plot.lm() was using an incorrect estimate of dispersion for
	some GLMs (including family=binomial and family=poisson).
	(PR#9316)

    o	Subsetting operators were setting R_Visible too early, so
	assignments in arguments could make the result invisible.
	(PR#9263)

    o	The tk-GUI was displaying a warning due to an extra comma in
	the list of manuals (PR#9396)

    o	packageDescription() now gives an explicit error on a corrupt
	DESCRIPTION file.

    o	There was a scoping issue with tcltk callbacks given as
	unevaluated expressions. This has only been partially fixed, a
	complete fix probably requires redesign.

    o	trace() had its return value documented incorrectly and was
	sometimes visible when it should not have been.

    o	pchisq() would sometimes use the wrong tail when calculating
	non-central probabilities with lower.tail = FALSE. (PR#9406)

    o	rm() could remove the wrong objects when passed an expression.
	(PR#9399)  Now only names are allowed in the '...' argument,
	and the incorrect documentation of what happened with
	character objects is corrected.

    o	url() was not supporting 'encoding' except on file:// URLs.



		CHANGES IN R VERSION 2.4.0


USER-VISIBLE CHANGES

    o	The startup message now prints first the version string and
	then the copyright notice (to be more similar to R --version).

    o	save() by default evaluates promise objects.  The old behaviour
	(to save the promise and its evaluation environment) can be
	obtained by setting the new argument 'eval.promises' to FALSE.
	(Note that this does not apply to promises embedded in
	objects, only to top-level objects.)

    o	The functions read.csv(), read.csv2(), read.delim(),
	read.delim2() now default their 'comment.char' argument to "".
	(These functions are designed to read files produced by other
	software, which might use the # character inside fields, but
	are unlikely to use it for comments.)

    o	The bindings in the base environment/name space (currently the
	same thing) are now locked.  This means that the values of
	base functions cannot be changed except via
	assignInNamespace() and similar tricks.

    o	[[ on a factor now returns a one-element factor (and not an
	integer), as.list() on a factor returns a list of one-element
	factors (and not of character vectors), and unlist() on a list
	of factors returns a factor (and not an integer vector).
	These changes may affect the results of sapply() and lapply()
	applied to factors.

    o	mauchly.test() now returns the W statistic (for comparability
	with SAS and SPSS), rather than the z (which was accidentally
	not named in the output)

    o	sort(x, decreasing = FALSE, ...) is now a generic function.
	This means that 'partial' is no longer the second argument,
	and calls which used positional matching may be incorrect: we
	try to detect them.

    o	See the section on 'Changes to S4 methods': all packages
	depending on 'methods' need to be re-installed.


NEW FEATURES

    o	agrep(), grep(), strwrap(), strtrim(), substr() and
	related functions now coerce arguments which should be
	character via as.character() rather than internally (so method
	dispatch takes place, e.g. for factors).

	chartr(), charfold(), tolower() and toupper() now coerce their
	main argument if necessary to a character vector via
	as.character().

	Functions which work element-by-element on character vectors
	to give a character result now preserve attributes including
	names, dims and dimnames (as suggested by the Blue Book
	p. 144).  Such functions include charfold(), chartr(), gsub(),
	strtrim(), sub(), substr(), tolower() and toupper().  (Note
	that coercion of a non-character argument may lose the
	attributes.)

	agrep(value = TRUE) preserves names for compatibility with
	grep().

	nchar() has always preserved dims/dimnames (undocumented
	before) and now also preserves names.


    o	.Deprecated and .Defunct take a new parameter, msg, that allows
	for the specification of the message printed and facilitates
	deprecation of calling sequences etc.

    o	.Fortran() will map 'name' to lower case, and will work with
	'name' containing underscores.

    o	The default is now .saveRDS(compress = TRUE)

    o	The :: operator now also works for packages without name spaces
	that are on the search path.

    o	[[ on a list does not duplicate the extracted element unless
	necessary.  (It did not duplicate in other cases, e.g. a
	pairlist.)

    o	argsAnywhere() works like args() on non-exported functions.

    o	as.data.frame() gains a '...' argument.

    o	Added an as.data.frame() method for class "ftable".

    o	as.list(<an expression>) is now handled by internal code and
	no longer loses attributes such as names.

	as.list(<a list>) no longer duplicates (unnecessarily).

    o	as.POSIX[cl]t can now convert character strings containing
	fractional seconds.

    o	attach() can now attach a copy of an environment.

    o	available.packages() and installed.packages() gain a 'fields'
	argument thanks to Seth Falcon.

    o	axis.POSIXct() uses a different algorithm for ranges of 2 to 50
	days that will mark days at midnight in the current timezone
	(even if the graph crosses a DST change).

    o	body<-() and formals<-() default to envir = environment(fun),
	that is they do not by default change the environment.
	(Previously they changed it to parent.frame().)

    o	New function combn(x, m, ..) for computing on all combinations of
	size 'm' (for small 'm' !).

    o	The cumxxx() functions now handle logical/integer arguments
	separately from numeric ones, and so return an integer result
	where appropriate.

    o	data.frame() has a new argument 'stringsAsFactor'.  This and
	the default for read.table(as.is=) are set from the new global
	option 'stringsAsFactors' via the utility function
	default.stringsAsFactors().

    o	dev.interactive() now has an optional argument 'orNone'.

    o	df() now has a noncentrality argument 'ncp', based on a
	contribution by Peter Ruckdeschel.

    o	example() gains an argument 'ask' which defaults to "TRUE when
	sensible", but the default can be overridden by setting option
	'example.ask'.

    o	expand.grid() now has an argument 'KEEP.OUT.ATTRS' which can
	suppress (the potentially expensive) "out.attrs" attribute. It no
	longer returns an extraneous 'colnames' attribute.

    o	The subset and subassign methods for factors now handle factor
	matrices, and dim() can be set on a factor.

    o	There is now a format() method for class "ftable".

    o	head(x, n) and tail(x, n) now also work for negative arguments,
	thanks to Vincent Goulet.

    o	head.matrix() and tail.matrix() are no longer hidden, to be used
	for building head() and tail() methods for other classes.

    o	If help() finds multiple help files for a given topic, a menu
	of titles is used to allow interactive choice.

    o	help.search() now rebuilds the database if 'package' specifies a
	package not in the saved database.

    o	hist(*, plot = FALSE) now warns about unused arguments.

    o	history() gains a 'pattern' argument as suggested by Romain
	Francois.

    o	integer(0) now prints as that rather than "numeric(0)" (it
	always deparsed as "integer(0)").

    o	interaction(..., drop=TRUE) now gives the same result as
	interaction(...)[,drop=TRUE] (it used to sometimes give a
	different order for the levels).

    o	lag.plot() produces a conventional plot (not setting mfrow) if
	only one plot is to be produced.

    o	lapply() does much less copying.  Vector X are handled without
	duplication, and other types are coerced via as.list().	 (As a
	result, package 'boot' runs its examples 4% faster.)

	lapply(<a pairlist>) now coerces to a list (rather than traverse
	the pairlist from the beginning for each item).

    o	legend() has new parameters 'box.lwd' and 'box.lty'.

    o	lines() gains a simple method for isoreg() results.

    o	load() no longer coerces pairlists to lists (which was
	undocumented, but has been happening since 1998).

    o	make.link() now returns an object of class "link-glm".
	The GLM families accept an object of this class for their
	'link' argument, which allows user-specified link functions.
	Also, quasi() allows user-specified variance functions.

    o	mapply() uses names more analogously to lapply(), e.g..

    o	matplot() now accepts a 'bg' argument similarly to plot.default() etc.

    o	median() is now generic, and its default method uses mean()
	rather than sum() and so is more widely applicable (e.g. to dates).

    o	Dummy functions memory.size() and memory.limit() are available
	on Unix-alikes, for people who have not noticed that documentation
	is Windows-specific.

    o	merge() works more efficiently when there are relatively few
	matches between the data frames (for example, for 1-1
	matching).  The order of the result is changed for 'sort = FALSE'.

    o	merge() now inserts row names as a character column and not a
	factor: this makes the default sort order more comprehensible.

    o	Raw, complex and character vectors are now allowed in model
	frames (there was a previously undocumented restriction to
	logical, integer and numeric types.).  Character vectors in a
	formula passed to model.matrix() are converted to factors and
	coded accordingly.

    o	modifyList() utility, typically for housekeeping nested lists.

    o	x <- 1:20; y <- rnorm(x); nls(y ~ A*exp(-x^2/sig)) no longer
	returns an unhelpful error message.  In this and similar cases, it
	now tries a wild guess for starting values.

    o	Ops.difftime() now handles unary minus and plus.

    o	Ops.Date() and Ops.POSIXt() now allow character arguments
	(which are coerced to the appropriate class before comparison,
	for Ops.POSIXt() using the current time zone).

    o	There is a new option(max.contour.segments = 25000) which can be
	raised to allow extremely complex contour lines in contour()
	and contourLines().  (PR#9205)

    o	options(max.print = N) where N defaults to 99999 now cuts printing
	of large objects after about N entries.	 print(x, ..., max = N)
	does the same for the default method and those building on
	print.default().

	options("menu.graphics") controls if graphical menus should be
	used when available.

	options("par.ask.default") allows the default for par("ask")
	to be set for a newly-opened device.  (Defaults to FALSE, the
	previous behaviour.)

	The way option("papersize") is set has been changed.  On
	platforms which support the LC_PAPER locale category, the
	setting is taken first from the R_PAPERSIZE environment
	variable at run time, then from the LC_PAPER category
	("letter" for _US and _CA locales and "a4" otherwise).	On
	other platforms (including Windows and older Unixen), the
	choice is unchanged.

    o	package.skeleton() gains arguments 'namespace' and
	'code_files'.

    o	par(ask=TRUE) now only applies to interactive R sessions.

    o	parse() now returns up to 'n' expressions, rather than fill
	the expressions vector with NULL.  (This is now compatible
	with S.)

    o	The 'version' argument for pdf() is now increased
	automatically (with a warning) if features which need a higher
	level are used.

    o	pie() now allows expressions for 'labels', and empty slices.

    o	There is a new '%.%' operator for mathematical annotations
	(plotmath) which draws a centred multiplication dot
	(a \cdot in LaTeX), thanks to Uwe Ligges.

    o	predict.lm() gains a 'pred.var' argument.  (Wishlist PR#8877.)

    o	print.summary.{aov,glm,lm,nls} and print.{aov,glm} make use of
	naprint() to report when na.action altered the model frame.

    o	print.table(T, zero.print=ch) now also replaces 0 by ch when T is
	non-integer with integer entries.

    o	Recursive rapply() which is similar to lapply but used
	recursively and can restrict the classes of elements to which
	it is applied.

    o	r2dtable() has been moved to package 'stats'.

    o	New function read.DIF() to read Data Interchange Format files,
	and (on Windows) this format from the clipboard.

    o	New experimental function readNEWS() to read R's own "NEWS" file
	and similarly formatted ones.

    o	readLines() has a new argument 'warn' to suppress warnings:
	the default behaviour is still to warn.

    o	reg.finalizer() has a new argument 'onexit' to parallel the
	C-level equivalent R_RegisterFinalizerEx.

    o	rep() is now a primitive function and under some conditions
	very much faster: rep.int() is still a little faster (but does
	less). (Because it is primitive there are minor changes to the
	call semantics: see the help page.)

    o	The 'row.names' of a data frame may be stored internally as an
	integer or character vector.  This can result in considerably
	more compact storage (and more logical row names from rbind)
	when the row.names are 1:nrow(x).  However, such data frames
	are not compatible with earlier versions of R: this can be
	ensured by supplying a character vector as 'row.names'.

	row.names() will always return a character vector, but direct
	access to the attribute may not.

	The internal storage of row.names = 1:n just records 'n', for
	efficiency with very long vectors.

	The "row.names" attribute must be a character or integer
	vector, and this is now enforced by the C code.

    o	The "data.frame" and "matrix" methods for rowsum() gain an 'na.rm'
	argument.

    o	Experimental support for memory-use profiling via Rprof(),
	summaryRprof(), Rprofmem() and tracemem().

    o	save.image() [also called by sys.save.image() and hence from q()]
	now defaults to saving compressed binary images.  To revert to
	the previous behaviour set option "save.image.defaults": see
	?save.image.

    o	There is a new primitive seq.int() which is slightly more
	restricted than seq() but often very much faster, and new
	primitives seq_along() and seq_len() which are faster still.

    o	serialize(connection = NULL) now returns a raw vector (and not
	a character string).  unserialize() accepts both old and new
	formats (and has since 2.3.0).

    o	setwd() now returns the previously current directory (invisibly).

    o	The function sort() is now sort.int(), with a new generic
	function sort() which behaves in the same way (except for the
	order of its argument list) for objects without a class, and
	relies on the '[' method for objects with a class (unless a
	specific method has been written, as it has for class "POSIXlt").

    o	sort.list() now implements complex vectors (PR#9039), and how
	complex numbers are sorted is now documented.

    o	spline() and splinefun() now follow approx[fun] to have an argument
	'ties = mean' which makes them applicable also when 'x' has
	duplicated values.

    o	str(x) does not print the S3 "class" attribute when it is the
	same as 'mode' (which is printed anyway, possibly abbreviated)
	and it puts it beside mode for atomic objects such as S3 class
	"table".

    o	str(<data.frame>) now outputs 'data.frame' instead of
	`data.frame'; this may affect some strict (Package) tests.

    o	str() now takes also its defaults for 'vec.len' and 'digits.d'
	from options('str') which can be set by the new strOptions().

    o	symnum() has a new argument 'numeric.x' particularly useful for
	handling 0/1 data.

    o	Sys.getlocale() and Sys.setlocale() support LC_MESSAGES,
	LC_PAPER and LC_MEASUREMENT if the platform does.

    o	Sweave has a new options 'pdf.encoding' and 'pdf.version' for
	its Rweave driver.

    o	The character vector used by an output textConnection() has
	a locked binding whilst the connection is open.

	There is a new function textConnectionValue() to retrieve the
	value of an output textConnection().

    o	traceback() gains a 'max.lines' argument.
	.Traceback is no longer stored in the workspace.

    o	warning(immediate. = TRUE) now applies to
	getOption("warn") < 0 and not just == 0.

    o	warnings() is now an accessor function for 'last.warning' (which
	is no longer stored in the workspace) with a print() method.


    o	The internal internet download functions have some new
	features from libxml 2.6.26.

    o	There is an option "HTTPUserAgent" to set the User Agent in R
	download requests etc.	Patch from S. Falcon.

    o	PCRE has been updated to version 6.7.

    o	The C function substituteList now has tail recursion expanded
	out, so C stack overflow is less likely.  (PR#8141, fix by
	Kevin Hendricks)

    o	The (somewhat soft) 1023/4 byte limit on command lines is now
	documented in 'An Introduction to R'.

    o	The maximum number of open connections has been increased from
	50 to 128.

    o	There is a new manual 'R Internals' on R internal stuctures
	plus the former appendices of 'Writing R Extensions'.

    o	The autoloads introduced at the package re-organization have been
	almost completely removed: the one that remains is for ts().

    o	The setting of the various Java configuration variables has been
	improved to refer to JAVA_HOME, and they are now documented in
	the R-admin manual.

    o	It is (again) possible to calculate prediction intervals from
	"lm" objects for the original data frame, now with a warning
	that the intervals refer to future observations.  Weighted
	intervals have also been implemented, with user-specifiable
	weights. Warnings are given in cases where the default
	behaviour might differ from user expectations.	See the
	?predict.lm for details.


CHANGES TO S4 METHODS

    o	The default prototype object for S4 classes will have its own
	internal type in 2.4.0, as opposed to being an empty list (the
	cause of several errors in the code up to 2.3.1).  Note that old
	binary objects, including class definitions, will be
	inconsistent with the type, and should be recreated.

    o	S4 method dispatch has been completely revised to use cached
	generic functions and to search for the best match among
	inherited methods.  See ?Methods and
	http://developer.r-project.org/howMethodsWork.pdf

    o	Objects created from an S4 class are now marked by an internal flag,
	tested by isS4() in R and by macro IS_S4_OBJECT() in C.	 This
	is an efficient and reliable test, and should replace all
	earlier heuristic tests.

    o	Some changes have been made to automatic printing of S4
	objects, to make this correspond to a call to show(), as per
	'Programming with Data'.

    o	S4 generic and class definitions are now cached when the related
	package is loaded.  This should improve efficiency and also
	avoid anomalous situations in which a class or generic cannot
	be found.

    o	trace() now creates a new S4 class for the traced object if
	required.  This allows tracing of user-defined subclasses of
	"function".


DEPRECATED & DEFUNCT

    o	The re-named tcltk functions tkcmd, tkfile.tail, tkfile.dir,
	tkopen, tkclose, tkputs, tkread are now defunct.

    o	Argument 'col' of bxp() has been removed: use 'boxfill'.

    o	Use of NULL as an environment is now an error.

    o	postscriptFont() is defunct: use Type1Font().

    o	La.chol() and La.chol2inv() are defunct (they were the same as
	the default options of chol() and chol2inv).

    o	La.svd(method = "dgesvd") is defunct.

    o	Files install.R and R_PROFILE.R in packages are now ignored
	(with a warning).

    o	The following deprecated command-line options to INSTALL have
	been removed (use the fields in the DESCRIPTION file instead):
	-s --save --no-save --lazy --no-lazy --lazy-data --no-lazy-data

    o	Graphical parameter 'tmag' is obsolete.

    o	mauchley.test() (package 'stats') is now defunct.

    o	symbol.C() and symbol.For() are deprecated.  They are required in
	S for use with is.loaded(), but are not so required in R.

    o	load()ing an object saved in one of the formats used prior to
	R 1.4.0 is deprecated.	Such objects should be re-saved in the
	current format.

    o	save(version = 1) is now deprecated.


C-LEVEL FACILITIES

    o	The convenience function ScalarLogical now coerces all
	non-zero non-NA values to TRUE.

    o	The vector accessor functions such as INTEGER, REAL and
	SET_VECTOR_ELT now check that they are called on the
	correct SEXPTYPE (or at least on a compatible one).  See
	`Writing R Extensions' for the details and for a stricter
	test regime.

    o	It is no longer possible to pass list variables to
	.C(DUP = FALSE): it would have given rise to obscure garbage
	collection errors.

    o	allocString is now a macro, so packages using it will need to
	be reinstalled.

    o	R_ParseVector was returning with object(s) protected in the
	parser if the status was PARSE_INCOMPLETE or PARSE_ERROR.

    o	There is a new function Rf_endEmbeddedR to properly terminate
	a session started by Rf_initEmbeddedR, and both are now
	available on Windows as well as on Unix-alikes.	 These and
	related functions are declared in a new header <Rembedded.h>.

	If R_TempDir is set when embedded R is initialized it is
	assumed to point to a valid session temporary directory: see
	`Writing R Extensions'.

    o	There is a new interface allowing one package to make C routines
	available to C code in other packages.	The interface consists
	of the routines R_RegisterCCallable and R_GetCCallable.	 These
	functions are declared in <R_ext/Rdynload.h>. This interface
	is experimental and subject to change.

	In addition, a package can arrange to make use of header
	files in another (already installed) package via the
	'LinkingTo' field in the DESCRIPTION file: see 'Writing R
	Extensions'.


UTILITIES

    o	R CMD SHLIB now handles (as linker commands) -L*, -l* and *.a.

    o	R CMD check now:

	- warns if there are non-ASCII characters in the R code (as
	  these will likely be syntax errors in some locale).

	- tests Rd cross-references by default, and tests for
	  (syntactically) valid CITATION metadata.

	- tests that the package can be loaded, and that the package
	  and name space (if there is one) can each be loaded in
	  startup code (before the standard packages are loaded).

	- tests for empty 'exec' or 'inst' directories.

	- checks if $(FLIBS) is used when $(BLAS_LIBS) is.

	- checks that all packages (except non-S4-using standard
	  packages) used in ::, :::, library() and require() calls are
	  declared in the DESCRIPTION file, and 'methods' is declared if
	  S4 classes or methods are set.

	- throws an error if the standard packages 'methods' and
	  'stats4' are imported from in the NAMESPACE file and not
	  declared in the DESCRIPTION file.

    o	The test script produced by massage-Examples.pl no longer
	creates objects in the base environment.

    o	New utilties R CMD Stangle and R CMD Sweave for extracting S/R
	code from and processing Sweave documentation, respectively.

    o	The DESCRIPTION file of packages may contain an 'Enhances:'
	field.

    o	An R CMD javareconf script has been added to allow Java
	configuration to be updated even after R has been installed.


INSTALLATION

    o	The C function realpath (used by normalizePath()) is hidden on
	some systems and we try harder to find it.

    o	There is a new option --enable-BLAS-shlib, which compiles the
	BLAS into a dynamic library -lRblas and links against that.
	For the pros and cons see the R-admin manual.

	The defaults are now --without-blas (so you have explicitly to
	ask for an external BLAS), and --enable-BLAS-shlib unless
	a usable external BLAS is found or on AIX or on MacOS X 10.2
	and earlier.

    o	MacOS X did not like having LSAME in both BLAS and LAPACK
	libraries, so it is no longer part of the R-internal LAPACK.
	We now require an external BLAS to provide LSAME: it seems
	that nowadays all do.

    o	The configure test for 'whether mixed C/Fortran code can be
	run' has been improved as on one system that test passed but
	the Fortran run-time library was broken.

    o	A precious configure variable DEFS can be set to pass defines
	(e.g. -DUSE_TYPE_CHECKING_STRICT) to C code when compiling R.

    o	There is now a test for visible __libc_stack_end on Linux
	systems (since it is not visible on some recent glibc's
	built from the sources).

    o	MacOS X 10.4 and higher now use two-level namespaces, single
	module in a shared library and allow undefined symbols to be
	resolved at run-time. This implies that common symbols are now
	allowed in package libraries. --enable-BLAS-shlib is supported
	for internal BLAS, external BLAS framework and external static
	BLAS.  An external dynamic library BLAS is NOT supported. (But
	it can be easily used by replacing internal BLAS library file
	later.)	 MacOS X < 10.4 does not support --enable-BLAS-shlib.

    o	Dynamic libraries and modules use a flat namespace on MacOS X
	10.4 and higher if either Xcode tools don't support dynamic
	lookup (Xcode < 2.3) or the FORCE_FLAT_NAMESPACE environment
	variable is set.  (The latter was introduced temporarily for
	testing purposes and may go away anytime.)

    o	configure now defaults to 'run-time linking' on AIX
	(and AIX < 4.2 is no longer allowed), using -bexpall rather
	than export/import files.  If this works, it allows R to be
	built in the same way as other Unix-alikes, including with R
	as a shared library and with a shared BLAS.

    o	The "mac.binary" package type now defaults to universal
	binary.	 If a repository supports architecture-specific Mac
	binaries, they can be requested by using "mac.binary.xxx" in
	contrib.url(), where xxx is the desired architecture.

    o	There is a new configure option --enable-memory-profiling to
	enable memory profiling with tracemem, Rprof, Rprofmem.


BUG FIXES

    o	The name of a Fortran symbol reported to be missing by
	.Fortran() is now the actual name.  (What was reported to be
	an 'entry point' was missing the common leading underscore.)

    o	print() on a MBCS character string now works properly a
	character at a time rather than a byte at time.	 (This does
	not affect MBCSs like UTF-8 and the Windows DBCSes which have
	non-ASCII lead bytes and always worked correctly.)

    o	glm() now recalculates the null deviance whenever there is an
	offset (even if it is exactly zero to avoid a discontinuity in
	that case, since the calculations with and without offset are
	done by different algorithms).

    o	Amongst families, quasi() accepted an expression for link and
	no other did.  Now all accept an expression which evaluates to
	a one-element character vector (although e.g. 'logit' is taken
	as a name and not an expression).

    o	trace() now accepts arguments where= and signature= for the
	old-style trace (no tracer or exit, edit==FALSE) and just
	prints a message on entry.  Also the undocumented feature of
	where=function now works for generic functions as well.

    o	callNextMethod() failed for recursive use when the methods had
	nonstandard argument lists.  Now enforces the semantic rule
	that the inheritance is fixed when the method containing the
	callNextMethod() is installed.	See Details in the documentation.

    o	UseMethod() looked for the defining environment of 'generic' as
	if it were the current function, although some functions are
	generic for methods of a different generic.

	Lookup for S3 methods is confined to functions: previously a
	non-function 'fun.class' could have masked a function of the
	same name.

    o	Line types (lty) specified as hex strings were documented not to
	allow zero, but some devices accepted zero and handled it in a
	device-dependent way.  Now it is an error on all devices.
	(PR#8914)

    o	Subassignment for a time series can no longer extend the series:
	it used to attempt to but failed to adjust the tsp attributes.
	Now window() must be used.

    o	Function AIC() in package 'stats4' was not dispatching correctly
	on S4 classes via logLik() because of name space issues.

    o	Subsetting LANGSXPs could break the call-by-value illusion.
	(PR#7924) (patch from Kevin Hendricks).

    o	parse() with n > 1 gave a syntax error if fewer than n statements
	were available.

    o	parse() with n > 1 gave strange results on some syntax errors.
	(PR#8815)

    o	lag.plot() now respects graphical parameters for the axes.

    o	Using a wrong link in family() now gives more consistent error
	messages.

    o	sort.list(method="radix") works on factors again.

    o	object.size() is more accurate for vector objects (it takes into
	account the smaller header and also the fixed sizes used in
	the node classes for small vector objects).

    o	addmargins(T, ...) now returns a "table" when 'T' is a "table", as
	its help page has always suggested.

    o	remove() now explicitly precludes removing variables from
	baseenv() and throws an error (this was previously ignored).

    o	Saving the workspace at the end of a session now works as has
	long been intended, that is it is saved only if something has
	been added/deleted/changed during the current session.

    o	The search for bindings in <<-, ->> and assign(inherits=TRUE)
	was omitting the base package, although this was not
	documented.  Now the base package is included (but most
	bindings there are locked).

    o	dweibull(0, shape) was NaN not Inf for shape < 1.  Also, the
	help for dgamma and dweibull gave support as x > 0, but
	returned non-zero values for x = 0.  (PR#9080)

    o	Subsetting arrays no longer preserves attributes (it was
	removed for matrices in 1998).

    o	The "factor" method of as.character() no longer maps level
	"NA" to "<NA>" (a legacy of before there were NA character
	strings).

    o	terms(keep.order=TRUE) was not returning a valid "order"
	attribute.

    o	The DLL registration code was not freeing .External symbols.

    o	The internet download routines expected URLs of less than 4096
	bytes, but did not check.  Now this is checked, and http:// URLs
	are allowed to be up to 40960 bytes.

    o	parse(n=-1) threw a stack-imbalance error, and parse(n=3) did
	not cope correctly with EOF during input.

    o	Zero-column data frames had no names (rather than character(0)).

    o	by() and acf() could get confused when they used very long
	expressions as names.

    o	residuals(<glm object>, type="working") was NA for cases with
	zero weight (whereas they are well-defined even though the
	case was not used during the fitting) and the actual value is
	now returned.  This allows residuals to be computed from fits
	with 'y = FALSE'.

	The residuals in a fitted "glm" object are computed more
	accurately: the previous formula was subject to cancellation.

    o	loess() now checks the validity of its 'control' argument.

    o	rownames(<0-row matrix>, do.NULL=FALSE) was wrong.  (PR#9136)

    o	apply() now works as documented when applied over 2 or more
	margins with one of zero extent.  (It used to drop dimensions.)

    o	head() and tail() now also work row-wise for "table" and "ftable"
	objects.

    o	NextMethod() could throw an error/crash if called from a method
	that was called directly rather than from a generic (so
	.Method was unset).

    o	order(x, na.last = NA) failed for a zero-length x.

    o	grep(pat, x, value = TRUE, perl = L) preserved names for
	L == TRUE && !is.na(pat) but not otherwise.  Now it always does.

    o	[rc]bind() now find registered methods and not just visible ones.

    o	Printing a factor no longer ignores attributes such as names and
	dim/dimnames.

    o	Command-line arguments after --encoding were ignored.

    o	The check for impossible confidence levels was off by one in
	wilcox.test (PR#8557)

    o	[[ on an environment could create aliases. (PR#8457)

    o	pt() with a very small (or zero) non-centrality parameter could
	give an unduly stringent warning about 'full precision was not
	achieved'.  (PR#9171)

    o	writeChar() could segfault if 'nchars' was given silly values.

    o	qt() and rt() did not work for vector 'ncp', and qt() did not
	work for negative 'ncp'.

    o	ns() failed to work correctly when 'x' was of length one.

    o	identical() ignored tags on pairlists (including names of
	attributes) and required an identical ordering for
	attribute values in their pairlists.  Now names are compared
	on pairlists, and attribute sets are treated as unordered.

    o	If they were unused arguments supplied to a closure, only
	the first non-empty one was reported, despite the message.

	Unmatched empty arguments (such as f(1,,) for a function of
	one argument) were ignored.  They are now an error.

    o	Calling a builtin with empty arguments used to silently remove
	them (and this was undocumented).  Now this is an error unless
	builtin is c() or list() or there are only trailing empty
	arguments, when it is a warning (for the time being: this will
	be made an error in R 2.5.0).

    o	install.packages() ignored 'configure.args' if the vector was
	unnamed.

    o	biplot() now works if there are missing values in the data.

    o	biplot() now passes par() values to all four axes (not
	just those on sides 1 and 2).

    o	[.acf now handles an empty first index.

    o	Deparsing uses backticks more consistently to quote
	non-syntactic names.

    o	Assigning to the symbol in a for() loop with a
	list/expression/pairlist index could alter the index.  Now the
	loop variable is explicitly read-only.	(PR#9216)

    o	Using old.packages() (and hence update.packages()) on an empty
	(or non-existent) library failed with an obscure message.

    o	plot.xy() could segfault if supplied with an invalid 'col'
	argument.  (PR#9221)

    o	menu() with graphics=TRUE attempted to use Tcl/Tk on unix even
	if DISPLAY was not set (in which case Tk is not available and
	so the attempt is bound to fail).

    o	The print() method for 'dist' objects prints a matrix even for
	n = 2.

    o	The cumxxx functions were missing some PROTECTs and so could
	segfault on long vectors (especially with names or where
	coercion to numeric occurred).

    o	The X11() device no longer produces (apparently spurious)
	'BadWindow (invalid Window parameter)' warnings when run from
	Rcmdr.

    o	legend() assumed that widths and heights of strings were positive,
	which they need not be in user coordinates with reversed axes.
	(In part, PR#9236)

    o	The plot() methods for "profile.nls" objects could get
	confused if 'which' had been used in the profile() call. (PR#9231)

    o	boxplot() did not passed named arguments (except graphics
	parameters) to bxp() as documented.  (PR#9183)

    o	Only genuinely empty statements act as 'return' in the
	browser, not say those starting with a comment char.  (PR#9063)

    o	summary.mlm() incorrectly used accessor functions to fake an
	"lm" object.  (PR#9191)

    o	prettyNum() was not preserving attributes, despite being
	explicitly documented to. (PR#8695)

    o	It was previously undocumented what happened if a graphical
	parameter was passed in both '...' and 'pars' to boxplot()
	and bxp(), and they behaved differently.  Now those passed in
	'...' have precedence in both cases.

    o	A failed subassignment could leave behind an object '*tmp*'.
	The fix also sometimes gives better error messages.

    o	Using SIGUSR1 on Unix now always terminates a session, and no
	longer is caught by browser contexts and restarts (such as try()).

    o	In the 'graphics' package, in-line 'font=5' was being ignored
	(report by Tom Cook).

    o	nls() looked for non-parameter arguments in a function call in
	the wrong scope (from the body of nls).

    o	Printing of complex numbers could misbehave when one of the
	parts was large (so scientific notation was used) and the
	other was so much smaller that it had no significant digits
	and should have been printed as zero (e.g. 1e80+3e44i).

    o	Using install.packages with type="mac.binary" and target path
	starting with ~ failed with a cryptic message while unpacking.

    o	getwd() now works correctly when the working directory is
	unavailable (e.g. unreadable).

    o	The alternative hypothesis in wilcox.test() was labelled by an
	unexplained quantity 'mu' which is now spelled out.

	The alternative hypothesis in ks.test() is clearer both in the
	documentation and in the result. (PR#5360)



	**************************************************
	*						 *
	*	       2.3 SERIES NEWS			 *
	*						 *
	**************************************************


		CHANGES IN R VERSION 2.3.1 patched


BUG FIXES

    o	help.search() incorrectly documented where the data base was
	saved and what was in it.

    o	str(<data.frame>, strict.width=.) produced an extraneous first line.

    o	Improve bessel[IJKY]() out-of-range checks; for instance,
	besselI(0, nu) no longer warns.

    o	cbind() on some non-vector objects (e.g. names) segfaulted.

    o	xy.coords(numeric(0)) gave a misleading error message.

    o	INSTALL has been changed to avoid a few problems with the
	base (not XPG4) Solaris sed.

    o	There were problems in src/main/printutils.c on some platforms
	that did not have va_copy.

    o	[pq]unif allowed infinite ranges but handled them
	inconsistently.	 (PR#8958)

	[pq]unif claimed to allow min == max but did not do so.

    o	Subassignment within raw arrays of 3 or more dimensions was not
	implemented.

    o	environment<-() did not even check if duplication was required.

    o	rt() was wrong for non-central t-distributions. qt() was wrong
	for non-central distributions far enough in the left tail
	(reported by Long Qu).	(PR#9050)

    o	R CMD Rdconv --type=Ssgm no longer drops a \keyword{} if it is the
	only one (one letter typo patch by Bill Dunlap).  (PR#9051)

    o	poly(x, y, .., raw = TRUE) now does follow 'raw'.

    o	plot(0/ -1:1, type = "s") now works.  (PR#9046)

    o	write.table(row.names=FALSE) does now quote column names. (PR#9044)

    o	rf() was wrong for non-central F (PR#9055). qf() was wrong for
	non-central F with denominator df > 1e8.

    o	The C function dummy_vfprint had a potential memory leak.  This
	showed up with some connections when used with output of more
	than 100,000 bytes in a single call.

    o	vignette() did not work if more than one vignette with the
	same name was installed	 (PR#9069).

    o	mget() did not check that 'ifnotfound' was a list, and worked
	incorrectly if it was a list of length > 1.  Now 'ifnotfound'
	is (if possible) coerced to a list.

    o	The internal check for conformance of time series assumed that the
	'tsp' attribute was integer, whereas it was enforced to be
	numeric by the attribute-setting code.

    o	Sweave() did not treat \begin{document} in comments correctly
	(PR#9073).

    o	diff(x) gave wrong result when x was "POSIXlt" object.

    o	title() could crash R when passed a long non-character vector.
	(PR#9115)

    o	Functions rgb(), hsv() and hcl() lost names unless 'alpha' was
	specified.  (In part, PR#9118)

    o	The residuals() method for "glm" failed unless 'y = TRUE' for
	the fit: it now works for "working" and "partial" residuals
	and gives a useful error message for other types. (PR#9124)

    o	R CMD Rdconv did not close the .Rd file, which matters on Windows.
	(PR#9126)

    o	anova.mlm() could fail if applied to a single model.

    o	stopifnot(<FALSE-expr>) now gives a better message for a *long*
	expression.




		CHANGES IN R VERSION 2.3.1


NEW FEATURES

    o	In lm() and glm(), offsets are allowed to be length 1 (and
	if so are replicated to the number of cases).

    o	The \uxxxx notation for Unicode characters in input strings
	can now be used on any platform which supports MBCS, even if
	the current locale is not MBCS (provided that the Unicode
	character is valid in the current character set).

    o	The quasibinomial() family now allows the "cauchit" link. (PR#8851)

    o	edit.data.frame() no longer (silently) coerces character columns
	to factor.


C-LEVEL FACILITIES

    o	The variables controlling stack checking are made available via
	Rinterface.h to front-ends embedding R: see 'Writing R Extensions'

    o	R_SignalHandlers (defined in Rinterface.h) can be set to 0 to
	suppress the R signal handlers in front-ends embedding R.


INSTALLATION CHANGES

    o	There have been a number of changes to help installation on
	platforms that no one had beta-tested.

	- Changes related to older header files, e.g. on Redhat 8.0/9.

	- Problems with 'make install' on older (<3) versions of bash
	  on Solaris and elsewhere.

	- AIX 5.2/gcc issues with needing -lm when making modules X11
	  and vfonts.

	- Some versions of Solaris and AIX had an fcntl.h that
	  redefined 'open' to be 'open64' and thereby broke
	  compilation of src/main/connections.c and elsewhere.

    o	'make uninstall' works better on a build using a named
	subarchitecture.


BUG FIXES

    o	min(), max(), sum() and prod() gave nonsensical answers with
	an empty list or raw argument.

    o	sum() on a data frame did not allow multiple arguments.	 (PR#8385)

    o	charmatch() and pmatch() did not specify they applied only to
	character vectors.  Now they do, and attempt to coerce 'x' and
	'target' to character before attempting matching.

    o	The Summary() methods for data.frame, Date, POSIXct, POSIXlt
	and difftime all required an argument which can match 'x',
	although the generics did not.

    o	regexpr() now accepts 0-length 'text' inputs.

    o	help.search() no longer errors out on a wrongly installed package
	(with no "hsearch.rds" file).

    o	The LaTeX version of the package reference manual was omitting
	some topics, and was not sorting the foo-package topic first.

    o	Serializing (e.g. via save()) is better protected against C
	stack overflow, which will now abort the conversion but no
	longer crashes the R process on some platforms.

    o	rbind()ing dataframes with a single row could lead to a
	corrupt data frame (a problem with the fix to PR#8506).

    o	plot(lm(y ~ 1)) now works also for 'which = 5'.

    o	dbeta(0, 1, a, 0) now correctly gives 'a' (limit) instead of 0,
	and dbeta(0, a, b, ncp) now returns Inf instead of NaN.

    o	demo(Hershey) was failing on the Cyrillic octal codes in locales
	(e.g. UTF-8) in which these are invalid.

    o	mean() on an integer (or logical) vector was treating NAs as
	actual values (unless na.rm = TRUE).

    o	mean() on a complex vector was calculated incorrectly in
	code to improve precision (PR#8842, John Peters).

    o	Graphical parameters bg, cex, col, lty, and lwd were being
	checked as being of length one even by functions such as
	title() that ignored them.  (Functions such as lines() and
	points() allow them to be of length > 1, so they might be
	passed through ... to other high-level graphical functions
	which then used to reject them.)

    o	str() now is fast again for large character vectors.

    o	edit() would default the environment of a function to .BaseEnv,
	instead of to .GlobalEnv.

    o	lm() and glm() coerce their 'weights' and 'offset' values to
	vector to avoid problems with specifying them as 1D or n x 1
	arrays.

    o	image() with one or both axes on log scales would give a
	spurious warning; contour() would give an error.

    o	legend() with log axes would place the title in the wrong place.

    o	edit.data.frame() was not returning factors edited with
	factor.mode="numeric" to factors.

    o	edit.matrix() tried to set rownames and colnames from the
	original matrix even if the sizes had been altered, and
	ignored changes made to the column names.  'edit.row.names' has
	a more sensible default (if the rownames are non-NULL).

    o	bindingIsLocked() was returning invalid values of a logical
	vector on some platforms.

    o	merge.data.frame() did not make the column names unique (by
	appending elements of 'suffixes') when performing a Cartesian
	product.  (PR#8676)

    o	rbind.data.frame() matches up the names of columns (which was
	undocumented), but failed to do so when checking if it was
	dealing with a factor column.  (PR#8868)

	If rbind() was used on data frames with duplicated names it
	produced a corrupt data frame.

    o	dt(x, df, ncp= not.0) no longer gives erratic values for
	|x| < ~1e-12.  (PR#8874)

    o	\code{\linkS4class{.}} now works.

    o	ccf() aligns time series by ts.intersect() rather than
	ts.union() and so is less likely to need a non-default
	na.action.  (PR#8893)

    o	optim(method="CG") could return a value that did not
	correspond to $par for very badly behaved functions on which
	the second phase of the line search failed.  (PR#8786)

    o	print.ts() could fail on a corrupt time series: it now warns and
	does the best it can.




		CHANGES IN R VERSION 2.3.0


USER-VISIBLE CHANGES

    o	In the grid package there are new 'arrow' arguments to
	grid.line.to(), grid.lines(), and grid.segments()
	(grid.arrows() has been deprecated).

	The new 'arrow' arguments have been added BEFORE
	the 'name', 'gp' and 'vp' arguments so existing code that
	specifies any of these arguments *by position* (not by name)
	will fail.

    o	all.equal() is more stringent, see the PR#8191 bug fix below.

    o	The data frame argument to transform() is no longer called 'x',
	but '_data'.  Since this is an invalid name, it is less likely
	to clash with names given to transformed variables. (People
	were getting into trouble with transform(data, x=y+z).)


NEW FEATURES

    o	arima.sim() has a new argument 'start.innov' for compatibility
	with S-PLUS.  (If not supplied, the output is unchanged from
	previous versions in R.)

    o	arrows() has been changed to be more similar to segments():
	for example col=NA omits the arrow rather than as previously
	(undocumented) using par("col").

    o	as.list() now accepts symbols (as given by as.symbol() aka
	as.name()).

    o	atan2() now allows one complex and one numeric argument.

    o	The 'masked' warnings given by attach() and library() now only
	warn for functions masking functions or non-functions masking
	non-functions.

    o	New function Axis(), a generic version of axis(), with Date and
	POSIX[cl]t methods.  This is used by most of the standard
	plotting functions (boxplot, contour, coplot, filled.contour,
	pairs, plot.default, rug, stripchart) which will thus label x
	or y axes appropriately.

    o	pbeta() now uses TOMS708 in all cases and so is more accurate
	in some (e.g. when lower.tail = FALSE and when one of the
	shape parameters is very small).

    o	[qr]beta(), [qr]f() and [qr]t() now have a non-centrality parameter.

    o	[rc]bind and some more cases of subassignment are implemented
	for raw matrices.  (PR8529 and 8530)

    o	The number of lines of deparsed calls printed by browser() and
	traceback() can be limited by the option "deparse.max.lines".
	(Wish of PR#8638.)

    o	New canCoerce() utility function in "methods" package.

    o	[pq]chisq() are considerably more accurate for moderate (up to
	80) values of ncp, and lower.tail = FALSE is fully supported
	in that region.	 (They are somewhat slower than before.)

    o	chol(pivot = TRUE) now gives a warning if used on a (numerically)
	non-positive-definite matrix.

    o	chooseCRANmirror() consults the CRAN master (if accessible) to
	find an up-to-date list of mirrors.

    o	cov.wt() is more efficient for 'cor = TRUE' and has a new 'method'
	argument which allows 'Maximum Likelihood'.

    o	do.call() gains an 'envir' argument.

    o	eigen() applied to an asymmetric real matrix now uses a
	tolerance to decide if the result is complex (rather than
	expecting the imaginary parts of the eigenvalues to be exactly
	zero).

    o	New function embedFonts() for embedding fonts in PDF or
	PostScript graphics files.

    o	fisher.test() now uses p-values computed via hypergeometric
	distributions for all 2 by 2 tables.  This might be slightly
	slower for a few cases, but works much better for tables with
	some large counts.

	There is a new option to simulate the p-value for larger than
	2 x 2 tables.

    o	for() now supports raw vectors as the set of indices.

    o	getNativeSymbolInfo() is vectorized for the 'name' argument.  It
	returns a named list of NativeSymbolInfo objects, but is
	backward compatible by default when called with a character
	vector of length 1, returning the NativeSymbolInfo object.

    o	help.search() no longer attempts to handle packages installed
	prior to R 2.0.0, and reports the current path to the
	package (rather than where it was originally installed: this
	information is not shown by the print() method).

    o	Added "hexmode" to parallel "octmode".

    o	install.packages() now does tilde expansion on file paths
	supplied as 'pkgs'.

    o	install.packages() has additional arguments 'configure.args' and
	'clean' which allow the caller to provide additional arguments
	to the underlying R CMD INSTALL shell command when installing
	source packages on a Unix-alike.

    o	is.loaded() has a new argument 'type' to confine the search to
	symbols for .C, .Fortran, .Call or .External: by default it
	looks for a symbol which will match any of them.  It is now
	internal and not primitive, so argument matching works in the
	usual way.

    o	The symmetry test for matrices used in eigen() has been ``exported''
	as the 'matrix' method of a new S3-generic 'isSymmetric().

    o	.leap.seconds and the internal adjustment code now know about
	the 23rd leap second on 2005-12-31: the internal code uses a
	run-time test to see if the OS does.

    o	The 'col' argument of legend() now defaults to par("col")
	(which defaults to "black", the previous default), so that
	the lines/symbols are shown in the legend in the colour that
	is used on the plot.

    o	log2() and log10() call C functions of the same name if
	available, and will then be more likely to be precise to
	machine accuracy.

    o	new.packages() gains a ... argument to pass e.g. 'destdir' to
	install.packages().  (Wish of PR#8239.)

    o	nls() now supports 'weights'.

    o	The vector passed as the first argument of the 'fn' and 'gr'
	arguments of optim() has the names (if any) given to argument
	'par'.

    o	options(expressions) is temporarily increased by 500 during
	error-handling.	  This enables e.g. traceback() to work when
	the error is reaching the limit on the nesting of expressions.

    o	page() accepts general R objects, not just names (and
	previously undocumented) character strings.  This allows the
	object to be specified as a call, for example.	More options
	are allowed in its '...' argument.

    o	pairs() allows a wider class of inputs, including data frames
	with date and date-time columns.

    o	par() and the in-line use of graphical parameters produce more
	informative error messages, distinguishing between
	non-existent pars and inappropriate use of valid pars.

	Graphical parameters 'family', 'lend', 'ljoin' and 'lmitre'
	can now be set in-line.

	There is no longer a warning if non-settable pars are used
	in-line, but there is an appropriate warning if unknown pars
	are passed.

	The length limit for the 'family' parameter has been increased
	to 200 bytes, to allow for the names of some CID-keyed fonts
	in multi-byte locales.

    o	The pdf() device now allows 'family' to be specified in the same
	generality as postscript().

    o	The pdf() device writes /FontDescriptor entries for all fonts
	except the base 14, and does not write font entries for unused
	fonts.

    o	Plotmath allows 'vartheta', 'varphi' and 'varsigma' (or 'stigma')
	as synonyms for 'theta1', 'phi1' and 'sigma1', and the help
	page has a note for TeX users.

    o	plot.xy() now takes its default arguments from the
	corresponding par() settings, so points(type="l") and
	lines(type="p") behave in the same way (and more obviously,
	also for type="b").

    o	poly() has a new argument 'raw', mainly for pedagogical purposes.

    o	The class "POSIXlt" now supports fractional seconds (as
	"POSIXct" has always done).  The printing of fractional seconds
	is controlled by the new option "digits.secs", and by default is off.

    o	postscript() supports family = "ComputerModernItalic" for
	Computer Modern with italic (rather than slanted) faces.

    o	The postscript()/pdf() font metrics for the 14 standard fonts
	(only, not the rest of the common 35) have been updated to
	versions from late 1999 which cover more glyphs.  There are
	also a few differences in the metrics and hence the output
	might be slightly different in some cases.

    o	The way families can be specified for postscript() and pdf()
	has been expanded to include CID-keyed fonts, with new
	functions Type1Font() and CIDFont() to set up such fonts
	families.

    o	prettyNum() has new arguments 'preserve.width' and 'zero.print'.
	When the former is not "none", as in calls from format() and
	formatC(), the resulting strings are kept at the desired width
	when possible even after adding of 'big.mark' or 'small.mark'.

    o	proc.time() and system.time() now record times to 1ms accuracy
	where available (most Unix-like systems).

    o	The initialization methods for the quasi() family have been
	changed to depend on the variance function, and in particular
	to work better for the "mu(1-mu)" variance function.  (PR#8486)

    o	read.table() gains a 'flush' argument passed to scan().

    o	require() now takes a 'lib.loc' argument.

    o	The second argument 'size' to sample() is required to have
	length 1, so that errors when supplying arguments are more
	easily detected.

    o	The default is now compress = !ascii in save() (but not save.image).

    o	scan() and write.table() now have some interruptibility, which
	may be useful when processing very large files.

    o	A new heuristic test, seemsS4Object() is supplied, along with a
	similar C-level test, R_seemsS4Object(object). The test
	detects probable S4 objects by their class's attribute. See
	the help page.

    o	S3 classes can now be made non-virtual S4 classes by supplying a
	prototype object in the arguments to setOldClass().

    o	splinefun() returns a function that now also has a 'deriv' argument
	and can provide up to the 3rd derivative of the interpolating
	spline, thanks to Berwin Turlach.

    o	stopifnot(A) now gives a better error message when A has NAs, and
	uses "not all TRUE" when A has length >= 2.

    o	str()'s default method has a new argument 'strict.width' which can
	be used to produce strict 'width' conforming output.  A new
	options(str = list(strict.width = *)) setting allows to control
	this for a whole session.

    o	summary.nls() has a new argument 'correlation' that defaults
	to FALSE (like summary.lm).

    o	Sys.sleep() has sub-millisecond resolution on Unix-alikes
	with gettimeofday().

    o	Sys.time() now has sub-millisecond accuracy on systems
	supporting the POSIX call gettimeofday, and clock-tick
	accuracy on Windows.

    o	The new function timestamp() adds a time stamp to the saved
	command history on consoles which support it.

    o	New function tcrossprod() for efficiently computing x %*% t(x)
	and x %*% t(y).

    o	The suffix used by tempfile() is now in hex on all platforms
	and guaranteed to be at least 6 hex digits (usually 8).

    o	trace() now works more consistently and more like its
	documentation, in particular the assertions about old tracing
	being removed for new.	For debugging purposes (of R) a
	mechanism for debugging the trace computations themselves was
	added.	See trace.R.

    o	The implementation of trace() has beem made more general by
	calling a function to do the trace interaction, and recover()
	now detects trace calls to trim the irrelevant code underneath.

    o	unserialize() can now also read a byte stream from a raw vector.

    o	The useDynLib() directive in the NAMESPACE file now accepts the
	names of the native/foreign symbols that are to be resolved in
	the DLL for use in .C/.Call/.Fortran/.External calls.  These
	can be used as regular R variables instead of the (routine
	name, PACKAGE) pairs currently recommended.  Alternative names
	can be given for the R variables mapping to these symbols.
	The native routine registration information can also be used
	directly via useDynLib(name, .registration = TRUE).  See the
	'Writing R Extensions' manual for more details.

	checkFF() (package 'tools') has been updated accordingly.

    o	validObject() has an option complete=TRUE that recursively
	checks the objects in the slots.  Not used when new(...)
	checks validity.

    o	New Vectorize() function, a wrapper for mapply().

    o	write.ftable() has gained an argument 'append = FALSE' (thanks to
	Stephen Weigand).

    o	On Unix-alikes, X11() now has arguments to request the initial
	position of the window, and 'gamma' defaults to the value of
	getOptions("gamma").  These changes are consistent with the
	windows() device.

    o	X11() and the Unix-alike data entry window can have properties
	(including geometry) set by X resources: see their help files.

    o	xy.coords() & xyz.coords() now have NULL defaults for their 'y' or
	'y' and 'z' arguments.	This is more consistent with their earlier
	documentation, and may be convenient for using them.


    o	Non-syntactic names of list elements are now printed quoted by
	backticks rather than double quotes.

    o	There is some basic checking for imminent C stack overflow (when
	the evaluation depth and the user interrupts are checked).
	On systems with suitable OS support (not Windows), segfaults
	from C stack overflow are caught and treated as an R error.

	New function Cstack_info() reports on stack size and usage.

	options(expressions) reverts to the default of 5000 now
	stack checking is in place.

    o	Package tcltk does not try to initialize Tk on Unix-alikes
	unless a DISPLAY variable is present.  This allows packages
	dependent on tcltk to be installed without access to an X server.

    o	The code used to guess timezone offsets where not supplied by
	the OS uses a different algorithm that is more likely to guess
	the summer-time transitions correctly.

    o	Package tools contains translation tables 'Adobe_glyphs' and
	'charset_to_Unicode'.

    o	Changed the environment tree to be rooted in an empty
	environment, available as emptyenv().  baseenv() has been
	modified to return an environment with emptyenv() as parent,
	rather than NULL.

    o	gettext has been updated to 0.14.5.

    o	PCRE has been updated to version 6.4.

    o	The method $.DLLInfo resolves the specified symbol in the DLL,
	returning a NativeSymbolInfo object.  Use [[ to access the actual
	values in the DLLInfo object.

    o	On systems with either vasprintf or both va_copy and a vsnprintf
	which reports the size of buffer required, connections such as
	gzfile() and bzfile() can now write arbitrarily long lines,
	not just 100000 chars.

    o	The R session temporary directory is now set in C code using
	the same algorithm whether or not the shell front-end is used
	and on all platforms.  This looks at environment variables
	TMPDIR, TMP and TEMP in turn, and checks if they point to a
	writable directory.

    o	Some of the classical tests put unnecessary restrictions on the
	LHS in the formula interface (e.g., t.test(x+y ~ g) was not
	allowed).

    o	On suitably equipped Unix-alike systems, segfaults, illegal
	operations and bus errors are caught and there is a simple
	error-handler which gives the user some choice as to what to
	do in interactive use.

	On Windows access violations and illegal instructions are
	caught with a simple error handler.

    o	Tracebacks now include calls such as .C/.Fortran/.Call, which
	will help if errors occur in R code evaluated by compiled code
	and in tracebacks presented by the segfault etc handlers.

    o	Treatment of signature objects and method definition objects has
	been modified to give cleaner printing and more consistency in
	the treatment of signatures.  A sometimes useful utility,
	methodSignatureMatrix(), is now exported.

    o	Printing the results of codoc() from package tools now helpfully
	summarizes the found code/documentation mismatches.

    o	R refrains from printing a final EOL upon exiting the main loop
	if the quiet flag is on and if the save action is known (e.g. this
	is true for --slave).


DEPRECATED & DEFUNCT

    o	The deprecated and undocumented use of atan() with two arguments
	has been removed: instead use atan2().

    o	write.table0() is defunct in favour of write.table().

    o	format.char() is defunct in favour of format.default().

    o	Support for the long-deprecated (and no longer documented)
	arguments --min-vsize --min-nsize --max-vsize --max-nsize
	--vsize --nsize of R CMD BATCH has been removed.

    o	The 'debian' subdirectory has been removed from the sources.

    o	The 'vfont' argument of axis() and mtext() has been removed:
	use par(family=) instead.

    o	The unused graphical parameter "type" has been removed: it
	invited confusion with the 'type' argument to default methods
	of plot(), points() and lines().

    o	nlsMethod() and profiler() are no longer exported from the stats
	name space (and nlsMethod.plinear() is no longer registered as
	a method, as nlsMethod() was not generic).

    o	The re-named tcltk functions tkcmd, tkfile.tail, tkfile.dir,
	tkopen, tkclose, tkputs, tkread are now formally deprecated.

    o	Argument 'col' of bxp() is now formally deprecated.

    o	Use of NULL as an environment is deprecated and gives a warning.

    o	postscriptFont() is deprecated in favour of Type1Font() (which
	is just a change of name).

    o	La.chol() and La.chol2inv() are deprecated (they have since R
	1.7.0 been the same as the default options of chol() and chol2inv).

    o	La.svd(method = "dgesvd") is deprecated.

    o	The use of install.R and R_PROFILE.R files in packages is
	deprecated: use the DESCRIPTION file instead to arrange to
	save an image or to load dependent packages.

	The following command-line options to INSTALL are deprecated
	(use the fields in the DESCRIPTION file instead):
	-s --save --no-save --lazy --no-lazy --lazy-data --no-lazy-data

    o	Graphical parameter 'tmag' (which is long unused) is deprecated.


INTERNATIONALIZATION

	A set of patches supplied by Ei-ji Nakama has been incorporated.

    o	New postscript encodings for CP1253, CP1257 and Greek (ISO 8859-7).

    o	Support for East Asian CID-keyed fonts in pdf() and postscript().
	Although these usually contain Latin characters no accurate
	AFMs are available and so CID-keyed fonts are intended only
	for use with CJK characters.

    o	Wide-character width functions wc[s]width are provided that
	overcome problems found with OS-supplied ones (and those
	previously used by R on Windows).  This means that
	double-width CJK characters are now supported on all
	platforms.  It seems that the width of some characters (and
	not just CJK characters) depends on which CJK locale's fonts
	are in use and also on the OS.

	Revised wide-character classification functions are
	provided for use on Windows, AIX and MacOS X to replace
	deficient OS-supplied ones.

    o	There is support for MBCS charsets in the pictex() graphics
	device, and rotated (by 90 degrees) text may work better.

    o	The \u (and \U except on Windows) notation for characters which
	is supported by the parser in all MBCS charsets is now always
	interpreted as a Unicode point, even on platforms which do not
	encode wchar_t in Unicode.  These are now a syntax error in
	single-byte locales.

    o	The default encoding for postscript() and pdf() is chosen to
	be suitable for the current locale, if that is a single-byte
	locale which is supported.  This covers European (including
	Greek) and Cyrillic languages.

	In UTF-8 locales, a suitable single-byte encoding is chosen
	for postscript() and pdf(), and text translated to it.

    o	xfig() gains an 'encoding' argument.

    o	There are some message translations into Spanish.


INSTALLATION CHANGES

    o	The encoding files for pdf()/postscript() have been moved to
	directory 'enc' in package 'grDevices'.

    o	Support for MBCS is only enabled if iconv is found and it
	supports enough conversions.  (libiconv does.)

    o	In an MBCS locale, make check now translates the graphics
	examples from Latin-1.	This ensures that they will work
	correctly in UTF-8: it is possible that in other MBCS locales
	they will now fail (rather than work completely incorrectly).

    o	There is a new test, 'test-Docs', which as part of 'make
	check-devel' tests the code in the documentation.  Currently
	it runs doc/manual/R-{exts,intro}.R and the compiled code in
	R-exts.c.

    o	The workaround to allow an external LAPACK-containing BLAS
	such as libsunperf to be used with the internal LAPACK has
	been removed.  If you have such a library you may now need
	to use --with-lapack.  It is no longer possible to use some
	older versions of libsunperf, e.g. Forte 7 on 64-bit builds.

    o	A substitute for mkdtemp is provided, so it is now always
	used for R_TempDir.

    o	Most of the functions checked for by 'configure' also have
	declarations checked for in the appropriate header.

    o	The top-level documentation files AUTHORS COPYING.LIB COPYRIGHTS
	FAQ RESOURCES THANKS have been moved to doc, and COPYING and NEWS
	are installed there.  The file Y2K has been removed from the
	distribution.

    o	The extension .lo is no longer used in building R (only in
	the optional build of libRmath.so): this allows a considerable
	simplification of the Makefiles.

    o	Direct support for f2c has been removed: it can still be used
	via a script which makes it look like a Fortran compiler.
	(src/scripts/f77_f2c is an example of such a script.)

    o	There is a new flag SAFE_FFLAGS which is used for the
	compilation of dlamc.f.	 It is set by configure for known
	problem cases (recent g77 and gfortran), but can be overridden
	by the user.

    o	The standard autoconf macros for large-file support are now used,
	and these are enabled unless --disable-largefile is specified.
	This replaces --enable-linux-lfs (and is now selected by default).

    o	Visibility attributes are used where supported (gcc4/gfortran on
	some platforms, also gcc3/g77 on FC3 and partially elsewhere).
	The main benefit should be faster loading (and perhaps better
	optimized code) in some of the dynamic shared objects (e.g.
	libR.so and stats.so).

    o	The *PICFLAGS are taken to be -fpic rather than -fPIC where
	possible.   This will make no difference on most platforms:
	-fPIC is needed on Sparc (and still used there), but -fpic
	should give slightly better performance on PowerPC (although
	-fPIC is used on PPC64 as it is needed to build libR.so there).

    o	More use is made of inlining for small utility functions such
	as isReal.  Because this can only be done portably with C99
	constructs (and we know of no actual implementation), this is
	only done for the GNU C compiler.

    o	There is an experimental feature to allow shared installations
	of sub-architectures.  See the R-admin manual.

    o	All platforms now use R's internal implementation of strptime,
	which allows fractional seconds.  (The major platforms were
	already using it.)

    o	The dlcompat work-around for old Mac OS X systems (<= 10.2)
	has been removed.  External dlcompat must be installed if needed.


UTILITIES

    o	R CMD check now uses an install log by default.

    o	R CMD check works for packages whose package name is different
	from the directory name in which it is located.

    o	R CMD INSTALL now uses more randomness in the temporary
	directory name even on systems without mktemp -d.

    o	R CMD f77 has been removed now f2c is no longer supported.

    o	The version string shown in the startup message and by
	"R --version", and that stored in variable R.version.string
	are now in exactly the same format.

    o	The base name of a help file needs to be valid as part of a file://
	URL, so R CMD check now checks the names are ASCII and do not
	contain % .

    o	R CMD check now warns about unknown sections in Rd files, and
	invalid names for help, demo and R files, as well as unlikely
	file names in the 'src' directory.  The latter is controlled
	by option --check-subdirs and by default is done if checking a
	tarball without a configure script.

	R CMD build excludes invalid files in the 'man', 'R' and 'demo'
	subdirectories.

    o	\usepackage[noae]{Sweave} in the header of an Sweave file
	supresses auto-usage of the ae package ("almost European"
	fonts) and T1 input encoding.


DOCUMENTATION

    o	Rd format now allows \var{} markup inside \code{} and \examples{}.

    o	Markup such as --, ---, < and > is handled better when
	converting .Rd files to [C]HTML.

    o	There is new markup \link[=dest]{name} to generate a link to topic
	'dest' which is shown as 'name', and \linkS4class{abc} which
	expands to \link[=abc-class]{abc}, for cross-referencing the
	recommended form of documentation for S4 classes.


PACKAGE INSTALLATION

    o	There is now some support for Fortran 90/95 code in packages:
	see `Writing R Extensions'.

    o	Installation of man sources and demos is now done by R code.
	The restrictions on the names of help files, R files and
	of demos are now enforced (see `Writing R Extensions').

    o	Packages which contain compiled code can now have more than
	one dot in their name even on Windows.

    o	The Meta/hsearch.rds database saved now contains LibPath="".
	This information is now always recreated when help.search() is
	run, but the field is retained for back-compatibility.

    o	update.packages() now has a '...' argument to be passed to
	install.packages(), including the formerly separate arguments
	'destdir' and 'installWithVers'.

    o	Make macros AR and RANLIB are now declared in etc/Makeconf for
	use by packages which wish to make static libraries.


C-LEVEL FACILITIES

    o	qgamma and rgamma in Rmath.h now check for non-positive arguments.

    o	The BLAS which ships with R now contains the complete set of
	double-complex BLAS routines, rather than just those used in R.

	<R_ext/BLAS.h> has been corrected to add the missing
	double-precision BLAS functions drotmg and drotm, and to
	exclude lsame (which is a Lapack auxiliary function and is now
	declared in <R_ext/Lapack.h>).	It also includes the double
	complex routines added for this release of R provided Fortran
	doublecomplex is usable on the platform.

    o	<R_ext/BLAS.h> and <R_ext/Lapack.h> now declare all the entry
	points as 'extern'.

    o	The flag SAFE_FFLAGS is made available to packages via
	etc/Makeconf and R CMD config.	It can be used where
	optimization needs to be defeated, e.g. in LAPACK setup.

    o	getNativeSymbolInfo has a withRegistrationInfo argument which
	causes the address field to be a reference to the registration
	information if it is available for that symbol.	 If the
	registration information is not available, the address is a
	reference to the native symbol. The default is FALSE which is
	backward compatible, returning just the address of the symbol
	and ignoring registration information.

    o	errorcall and warningcall are now declared in <Rinternals.h>
	(they might be needed in front-ends).

    o	R_FlushConsole and R_ProcessEvents are now declared in <R.h>.

    o	The R_Sock* functions supporting socket connections are no
	longer declared in R-ftp-http.h as they are not loaded into R
	itself, and are now hidden in the module's DLL on suitable systems.


BUG FIXES

    o	Quoted arguments to the R script after --args are now
	passed quoted to the R executable and so will be shown as
	expected by commandArgs().  (They were previously split at
	whitespace even inside quotes on Unix-alikes but not on
	Windows.)

    o	axis() now supports pars 'xaxp'/'yaxp' as inline arguments.

    o	sort() now does not return inappropriate attributes such as
	"dim" and "tsp": it only returns names.

	sort(x, partial=) no longer returns unsorted names, and drops
	names (since it is supplied for efficiency).

    o	Use of non-central F in pf() gives accurate values for larger ncp.

    o	R CMD build --binary does a better job of cleaning up after
	failure to re-make vignettes.

    o	reg-test-1.R tested system(intern=TRUE) which depends on popen
	and so is not supported on all platforms.

    o	Changed apparent mis-spelling of "Gibraltar" in dataset 'eurodist'.

    o	sysconf() is now used to find the number of clock ticks/second:
	under some circumstances glibc reported CLK_TCK = 60 when the
	true value was 100.

    o	identical() was not allowing for embedded nuls in character
	strings. (NB: the comparison operators including == do not,
	and never will.)

    o	The profile() and profiler() methods for "nls" objects now
	support algorithm = "plinear" and algorithm = "port".

    o	The signal handlers for signals USR1 and USR2 where not
	restored if the signal arrived when interrupts were suspended.

    o	Certain combinations of S4 inheritance could cause inherited
	methods to override some directly specified methods.

    o	Some cases of named signatures in calls to setMethod() caused errors.

    o	all.equal() is now more consistent and "picky" about mismatching
	attributes, in particular names(); this is a part of the
	propositions by Andy Piskorkski (PR#8191).

    o	load() when applied to a connection leaves it open/not as it
	found it, and checks explicitly for having a binary readable
	connection.

    o	The p-values given by stat.anova() (called from several
	anova() methods) are now NA (rather than spurious) if
	non-nested models give rise to changes in deviance with a
	different sign from changes in degrees of freedom.

    o	Built-ins were reported as the relevant call in C-level error()s
	iff R profiling was in progress.  Now they are never reported.

    o	Too-long signatures (with no names) were not being caught
	in setMethod().

    o	Slot names in prototype() are being more thoroughly checked.

    o	signif() is more likely to follow the 'round to even' rule for
	exactly representable numbers, e.g. signif(0.25, 1).  (Related
	to PR#8452.)

    o	nls() now works correctly with some low-dimensional fits,
	e.g. with one or zero non-linear parameters.

    o	glm() could give an inappropriate error message if all
	possible coefficients were invalid (e.g. a log-linear binomial
	model with no intercept and a not all positive predictor).

    o	solve() gives clearer error messages for some incorrect usages.
	(PR#8494 and similar)

    o	The gaussian() family was missing the 'valideta' component
	(which could be needed for the "inverse" link function).

	The starting values supplied by the gaussian family could be
	invalid for the "log" and "inverse" link functions.  This is
	now reported.

    o	data.matrix() did not work correctly on zero-row data frames.
	(PR#8496 and other problems.)

    o	The DSC comments in the files from postscript(onefile=FALSE) now
	label all files as having page 1 of 1, as some other software
	seems to expect that.

    o	The axis labels chosen for logarithmic axis are now less
	likely to be linear and inappropriate (when the range is more
	than 10 and less than 100).  (PR#1235)

    o	Staircase lines (types "s" and "S") are now drawn
	continuously rather than a point at a time and so line types,
	mitring and so on work. (PR#2630)

    o	Calling par(mfg) before doing any plotting resulted in NewPage
	never being called on the device, which in turn resulted in
	incorrect output for postcript() and pdf() devices.  (Reported
	by Marc Schwartz in discussion of the non-bug PR#7820.)

    o	terms.formula needed to add parentheses to formulae with
	terms containing '|'.  (PR#8462)

    o	pbirthday() and qbirthday() now also work for very improbable
	events {those you are typically *not* interested in}.

    o	Only source help files starting with an upper- or lower-case
	letter or digit and extension .Rd or .rd are documented to be
	processed.  This is more liberal in that starting with a digit
	is now also allowed, but rule is now enforced.

    o	nls(algorthm="port") was always taking positive numeric
	differences and so could exceed the upper bounds.

    o	methods:::.asEnvironmentPackage() was not allowing for
	versioned installs.

    o	.find.package() now reports which package(s) it cannot find in
	the case it stops with an error.

    o	The standard Unix-alike version of file.show() gives an
	informative message if it cannot open a file rather than the
	(possibly incorrect) 'NO FILE'.

    o	window() did not allow non-overlapping ranges with
	extend = TRUE.	(PR#8545)

    o	pbinom(size = 0) now returns correct values (not NaN).	(PR#8560)

    o	[dp]binom(x, *) for x < 0 now always returns 0. (PR#8700)
	analogous change in pgeom(), pnbinom() and ppois().

    o	[dqpr]geom and [dpqr]nbinom() now all consistently accept prob = 1
	but not prob = 0.  qgeom(prob=1) now gives the correct values
	(not -1).

    o	INSTALL on Unix-alikes was not loading dependent packages when
	preparing for lazy-loading.

    o	qcauchy(1) now gives +Inf instead of just a very large number.

    o	df(0, f1, *) now properly returns Inf, 1, or 0 for f1 < , = , or > 2.

    o	qbinom(), qnbinom() and qpois() now use a better search and
	normally reach the answer very quickly when it is large
	(instead of being slow or infinite-looping).

    o	pt(x, df) lost accuracy in the far tails (when |x| > 1e154) for
	small df (like df = 0.001 for which such extremes are not unlikely).

    o	dbeta(x, a, b) underflowed internally and incorrectly gave 0
	for very small x and a.

    o	None of the warnings about convergence failures or loss of
	precision in nmath (distribution and special functions) were
	being reported to the R user.

    o	dnt was missing from standalone nmath (under Unix-alikes).

    o	split() now accepts factors with numeric (but not storage mode
	integer) codes.

    o	The utilities such as 'check' now report active version numbers
	again, as SVN 'last changed revision' numbers.

    o	addmargins() did not accept a name for 'FUN', only an expression.

    o	'+' for POSIXt objects now takes the tzone from whichever
	object has it, so date+x is the same as x+date if x is numeric.

    o	mean.default() and var() compute means with an additional pass
	and so are often more accurate, e.g. the variance of a
	constant vector is (almost) always zero and the mean of such a
	vector will be equal to the constant value to machine
	precision.  (PR#1228)

	sum(), prod(), mean(), rowSums() and friends use a long double
